import{S as $r,i as wr,s as Pr,e as n,k as p,w,t as s,M as xr,c as i,d as o,m as f,a as r,x as P,h as a,b as c,G as e,g as $,y as x,q as D,o as k,B as E,v as Dr,L as Ii}from"../../chunks/vendor-hf-doc-builder.js";import{T as wo}from"../../chunks/Tip-hf-doc-builder.js";import{D as C}from"../../chunks/Docstring-hf-doc-builder.js";import{C as Ai}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as Po}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Ei}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function kr(O){let d;return{c(){d=s("One should not use the Diffusion Pipeline class for training or fine-tuning a diffusion model. Individual \n	components of diffusion pipelines are usually trained individually, so we suggest to directly work \n	with `UNetModel` and `UNetConditionModel`.")},l(v){d=a(v,"One should not use the Diffusion Pipeline class for training or fine-tuning a diffusion model. Individual \n	components of diffusion pipelines are usually trained individually, so we suggest to directly work \n	with `UNetModel` and `UNetConditionModel`.")},m(v,m){$(v,d,m)},d(v){v&&o(d)}}}function Er(O){let d,v,m,u,y;return u=new Ai({props:{code:`from diffusers import (
    StableDiffusionPipeline,
    StableDiffusionImg2ImgPipeline,
    StableDiffusionInpaintPipeline,
)

text2img = StableDiffusionPipeline.from_pretrained("runwayml/stable-diffusion-v1-5")
img2img = StableDiffusionImg2ImgPipeline(**text2img.components)
inpaint = StableDiffusionInpaintPipeline(**text2img.components)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> (
<span class="hljs-meta">... </span>    StableDiffusionPipeline,
<span class="hljs-meta">... </span>    StableDiffusionImg2ImgPipeline,
<span class="hljs-meta">... </span>    StableDiffusionInpaintPipeline,
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>text2img = StableDiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>img2img = StableDiffusionImg2ImgPipeline(**text2img.components)
<span class="hljs-meta">&gt;&gt;&gt; </span>inpaint = StableDiffusionInpaintPipeline(**text2img.components)`}}),{c(){d=n("p"),v=s("Examples:"),m=p(),w(u.$$.fragment)},l(l){d=i(l,"P",{});var _=r(d);v=a(_,"Examples:"),_.forEach(o),m=f(l),P(u.$$.fragment,l)},m(l,_){$(l,d,_),e(d,v),$(l,m,_),x(u,l,_),y=!0},p:Ii,i(l){y||(D(u.$$.fragment,l),y=!0)},o(l){k(u.$$.fragment,l),y=!1},d(l){l&&o(d),l&&o(m),E(u,l)}}}function Ir(O){let d,v,m,u,y,l,_;return{c(){d=n("p"),v=s("It is required to be logged in ("),m=n("code"),u=s("huggingface-cli login"),y=s(") when you want to use private or "),l=n("a"),_=s(`gated
models`),this.h()},l(A){d=i(A,"P",{});var T=r(d);v=a(T,"It is required to be logged in ("),m=i(T,"CODE",{});var V=r(m);u=a(V,"huggingface-cli login"),V.forEach(o),y=a(T,") when you want to use private or "),l=i(T,"A",{href:!0,rel:!0});var L=r(l);_=a(L,`gated
models`),L.forEach(o),T.forEach(o),this.h()},h(){c(l,"href","https://huggingface.co/docs/hub/models-gated#gated-models"),c(l,"rel","nofollow")},m(A,T){$(A,d,T),e(d,v),e(d,m),e(m,u),e(d,y),e(d,l),e(l,_)},d(A){A&&o(d)}}}function Ar(O){let d,v,m,u,y;return u=new Ai({props:{code:`import torch
from diffusers import DiffusionPipeline
from xformers.ops import MemoryEfficientAttentionFlashAttentionOp

pipe = DiffusionPipeline.from_pretrained("stabilityai/stable-diffusion-2-1", torch_dtype=torch.float16)
pipe = pipe.to("cuda")
pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
# Workaround for not accepting attention shape using VAE for Flash Attention
pipe.vae.enable_xformers_memory_efficient_attention(attention_op=None)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> xformers.ops <span class="hljs-keyword">import</span> MemoryEfficientAttentionFlashAttentionOp

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;stabilityai/stable-diffusion-2-1&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Workaround for not accepting attention shape using VAE for Flash Attention</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.vae.enable_xformers_memory_efficient_attention(attention_op=<span class="hljs-literal">None</span>)`}}),{c(){d=n("p"),v=s("Examples:"),m=p(),w(u.$$.fragment)},l(l){d=i(l,"P",{});var _=r(d);v=a(_,"Examples:"),_.forEach(o),m=f(l),P(u.$$.fragment,l)},m(l,_){$(l,d,_),e(d,v),$(l,m,_),x(u,l,_),y=!0},p:Ii,i(l){y||(D(u.$$.fragment,l),y=!0)},o(l){k(u.$$.fragment,l),y=!1},d(l){l&&o(d),l&&o(m),E(u,l)}}}function jr(O){let d,v,m,u,y,l,_,A,T,V,L,G,W;return{c(){d=n("p"),v=s("It is required to be logged in ("),m=n("code"),u=s("huggingface-cli login"),y=s(") when you want to use private or "),l=n("a"),_=s(`gated
models`),A=s(", "),T=n("em"),V=s("e.g."),L=p(),G=n("code"),W=s('"runwayml/stable-diffusion-v1-5"'),this.h()},l(Y){d=i(Y,"P",{});var q=r(d);v=a(q,"It is required to be logged in ("),m=i(q,"CODE",{});var M=r(m);u=a(M,"huggingface-cli login"),M.forEach(o),y=a(q,") when you want to use private or "),l=i(q,"A",{href:!0,rel:!0});var Ge=r(l);_=a(Ge,`gated
models`),Ge.forEach(o),A=a(q,", "),T=i(q,"EM",{});var Ye=r(T);V=a(Ye,"e.g."),Ye.forEach(o),L=f(q),G=i(q,"CODE",{});var be=r(G);W=a(be,'"runwayml/stable-diffusion-v1-5"'),be.forEach(o),q.forEach(o),this.h()},h(){c(l,"href","https://huggingface.co/docs/hub/models-gated#gated-models"),c(l,"rel","nofollow")},m(Y,q){$(Y,d,q),e(d,v),e(d,m),e(m,u),e(d,y),e(d,l),e(l,_),e(d,A),e(d,T),e(T,V),e(d,L),e(d,G),e(G,W)},d(Y){Y&&o(d)}}}function Tr(O){let d,v,m,u,y;return{c(){d=n("p"),v=s("Activate the special "),m=n("a"),u=s("\u201Coffline-mode\u201D"),y=s(` to use
this method in a firewalled environment.`),this.h()},l(l){d=i(l,"P",{});var _=r(d);v=a(_,"Activate the special "),m=i(_,"A",{href:!0,rel:!0});var A=r(m);u=a(A,"\u201Coffline-mode\u201D"),A.forEach(o),y=a(_,` to use
this method in a firewalled environment.`),_.forEach(o),this.h()},h(){c(m,"href","https://huggingface.co/diffusers/installation.html#offline-mode"),c(m,"rel","nofollow")},m(l,_){$(l,d,_),e(d,v),e(d,m),e(m,u),e(d,y)},d(l){l&&o(d)}}}function Lr(O){let d,v,m,u,y;return u=new Ai({props:{code:`from diffusers import DiffusionPipeline

# Download pipeline from huggingface.co and cache.
pipeline = DiffusionPipeline.from_pretrained("CompVis/ldm-text2im-large-256")

# Download pipeline that requires an authorization token
# For more information on access tokens, please refer to this section
# of the documentation](https://huggingface.co/docs/hub/security-tokens)
pipeline = DiffusionPipeline.from_pretrained("runwayml/stable-diffusion-v1-5")

# Use a different scheduler
from diffusers import LMSDiscreteScheduler

scheduler = LMSDiscreteScheduler.from_config(pipeline.scheduler.config)
pipeline.scheduler = scheduler`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Download pipeline from huggingface.co and cache.</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;CompVis/ldm-text2im-large-256&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Download pipeline that requires an authorization token</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># For more information on access tokens, please refer to this section</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># of the documentation](https://huggingface.co/docs/hub/security-tokens)</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Use a different scheduler</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> LMSDiscreteScheduler

<span class="hljs-meta">&gt;&gt;&gt; </span>scheduler = LMSDiscreteScheduler.from_config(pipeline.scheduler.config)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline.scheduler = scheduler`}}),{c(){d=n("p"),v=s("Examples:"),m=p(),w(u.$$.fragment)},l(l){d=i(l,"P",{});var _=r(d);v=a(_,"Examples:"),_.forEach(o),m=f(l),P(u.$$.fragment,l)},m(l,_){$(l,d,_),e(d,v),$(l,m,_),x(u,l,_),y=!0},p:Ii,i(l){y||(D(u.$$.fragment,l),y=!0)},o(l){k(u.$$.fragment,l),y=!1},d(l){l&&o(d),l&&o(m),E(u,l)}}}function Or(O){let d,v,m,u,y,l,_,A,T,V,L,G,W,Y,q,M,Ge,Ye,be,ee,Yt,j,xo,Be,Do,ko,rt,Eo,Io,Re,Ao,jo,st,To,Lo,at,Oo,So,lt,qo,Co,Bt,te,No,Je,zo,Vo,Rt,B,oe,dt,ve,Wo,pt,Mo,Jt,h,ye,Fo,ft,Xo,Ho,Ke,Qe,Uo,Go,Yo,$e,ct,Bo,Ro,mt,Jo,Ko,ut,Qo,Zo,we,ne,ht,en,tn,gt,on,nn,rn,ie,_t,sn,an,bt,ln,dn,pn,re,Pe,fn,vt,cn,mn,Ze,xe,un,et,De,hn,F,ke,gn,Ee,_n,yt,bn,vn,yn,se,$n,ae,Ie,wn,Ae,Pn,$t,xn,Dn,kn,le,je,En,wt,In,An,X,Te,jn,Pt,Tn,Ln,de,On,H,Le,Sn,xt,qn,Cn,Dt,Nn,zn,N,Oe,Vn,kt,Wn,Mn,Et,Fn,Xn,It,Hn,Un,pe,Gn,I,Se,Yn,At,Bn,Rn,qe,Jn,jt,Kn,Qn,Zn,Ce,ei,Tt,ti,oi,ni,Ne,ii,Lt,ri,si,ai,fe,li,ce,di,me,pi,ue,ze,fi,Ot,ci,mi,he,Ve,ui,We,hi,tt,gi,_i,Kt,R,ge,St,Me,bi,qt,vi,Qt,J,Fe,yi,Ct,$i,Zt,K,_e,Nt,Xe,wi,zt,Pi,eo,Q,He,xi,Vt,Di,to;return l=new Po({}),ee=new wo({props:{$$slots:{default:[kr]},$$scope:{ctx:O}}}),ve=new Po({}),ye=new C({props:{name:"class diffusers.DiffusionPipeline",anchor:"diffusers.DiffusionPipeline",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/pipeline_utils.py#L453"}}),Pe=new C({props:{name:"__call__",anchor:"diffusers.DiffusionPipeline.__call__",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}]}}),xe=new C({props:{name:"device",anchor:"diffusers.DiffusionPipeline.device",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/pipeline_utils.py#L687",returnDescription:`
<p>The torch device on which the pipeline is located.</p>
`,returnType:`
<p><code>torch.device</code></p>
`}}),De=new C({props:{name:"to",anchor:"diffusers.DiffusionPipeline.to",parameters:[{name:"torch_device",val:": typing.Union[str, torch.device, NoneType] = None"},{name:"torch_dtype",val:": typing.Optional[torch.dtype] = None"},{name:"silence_dtype_warnings",val:": bool = False"}],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/pipeline_utils.py#L612"}}),ke=new C({props:{name:"components",anchor:"diffusers.DiffusionPipeline.components",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/pipeline_utils.py#L1356",returnDescription:`
<p>A dictionary containing all the modules needed to initialize the pipeline.</p>
`}}),se=new Ei({props:{anchor:"diffusers.DiffusionPipeline.components.example",$$slots:{default:[Er]},$$scope:{ctx:O}}}),Ie=new C({props:{name:"disable_attention_slicing",anchor:"diffusers.DiffusionPipeline.disable_attention_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/pipeline_utils.py#L1492"}}),je=new C({props:{name:"disable_xformers_memory_efficient_attention",anchor:"diffusers.DiffusionPipeline.disable_xformers_memory_efficient_attention",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/pipeline_utils.py#L1450"}}),Te=new C({props:{name:"download",anchor:"diffusers.DiffusionPipeline.download",parameters:[{name:"pretrained_model_name",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.DiffusionPipeline.download.pretrained_model_name",description:`<strong>pretrained_model_name</strong> (<code>str</code> or <code>os.PathLike</code>, <em>optional</em>) &#x2014;
Should be a string, the <em>repo id</em> of a pretrained pipeline hosted inside a model repo on
<a href="https://huggingface.co/" rel="nofollow">https://huggingface.co/</a> Valid repo ids have to be located under a user or organization name, like
<code>CompVis/ldm-text2im-large-256</code>.`,name:"pretrained_model_name"},{anchor:"diffusers.DiffusionPipeline.download.custom_pipeline",description:`<strong>custom_pipeline</strong> (<code>str</code>, <em>optional</em>) &#x2014;</p>
<div class="course-tip course-tip-orange bg-gradient-to-br dark:bg-gradient-to-r before:border-orange-500 dark:before:border-orange-800 from-orange-50 dark:from-gray-900 to-white dark:to-gray-950 border border-orange-50 text-orange-700 dark:text-gray-400">
						
<p>This is an experimental feature and is likely to change in the future.</p>

					</div>
<p>Can be either:</p>
<ul>
<li>
<p>A string, the <em>repo id</em> of a custom pipeline hosted inside a model repo on
<a href="https://huggingface.co/" rel="nofollow">https://huggingface.co/</a>. Valid repo ids have to be located under a user or organization name,
like <code>hf-internal-testing/diffusers-dummy-pipeline</code>.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>It is required that the model repo has a file, called <code>pipeline.py</code> that defines the custom
pipeline.</p>

					</div>
</li>
<li>
<p>A string, the <em>file name</em> of a community pipeline hosted on GitHub under
<a href="https://github.com/huggingface/diffusers/tree/main/examples/community" rel="nofollow">https://github.com/huggingface/diffusers/tree/main/examples/community</a>. Valid file names have to
match exactly the file name without <code>.py</code> located under the above link, <em>e.g.</em>
<code>clip_guided_stable_diffusion</code>.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>Community pipelines are always loaded from the current <code>main</code> branch of GitHub.</p>

					</div>
</li>
<li>
<p>A path to a <em>directory</em> containing a custom pipeline, e.g., <code>./my_pipeline_directory/</code>.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>It is required that the directory has a file, called <code>pipeline.py</code> that defines the custom
pipeline.</p>

					</div>
</li>
</ul>
<p>For more information on how to load and create custom pipelines, please have a look at <a href="https://huggingface.co/docs/diffusers/using-diffusers/custom_pipeline_overview" rel="nofollow">Loading and
Adding Custom
Pipelines</a>`,name:"custom_pipeline"},{anchor:"diffusers.DiffusionPipeline.download.force_download",description:`<strong>force_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to force the (re-)download of the model weights and configuration files, overriding the
cached versions if they exist.`,name:"force_download"},{anchor:"diffusers.DiffusionPipeline.download.resume_download",description:`<strong>resume_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to delete incompletely received files. Will attempt to resume the download if such a
file exists.`,name:"resume_download"},{anchor:"diffusers.DiffusionPipeline.download.proxies",description:`<strong>proxies</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A dictionary of proxy servers to use by protocol or endpoint, e.g., <code>{&apos;http&apos;: &apos;foo.bar:3128&apos;, &apos;http://hostname&apos;: &apos;foo.bar:4012&apos;}</code>. The proxies are used on each request.`,name:"proxies"},{anchor:"diffusers.DiffusionPipeline.download.output_loading_info(bool,",description:`<strong>output_loading_info(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to also return a dictionary containing missing keys, unexpected keys and error messages.`,name:"output_loading_info(bool,"},{anchor:"diffusers.DiffusionPipeline.download.local_files_only(bool,",description:`<strong>local_files_only(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to only look at local files (i.e., do not try to download the model).`,name:"local_files_only(bool,"},{anchor:"diffusers.DiffusionPipeline.download.use_auth_token",description:`<strong>use_auth_token</strong> (<code>str</code> or <em>bool</em>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If <code>True</code>, will use the token generated
when running <code>huggingface-cli login</code> (stored in <code>~/.huggingface</code>).`,name:"use_auth_token"},{anchor:"diffusers.DiffusionPipeline.download.revision",description:`<strong>revision</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;main&quot;</code>) &#x2014;
The specific model version to use. It can be a branch name, a tag name, or a commit id, since we use a
git-based system for storing models and other artifacts on huggingface.co, so <code>revision</code> can be any
identifier allowed by git.`,name:"revision"},{anchor:"diffusers.DiffusionPipeline.download.custom_revision",description:"<strong>custom_revision</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;main&quot;</code> when loading from the Hub and to local version of &#x2014;",name:"custom_revision"},{anchor:"diffusers.DiffusionPipeline.download.diffusers",description:`<strong><code>diffusers</code></strong> when loading from GitHub) &#x2014;
The specific model version to use. It can be a branch name, a tag name, or a commit id similar to
<code>revision</code> when loading a custom pipeline from the Hub. It can be a diffusers version when loading a
custom pipeline from GitHub.`,name:"diffusers"},{anchor:"diffusers.DiffusionPipeline.download.mirror",description:`<strong>mirror</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Mirror source to accelerate downloads in China. If you are from China and have an accessibility
problem, you can set this option to resolve it. Note that we do not guarantee the timeliness or safety.
Please refer to the mirror site for more information. specify the folder name here.`,name:"mirror"},{anchor:"diffusers.DiffusionPipeline.download.variant",description:`<strong>variant</strong> (<code>str</code>, <em>optional</em>) &#x2014;
If specified load weights from <code>variant</code> filename, <em>e.g.</em> pytorch_model.<variant>.bin. <code>variant</code> is
ignored when using <code>from_flax</code>.</variant>`,name:"variant"}],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/pipeline_utils.py#L1084"}}),de=new wo({props:{$$slots:{default:[Ir]},$$scope:{ctx:O}}}),Le=new C({props:{name:"enable_attention_slicing",anchor:"diffusers.DiffusionPipeline.enable_attention_slicing",parameters:[{name:"slice_size",val:": typing.Union[str, int, NoneType] = 'auto'"}],parametersDescription:[{anchor:"diffusers.DiffusionPipeline.enable_attention_slicing.slice_size",description:`<strong>slice_size</strong> (<code>str</code> or <code>int</code>, <em>optional</em>, defaults to <code>&quot;auto&quot;</code>) &#x2014;
When <code>&quot;auto&quot;</code>, halves the input to the attention heads, so attention will be computed in two steps. If
<code>&quot;max&quot;</code>, maximum amount of memory will be saved by running only one slice at a time. If a number is
provided, uses as many slices as <code>attention_head_dim // slice_size</code>. In this case, <code>attention_head_dim</code>
must be a multiple of <code>slice_size</code>.`,name:"slice_size"}],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/pipeline_utils.py#L1476"}}),Oe=new C({props:{name:"enable_xformers_memory_efficient_attention",anchor:"diffusers.DiffusionPipeline.enable_xformers_memory_efficient_attention",parameters:[{name:"attention_op",val:": typing.Optional[typing.Callable] = None"}],parametersDescription:[{anchor:"diffusers.DiffusionPipeline.enable_xformers_memory_efficient_attention.attention_op",description:`<strong>attention_op</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
Override the default <code>None</code> operator for use as <code>op</code> argument to the
<a href="https://facebookresearch.github.io/xformers/components/ops.html#xformers.ops.memory_efficient_attention" rel="nofollow"><code>memory_efficient_attention()</code></a>
function of xFormers.`,name:"attention_op"}],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/pipeline_utils.py#L1418"}}),pe=new Ei({props:{anchor:"diffusers.DiffusionPipeline.enable_xformers_memory_efficient_attention.example",$$slots:{default:[Ar]},$$scope:{ctx:O}}}),Se=new C({props:{name:"from_pretrained",anchor:"diffusers.DiffusionPipeline.from_pretrained",parameters:[{name:"pretrained_model_name_or_path",val:": typing.Union[str, os.PathLike, NoneType]"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.DiffusionPipeline.from_pretrained.pretrained_model_name_or_path",description:`<strong>pretrained_model_name_or_path</strong> (<code>str</code> or <code>os.PathLike</code>, <em>optional</em>) &#x2014;
Can be either:</p>
<ul>
<li>A string, the <em>repo id</em> of a pretrained pipeline hosted inside a model repo on
<a href="https://huggingface.co/" rel="nofollow">https://huggingface.co/</a> Valid repo ids have to be located under a user or organization name, like
<code>CompVis/ldm-text2im-large-256</code>.</li>
<li>A path to a <em>directory</em> containing pipeline weights saved using
<a href="/docs/diffusers/pr_185/en/api/diffusion_pipeline#diffusers.DiffusionPipeline.save_pretrained">save_pretrained()</a>, e.g., <code>./my_pipeline_directory/</code>.</li>
</ul>`,name:"pretrained_model_name_or_path"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.torch_dtype",description:`<strong>torch_dtype</strong> (<code>str</code> or <code>torch.dtype</code>, <em>optional</em>) &#x2014;
Override the default <code>torch.dtype</code> and load the model under this dtype. If <code>&quot;auto&quot;</code> is passed the dtype
will be automatically derived from the model&#x2019;s weights.`,name:"torch_dtype"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.custom_pipeline",description:`<strong>custom_pipeline</strong> (<code>str</code>, <em>optional</em>) &#x2014;</p>
<div class="course-tip course-tip-orange bg-gradient-to-br dark:bg-gradient-to-r before:border-orange-500 dark:before:border-orange-800 from-orange-50 dark:from-gray-900 to-white dark:to-gray-950 border border-orange-50 text-orange-700 dark:text-gray-400">
						
<p>This is an experimental feature and is likely to change in the future.</p>

					</div>
<p>Can be either:</p>
<ul>
<li>
<p>A string, the <em>repo id</em> of a custom pipeline hosted inside a model repo on
<a href="https://huggingface.co/" rel="nofollow">https://huggingface.co/</a>. Valid repo ids have to be located under a user or organization name,
like <code>hf-internal-testing/diffusers-dummy-pipeline</code>.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>It is required that the model repo has a file, called <code>pipeline.py</code> that defines the custom
pipeline.</p>

					</div>
</li>
<li>
<p>A string, the <em>file name</em> of a community pipeline hosted on GitHub under
<a href="https://github.com/huggingface/diffusers/tree/main/examples/community" rel="nofollow">https://github.com/huggingface/diffusers/tree/main/examples/community</a>. Valid file names have to
match exactly the file name without <code>.py</code> located under the above link, <em>e.g.</em>
<code>clip_guided_stable_diffusion</code>.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>Community pipelines are always loaded from the current <code>main</code> branch of GitHub.</p>

					</div>
</li>
<li>
<p>A path to a <em>directory</em> containing a custom pipeline, e.g., <code>./my_pipeline_directory/</code>.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>It is required that the directory has a file, called <code>pipeline.py</code> that defines the custom
pipeline.</p>

					</div>
</li>
</ul>
<p>For more information on how to load and create custom pipelines, please have a look at <a href="https://huggingface.co/docs/diffusers/using-diffusers/custom_pipeline_overview" rel="nofollow">Loading and
Adding Custom
Pipelines</a>`,name:"custom_pipeline"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.force_download",description:`<strong>force_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to force the (re-)download of the model weights and configuration files, overriding the
cached versions if they exist.`,name:"force_download"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.cache_dir",description:`<strong>cache_dir</strong> (<code>Union[str, os.PathLike]</code>, <em>optional</em>) &#x2014;
Path to a directory in which a downloaded pretrained model configuration should be cached if the
standard cache should not be used.`,name:"cache_dir"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.resume_download",description:`<strong>resume_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to delete incompletely received files. Will attempt to resume the download if such a
file exists.`,name:"resume_download"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.proxies",description:`<strong>proxies</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A dictionary of proxy servers to use by protocol or endpoint, e.g., <code>{&apos;http&apos;: &apos;foo.bar:3128&apos;, &apos;http://hostname&apos;: &apos;foo.bar:4012&apos;}</code>. The proxies are used on each request.`,name:"proxies"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.output_loading_info(bool,",description:`<strong>output_loading_info(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to also return a dictionary containing missing keys, unexpected keys and error messages.`,name:"output_loading_info(bool,"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.local_files_only(bool,",description:`<strong>local_files_only(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to only look at local files (i.e., do not try to download the model).`,name:"local_files_only(bool,"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.use_auth_token",description:`<strong>use_auth_token</strong> (<code>str</code> or <em>bool</em>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If <code>True</code>, will use the token generated
when running <code>huggingface-cli login</code> (stored in <code>~/.huggingface</code>).`,name:"use_auth_token"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.revision",description:`<strong>revision</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;main&quot;</code>) &#x2014;
The specific model version to use. It can be a branch name, a tag name, or a commit id, since we use a
git-based system for storing models and other artifacts on huggingface.co, so <code>revision</code> can be any
identifier allowed by git.`,name:"revision"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.custom_revision",description:`<strong>custom_revision</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;main&quot;</code> when loading from the Hub and to local version of <code>diffusers</code> when loading from GitHub) &#x2014;
The specific model version to use. It can be a branch name, a tag name, or a commit id similar to
<code>revision</code> when loading a custom pipeline from the Hub. It can be a diffusers version when loading a
custom pipeline from GitHub.`,name:"custom_revision"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.mirror",description:`<strong>mirror</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Mirror source to accelerate downloads in China. If you are from China and have an accessibility
problem, you can set this option to resolve it. Note that we do not guarantee the timeliness or safety.
Please refer to the mirror site for more information. specify the folder name here.`,name:"mirror"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.device_map",description:`<strong>device_map</strong> (<code>str</code> or <code>Dict[str, Union[int, str, torch.device]]</code>, <em>optional</em>) &#x2014;
A map that specifies where each submodule should go. It doesn&#x2019;t need to be refined to each
parameter/buffer name, once a given module name is inside, every submodule of it will be sent to the
same device.</p>
<p>To have Accelerate compute the most optimized <code>device_map</code> automatically, set <code>device_map=&quot;auto&quot;</code>. For
more information about each option see <a href="https://hf.co/docs/accelerate/main/en/usage_guides/big_modeling#designing-a-device-map" rel="nofollow">designing a device
map</a>.`,name:"device_map"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.low_cpu_mem_usage",description:`<strong>low_cpu_mem_usage</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code> if torch version &gt;= 1.9.0 else <code>False</code>) &#x2014;
Speed up model loading by not initializing the weights and only loading the pre-trained weights. This
also tries to not use more than 1x model size in CPU memory (including peak memory) while loading the
model. This is only supported when torch version &gt;= 1.9.0. If you are using an older version of torch,
setting this argument to <code>True</code> will raise an error.`,name:"low_cpu_mem_usage"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.use_safetensors",description:`<strong>use_safetensors</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
If set to <code>None</code>, the pipeline will load the <code>safetensors</code> weights if they&#x2019;re available <strong>and</strong> if the
<code>safetensors</code> library is installed. If set to <code>True</code>, the pipeline will forcibly load the models from
<code>safetensors</code> weights. If set to <code>False</code> the pipeline will <em>not</em> use <code>safetensors</code>.`,name:"use_safetensors"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.kwargs",description:`<strong>kwargs</strong> (remaining dictionary of keyword arguments, <em>optional</em>) &#x2014;
Can be used to overwrite load - and saveable variables - <em>i.e.</em> the pipeline components - of the
specific pipeline class. The overwritten components are then directly passed to the pipelines
<code>__init__</code> method. See example below for more information.`,name:"kwargs"},{anchor:"diffusers.DiffusionPipeline.from_pretrained.variant",description:`<strong>variant</strong> (<code>str</code>, <em>optional</em>) &#x2014;
If specified load weights from <code>variant</code> filename, <em>e.g.</em> pytorch_model.<variant>.bin. <code>variant</code> is
ignored when using <code>from_flax</code>.</variant>`,name:"variant"}],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/pipeline_utils.py#L702"}}),fe=new wo({props:{$$slots:{default:[jr]},$$scope:{ctx:O}}}),ce=new wo({props:{$$slots:{default:[Tr]},$$scope:{ctx:O}}}),me=new Ei({props:{anchor:"diffusers.DiffusionPipeline.from_pretrained.example",$$slots:{default:[Lr]},$$scope:{ctx:O}}}),ze=new C({props:{name:"numpy_to_pil",anchor:"diffusers.DiffusionPipeline.numpy_to_pil",parameters:[{name:"images",val:""}],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/pipeline_utils.py#L1393"}}),Ve=new C({props:{name:"save_pretrained",anchor:"diffusers.DiffusionPipeline.save_pretrained",parameters:[{name:"save_directory",val:": typing.Union[str, os.PathLike]"},{name:"safe_serialization",val:": bool = False"},{name:"variant",val:": typing.Optional[str] = None"}],parametersDescription:[{anchor:"diffusers.DiffusionPipeline.save_pretrained.save_directory",description:`<strong>save_directory</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Directory to which to save. Will be created if it doesn&#x2019;t exist.`,name:"save_directory"},{anchor:"diffusers.DiffusionPipeline.save_pretrained.safe_serialization",description:`<strong>safe_serialization</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to save the model using <code>safetensors</code> or the traditional PyTorch way (that uses <code>pickle</code>).`,name:"safe_serialization"},{anchor:"diffusers.DiffusionPipeline.save_pretrained.variant",description:`<strong>variant</strong> (<code>str</code>, <em>optional</em>) &#x2014;
If specified, weights are saved in the format pytorch_model.<variant>.bin.</variant>`,name:"variant"}],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/pipeline_utils.py#L525"}}),Me=new Po({}),Fe=new C({props:{name:"class diffusers.ImagePipelineOutput",anchor:"diffusers.ImagePipelineOutput",parameters:[{name:"images",val:": typing.Union[typing.List[PIL.Image.Image], numpy.ndarray]"}],parametersDescription:[{anchor:"diffusers.ImagePipelineOutput.images",description:`<strong>images</strong> (<code>List[PIL.Image.Image]</code> or <code>np.ndarray</code>) &#x2014;
List of denoised PIL images of length <code>batch_size</code> or numpy array of shape <code>(batch_size, height, width, num_channels)</code>. PIL images or numpy array present the denoised images of the diffusion pipeline.`,name:"images"}],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/pipeline_utils.py#L111"}}),Xe=new Po({}),He=new C({props:{name:"class diffusers.AudioPipelineOutput",anchor:"diffusers.AudioPipelineOutput",parameters:[{name:"audios",val:": ndarray"}],parametersDescription:[{anchor:"diffusers.AudioPipelineOutput.audios",description:`<strong>audios</strong> (<code>np.ndarray</code>) &#x2014;
List of denoised samples of shape <code>(batch_size, num_channels, sample_rate)</code>. Numpy array present the
denoised audio samples of the diffusion pipeline.`,name:"audios"}],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/pipeline_utils.py#L125"}}),{c(){d=n("meta"),v=p(),m=n("h1"),u=n("a"),y=n("span"),w(l.$$.fragment),_=p(),A=n("span"),T=s("Pipelines"),V=p(),L=n("p"),G=s("The "),W=n("a"),Y=s("DiffusionPipeline"),q=s(" is the easiest way to load any pretrained diffusion pipeline from the "),M=n("a"),Ge=s("Hub"),Ye=s(" and to use it in inference."),be=p(),w(ee.$$.fragment),Yt=p(),j=n("p"),xo=s("Any diffusion pipeline that is loaded with "),Be=n("a"),Do=s("from_pretrained()"),ko=s(` will automatically
detect the pipeline type, `),rt=n("em"),Eo=s("e.g."),Io=p(),Re=n("a"),Ao=s("StableDiffusionPipeline"),jo=s(` and consequently load each component of the
pipeline and pass them into the `),st=n("code"),To=s("__init__"),Lo=s(" function of the pipeline, "),at=n("em"),Oo=s("e.g."),So=p(),lt=n("code"),qo=s("__init__()"),Co=s("."),Bt=p(),te=n("p"),No=s("Any pipeline object can be saved locally with "),Je=n("a"),zo=s("save_pretrained()"),Vo=s("."),Rt=p(),B=n("h2"),oe=n("a"),dt=n("span"),w(ve.$$.fragment),Wo=p(),pt=n("span"),Mo=s("DiffusionPipeline"),Jt=p(),h=n("div"),w(ye.$$.fragment),Fo=p(),ft=n("p"),Xo=s("Base class for all models."),Ho=p(),Ke=n("p"),Qe=n("a"),Uo=s("DiffusionPipeline"),Go=s(` takes care of storing all components (models, schedulers, processors) for diffusion pipelines
and handles methods for loading, downloading and saving models as well as a few methods common to all pipelines to:`),Yo=p(),$e=n("ul"),ct=n("li"),Bo=s("move all PyTorch modules to the device of your choice"),Ro=p(),mt=n("li"),Jo=s("enabling/disabling the progress bar for the denoising iteration"),Ko=p(),ut=n("p"),Qo=s("Class attributes:"),Zo=p(),we=n("ul"),ne=n("li"),ht=n("strong"),en=s("config_name"),tn=s(" ("),gt=n("code"),on=s("str"),nn=s(`) \u2014 name of the config file that will store the class and module names of all
components of the diffusion pipeline.`),rn=p(),ie=n("li"),_t=n("strong"),sn=s("_optional_components"),an=s(" (List"),bt=n("code"),ln=s("str"),dn=s(`) \u2014 list of all components that are optional so they don\u2019t have to be
passed for the pipeline to function (should be overridden by subclasses).`),pn=p(),re=n("div"),w(Pe.$$.fragment),fn=p(),vt=n("p"),cn=s("Call self as a function."),mn=p(),Ze=n("div"),w(xe.$$.fragment),un=p(),et=n("div"),w(De.$$.fragment),hn=p(),F=n("div"),w(ke.$$.fragment),gn=p(),Ee=n("p"),_n=s("The "),yt=n("code"),bn=s("self.components"),vn=s(` property can be useful to run different pipelines with the same weights and
configurations to not have to re-allocate memory.`),yn=p(),w(se.$$.fragment),$n=p(),ae=n("div"),w(Ie.$$.fragment),wn=p(),Ae=n("p"),Pn=s("Disable sliced attention computation. If "),$t=n("code"),xn=s("enable_attention_slicing"),Dn=s(` was previously invoked, this method will go
back to computing attention in one step.`),kn=p(),le=n("div"),w(je.$$.fragment),En=p(),wt=n("p"),In=s("Disable memory efficient attention as implemented in xformers."),An=p(),X=n("div"),w(Te.$$.fragment),jn=p(),Pt=n("p"),Tn=s("Download and cache a PyTorch diffusion pipeline from pre-trained pipeline weights."),Ln=p(),w(de.$$.fragment),On=p(),H=n("div"),w(Le.$$.fragment),Sn=p(),xt=n("p"),qn=s("Enable sliced attention computation."),Cn=p(),Dt=n("p"),Nn=s(`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),zn=p(),N=n("div"),w(Oe.$$.fragment),Vn=p(),kt=n("p"),Wn=s("Enable memory efficient attention as implemented in xformers."),Mn=p(),Et=n("p"),Fn=s(`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),Xn=p(),It=n("p"),Hn=s(`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),Un=p(),w(pe.$$.fragment),Gn=p(),I=n("div"),w(Se.$$.fragment),Yn=p(),At=n("p"),Bn=s("Instantiate a PyTorch diffusion pipeline from pre-trained pipeline weights."),Rn=p(),qe=n("p"),Jn=s("The pipeline is set in evaluation mode by default using "),jt=n("code"),Kn=s("model.eval()"),Qn=s(" (Dropout modules are deactivated)."),Zn=p(),Ce=n("p"),ei=s("The warning "),Tt=n("em"),ti=s("Weights from XXX not initialized from pretrained model"),oi=s(` means that the weights of XXX do not come
pretrained with the rest of the model. It is up to you to train those weights with a downstream fine-tuning
task.`),ni=p(),Ne=n("p"),ii=s("The warning "),Lt=n("em"),ri=s("Weights from XXX not used in YYY"),si=s(` means that the layer XXX is not used by YYY, therefore those
weights are discarded.`),ai=p(),w(fe.$$.fragment),li=p(),w(ce.$$.fragment),di=p(),w(me.$$.fragment),pi=p(),ue=n("div"),w(ze.$$.fragment),fi=p(),Ot=n("p"),ci=s("Convert a numpy image or a batch of images to a PIL image."),mi=p(),he=n("div"),w(Ve.$$.fragment),ui=p(),We=n("p"),hi=s(`Save all variables of the pipeline that can be saved and loaded as well as the pipelines configuration file to
a directory. A pipeline variable can be saved and loaded if its class implements both a save and loading
method. The pipeline can easily be re-loaded using the `),tt=n("a"),gi=s("from_pretrained()"),_i=s(" class method."),Kt=p(),R=n("h2"),ge=n("a"),St=n("span"),w(Me.$$.fragment),bi=p(),qt=n("span"),vi=s("ImagePipelineOutput"),Qt=s(`

By default diffusion pipelines return an object of class
`),J=n("div"),w(Fe.$$.fragment),yi=p(),Ct=n("p"),$i=s("Output class for image pipelines."),Zt=p(),K=n("h2"),_e=n("a"),Nt=n("span"),w(Xe.$$.fragment),wi=p(),zt=n("span"),Pi=s("AudioPipelineOutput"),eo=s(`

By default diffusion pipelines return an object of class
`),Q=n("div"),w(He.$$.fragment),xi=p(),Vt=n("p"),Di=s("Output class for audio pipelines."),this.h()},l(t){const g=xr('[data-svelte="svelte-1phssyn"]',document.head);d=i(g,"META",{name:!0,content:!0}),g.forEach(o),v=f(t),m=i(t,"H1",{class:!0});var Ue=r(m);u=i(Ue,"A",{id:!0,class:!0,href:!0});var Wt=r(u);y=i(Wt,"SPAN",{});var Mt=r(y);P(l.$$.fragment,Mt),Mt.forEach(o),Wt.forEach(o),_=f(Ue),A=i(Ue,"SPAN",{});var Ft=r(A);T=a(Ft,"Pipelines"),Ft.forEach(o),Ue.forEach(o),V=f(t),L=i(t,"P",{});var Z=r(L);G=a(Z,"The "),W=i(Z,"A",{href:!0});var Xt=r(W);Y=a(Xt,"DiffusionPipeline"),Xt.forEach(o),q=a(Z," is the easiest way to load any pretrained diffusion pipeline from the "),M=i(Z,"A",{href:!0,rel:!0});var Ht=r(M);Ge=a(Ht,"Hub"),Ht.forEach(o),Ye=a(Z," and to use it in inference."),Z.forEach(o),be=f(t),P(ee.$$.fragment,t),Yt=f(t),j=i(t,"P",{});var z=r(j);xo=a(z,"Any diffusion pipeline that is loaded with "),Be=i(z,"A",{href:!0});var ji=r(Be);Do=a(ji,"from_pretrained()"),ji.forEach(o),ko=a(z,` will automatically
detect the pipeline type, `),rt=i(z,"EM",{});var Ti=r(rt);Eo=a(Ti,"e.g."),Ti.forEach(o),Io=f(z),Re=i(z,"A",{href:!0});var Li=r(Re);Ao=a(Li,"StableDiffusionPipeline"),Li.forEach(o),jo=a(z,` and consequently load each component of the
pipeline and pass them into the `),st=i(z,"CODE",{});var Oi=r(st);To=a(Oi,"__init__"),Oi.forEach(o),Lo=a(z," function of the pipeline, "),at=i(z,"EM",{});var Si=r(at);Oo=a(Si,"e.g."),Si.forEach(o),So=f(z),lt=i(z,"CODE",{});var qi=r(lt);qo=a(qi,"__init__()"),qi.forEach(o),Co=a(z,"."),z.forEach(o),Bt=f(t),te=i(t,"P",{});var oo=r(te);No=a(oo,"Any pipeline object can be saved locally with "),Je=i(oo,"A",{href:!0});var Ci=r(Je);zo=a(Ci,"save_pretrained()"),Ci.forEach(o),Vo=a(oo,"."),oo.forEach(o),Rt=f(t),B=i(t,"H2",{class:!0});var no=r(B);oe=i(no,"A",{id:!0,class:!0,href:!0});var Ni=r(oe);dt=i(Ni,"SPAN",{});var zi=r(dt);P(ve.$$.fragment,zi),zi.forEach(o),Ni.forEach(o),Wo=f(no),pt=i(no,"SPAN",{});var Vi=r(pt);Mo=a(Vi,"DiffusionPipeline"),Vi.forEach(o),no.forEach(o),Jt=f(t),h=i(t,"DIV",{class:!0});var b=r(h);P(ye.$$.fragment,b),Fo=f(b),ft=i(b,"P",{});var Wi=r(ft);Xo=a(Wi,"Base class for all models."),Wi.forEach(o),Ho=f(b),Ke=i(b,"P",{});var ki=r(Ke);Qe=i(ki,"A",{href:!0});var Mi=r(Qe);Uo=a(Mi,"DiffusionPipeline"),Mi.forEach(o),Go=a(ki,` takes care of storing all components (models, schedulers, processors) for diffusion pipelines
and handles methods for loading, downloading and saving models as well as a few methods common to all pipelines to:`),ki.forEach(o),Yo=f(b),$e=i(b,"UL",{});var io=r($e);ct=i(io,"LI",{});var Fi=r(ct);Bo=a(Fi,"move all PyTorch modules to the device of your choice"),Fi.forEach(o),Ro=f(io),mt=i(io,"LI",{});var Xi=r(mt);Jo=a(Xi,"enabling/disabling the progress bar for the denoising iteration"),Xi.forEach(o),io.forEach(o),Ko=f(b),ut=i(b,"P",{});var Hi=r(ut);Qo=a(Hi,"Class attributes:"),Hi.forEach(o),Zo=f(b),we=i(b,"UL",{});var ro=r(we);ne=i(ro,"LI",{});var Ut=r(ne);ht=i(Ut,"STRONG",{});var Ui=r(ht);en=a(Ui,"config_name"),Ui.forEach(o),tn=a(Ut," ("),gt=i(Ut,"CODE",{});var Gi=r(gt);on=a(Gi,"str"),Gi.forEach(o),nn=a(Ut,`) \u2014 name of the config file that will store the class and module names of all
components of the diffusion pipeline.`),Ut.forEach(o),rn=f(ro),ie=i(ro,"LI",{});var Gt=r(ie);_t=i(Gt,"STRONG",{});var Yi=r(_t);sn=a(Yi,"_optional_components"),Yi.forEach(o),an=a(Gt," (List"),bt=i(Gt,"CODE",{});var Bi=r(bt);ln=a(Bi,"str"),Bi.forEach(o),dn=a(Gt,`) \u2014 list of all components that are optional so they don\u2019t have to be
passed for the pipeline to function (should be overridden by subclasses).`),Gt.forEach(o),ro.forEach(o),pn=f(b),re=i(b,"DIV",{class:!0});var so=r(re);P(Pe.$$.fragment,so),fn=f(so),vt=i(so,"P",{});var Ri=r(vt);cn=a(Ri,"Call self as a function."),Ri.forEach(o),so.forEach(o),mn=f(b),Ze=i(b,"DIV",{class:!0});var Ji=r(Ze);P(xe.$$.fragment,Ji),Ji.forEach(o),un=f(b),et=i(b,"DIV",{class:!0});var Ki=r(et);P(De.$$.fragment,Ki),Ki.forEach(o),hn=f(b),F=i(b,"DIV",{class:!0});var ot=r(F);P(ke.$$.fragment,ot),gn=f(ot),Ee=i(ot,"P",{});var ao=r(Ee);_n=a(ao,"The "),yt=i(ao,"CODE",{});var Qi=r(yt);bn=a(Qi,"self.components"),Qi.forEach(o),vn=a(ao,` property can be useful to run different pipelines with the same weights and
configurations to not have to re-allocate memory.`),ao.forEach(o),yn=f(ot),P(se.$$.fragment,ot),ot.forEach(o),$n=f(b),ae=i(b,"DIV",{class:!0});var lo=r(ae);P(Ie.$$.fragment,lo),wn=f(lo),Ae=i(lo,"P",{});var po=r(Ae);Pn=a(po,"Disable sliced attention computation. If "),$t=i(po,"CODE",{});var Zi=r($t);xn=a(Zi,"enable_attention_slicing"),Zi.forEach(o),Dn=a(po,` was previously invoked, this method will go
back to computing attention in one step.`),po.forEach(o),lo.forEach(o),kn=f(b),le=i(b,"DIV",{class:!0});var fo=r(le);P(je.$$.fragment,fo),En=f(fo),wt=i(fo,"P",{});var er=r(wt);In=a(er,"Disable memory efficient attention as implemented in xformers."),er.forEach(o),fo.forEach(o),An=f(b),X=i(b,"DIV",{class:!0});var nt=r(X);P(Te.$$.fragment,nt),jn=f(nt),Pt=i(nt,"P",{});var tr=r(Pt);Tn=a(tr,"Download and cache a PyTorch diffusion pipeline from pre-trained pipeline weights."),tr.forEach(o),Ln=f(nt),P(de.$$.fragment,nt),nt.forEach(o),On=f(b),H=i(b,"DIV",{class:!0});var it=r(H);P(Le.$$.fragment,it),Sn=f(it),xt=i(it,"P",{});var or=r(xt);qn=a(or,"Enable sliced attention computation."),or.forEach(o),Cn=f(it),Dt=i(it,"P",{});var nr=r(Dt);Nn=a(nr,`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),nr.forEach(o),it.forEach(o),zn=f(b),N=i(b,"DIV",{class:!0});var U=r(N);P(Oe.$$.fragment,U),Vn=f(U),kt=i(U,"P",{});var ir=r(kt);Wn=a(ir,"Enable memory efficient attention as implemented in xformers."),ir.forEach(o),Mn=f(U),Et=i(U,"P",{});var rr=r(Et);Fn=a(rr,`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),rr.forEach(o),Xn=f(U),It=i(U,"P",{});var sr=r(It);Hn=a(sr,`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),sr.forEach(o),Un=f(U),P(pe.$$.fragment,U),U.forEach(o),Gn=f(b),I=i(b,"DIV",{class:!0});var S=r(I);P(Se.$$.fragment,S),Yn=f(S),At=i(S,"P",{});var ar=r(At);Bn=a(ar,"Instantiate a PyTorch diffusion pipeline from pre-trained pipeline weights."),ar.forEach(o),Rn=f(S),qe=i(S,"P",{});var co=r(qe);Jn=a(co,"The pipeline is set in evaluation mode by default using "),jt=i(co,"CODE",{});var lr=r(jt);Kn=a(lr,"model.eval()"),lr.forEach(o),Qn=a(co," (Dropout modules are deactivated)."),co.forEach(o),Zn=f(S),Ce=i(S,"P",{});var mo=r(Ce);ei=a(mo,"The warning "),Tt=i(mo,"EM",{});var dr=r(Tt);ti=a(dr,"Weights from XXX not initialized from pretrained model"),dr.forEach(o),oi=a(mo,` means that the weights of XXX do not come
pretrained with the rest of the model. It is up to you to train those weights with a downstream fine-tuning
task.`),mo.forEach(o),ni=f(S),Ne=i(S,"P",{});var uo=r(Ne);ii=a(uo,"The warning "),Lt=i(uo,"EM",{});var pr=r(Lt);ri=a(pr,"Weights from XXX not used in YYY"),pr.forEach(o),si=a(uo,` means that the layer XXX is not used by YYY, therefore those
weights are discarded.`),uo.forEach(o),ai=f(S),P(fe.$$.fragment,S),li=f(S),P(ce.$$.fragment,S),di=f(S),P(me.$$.fragment,S),S.forEach(o),pi=f(b),ue=i(b,"DIV",{class:!0});var ho=r(ue);P(ze.$$.fragment,ho),fi=f(ho),Ot=i(ho,"P",{});var fr=r(Ot);ci=a(fr,"Convert a numpy image or a batch of images to a PIL image."),fr.forEach(o),ho.forEach(o),mi=f(b),he=i(b,"DIV",{class:!0});var go=r(he);P(Ve.$$.fragment,go),ui=f(go),We=i(go,"P",{});var _o=r(We);hi=a(_o,`Save all variables of the pipeline that can be saved and loaded as well as the pipelines configuration file to
a directory. A pipeline variable can be saved and loaded if its class implements both a save and loading
method. The pipeline can easily be re-loaded using the `),tt=i(_o,"A",{href:!0});var cr=r(tt);gi=a(cr,"from_pretrained()"),cr.forEach(o),_i=a(_o," class method."),_o.forEach(o),go.forEach(o),b.forEach(o),Kt=f(t),R=i(t,"H2",{class:!0});var bo=r(R);ge=i(bo,"A",{id:!0,class:!0,href:!0});var mr=r(ge);St=i(mr,"SPAN",{});var ur=r(St);P(Me.$$.fragment,ur),ur.forEach(o),mr.forEach(o),bi=f(bo),qt=i(bo,"SPAN",{});var hr=r(qt);vi=a(hr,"ImagePipelineOutput"),hr.forEach(o),bo.forEach(o),Qt=a(t,`

By default diffusion pipelines return an object of class
`),J=i(t,"DIV",{class:!0});var vo=r(J);P(Fe.$$.fragment,vo),yi=f(vo),Ct=i(vo,"P",{});var gr=r(Ct);$i=a(gr,"Output class for image pipelines."),gr.forEach(o),vo.forEach(o),Zt=f(t),K=i(t,"H2",{class:!0});var yo=r(K);_e=i(yo,"A",{id:!0,class:!0,href:!0});var _r=r(_e);Nt=i(_r,"SPAN",{});var br=r(Nt);P(Xe.$$.fragment,br),br.forEach(o),_r.forEach(o),wi=f(yo),zt=i(yo,"SPAN",{});var vr=r(zt);Pi=a(vr,"AudioPipelineOutput"),vr.forEach(o),yo.forEach(o),eo=a(t,`

By default diffusion pipelines return an object of class
`),Q=i(t,"DIV",{class:!0});var $o=r(Q);P(He.$$.fragment,$o),xi=f($o),Vt=i($o,"P",{});var yr=r(Vt);Di=a(yr,"Output class for audio pipelines."),yr.forEach(o),$o.forEach(o),this.h()},h(){c(d,"name","hf:doc:metadata"),c(d,"content",JSON.stringify(Sr)),c(u,"id","pipelines"),c(u,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(u,"href","#pipelines"),c(m,"class","relative group"),c(W,"href","/docs/diffusers/pr_185/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),c(M,"href","https://huggingface.co/models?library=diffusers"),c(M,"rel","nofollow"),c(Be,"href","/docs/diffusers/pr_185/en/api/diffusion_pipeline#diffusers.DiffusionPipeline.from_pretrained"),c(Re,"href","/docs/diffusers/pr_185/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline"),c(Je,"href","/docs/diffusers/pr_185/en/api/diffusion_pipeline#diffusers.DiffusionPipeline.save_pretrained"),c(oe,"id","diffusers.DiffusionPipeline"),c(oe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(oe,"href","#diffusers.DiffusionPipeline"),c(B,"class","relative group"),c(Qe,"href","/docs/diffusers/pr_185/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),c(re,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Ze,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(et,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(F,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ae,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(le,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(X,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(H,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(I,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ue,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(tt,"href","/docs/diffusers/pr_185/en/api/diffusion_pipeline#diffusers.DiffusionPipeline.from_pretrained"),c(he,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(h,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ge,"id","diffusers.ImagePipelineOutput"),c(ge,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ge,"href","#diffusers.ImagePipelineOutput"),c(R,"class","relative group"),c(J,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(_e,"id","diffusers.AudioPipelineOutput"),c(_e,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(_e,"href","#diffusers.AudioPipelineOutput"),c(K,"class","relative group"),c(Q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,g){e(document.head,d),$(t,v,g),$(t,m,g),e(m,u),e(u,y),x(l,y,null),e(m,_),e(m,A),e(A,T),$(t,V,g),$(t,L,g),e(L,G),e(L,W),e(W,Y),e(L,q),e(L,M),e(M,Ge),e(L,Ye),$(t,be,g),x(ee,t,g),$(t,Yt,g),$(t,j,g),e(j,xo),e(j,Be),e(Be,Do),e(j,ko),e(j,rt),e(rt,Eo),e(j,Io),e(j,Re),e(Re,Ao),e(j,jo),e(j,st),e(st,To),e(j,Lo),e(j,at),e(at,Oo),e(j,So),e(j,lt),e(lt,qo),e(j,Co),$(t,Bt,g),$(t,te,g),e(te,No),e(te,Je),e(Je,zo),e(te,Vo),$(t,Rt,g),$(t,B,g),e(B,oe),e(oe,dt),x(ve,dt,null),e(B,Wo),e(B,pt),e(pt,Mo),$(t,Jt,g),$(t,h,g),x(ye,h,null),e(h,Fo),e(h,ft),e(ft,Xo),e(h,Ho),e(h,Ke),e(Ke,Qe),e(Qe,Uo),e(Ke,Go),e(h,Yo),e(h,$e),e($e,ct),e(ct,Bo),e($e,Ro),e($e,mt),e(mt,Jo),e(h,Ko),e(h,ut),e(ut,Qo),e(h,Zo),e(h,we),e(we,ne),e(ne,ht),e(ht,en),e(ne,tn),e(ne,gt),e(gt,on),e(ne,nn),e(we,rn),e(we,ie),e(ie,_t),e(_t,sn),e(ie,an),e(ie,bt),e(bt,ln),e(ie,dn),e(h,pn),e(h,re),x(Pe,re,null),e(re,fn),e(re,vt),e(vt,cn),e(h,mn),e(h,Ze),x(xe,Ze,null),e(h,un),e(h,et),x(De,et,null),e(h,hn),e(h,F),x(ke,F,null),e(F,gn),e(F,Ee),e(Ee,_n),e(Ee,yt),e(yt,bn),e(Ee,vn),e(F,yn),x(se,F,null),e(h,$n),e(h,ae),x(Ie,ae,null),e(ae,wn),e(ae,Ae),e(Ae,Pn),e(Ae,$t),e($t,xn),e(Ae,Dn),e(h,kn),e(h,le),x(je,le,null),e(le,En),e(le,wt),e(wt,In),e(h,An),e(h,X),x(Te,X,null),e(X,jn),e(X,Pt),e(Pt,Tn),e(X,Ln),x(de,X,null),e(h,On),e(h,H),x(Le,H,null),e(H,Sn),e(H,xt),e(xt,qn),e(H,Cn),e(H,Dt),e(Dt,Nn),e(h,zn),e(h,N),x(Oe,N,null),e(N,Vn),e(N,kt),e(kt,Wn),e(N,Mn),e(N,Et),e(Et,Fn),e(N,Xn),e(N,It),e(It,Hn),e(N,Un),x(pe,N,null),e(h,Gn),e(h,I),x(Se,I,null),e(I,Yn),e(I,At),e(At,Bn),e(I,Rn),e(I,qe),e(qe,Jn),e(qe,jt),e(jt,Kn),e(qe,Qn),e(I,Zn),e(I,Ce),e(Ce,ei),e(Ce,Tt),e(Tt,ti),e(Ce,oi),e(I,ni),e(I,Ne),e(Ne,ii),e(Ne,Lt),e(Lt,ri),e(Ne,si),e(I,ai),x(fe,I,null),e(I,li),x(ce,I,null),e(I,di),x(me,I,null),e(h,pi),e(h,ue),x(ze,ue,null),e(ue,fi),e(ue,Ot),e(Ot,ci),e(h,mi),e(h,he),x(Ve,he,null),e(he,ui),e(he,We),e(We,hi),e(We,tt),e(tt,gi),e(We,_i),$(t,Kt,g),$(t,R,g),e(R,ge),e(ge,St),x(Me,St,null),e(R,bi),e(R,qt),e(qt,vi),$(t,Qt,g),$(t,J,g),x(Fe,J,null),e(J,yi),e(J,Ct),e(Ct,$i),$(t,Zt,g),$(t,K,g),e(K,_e),e(_e,Nt),x(Xe,Nt,null),e(K,wi),e(K,zt),e(zt,Pi),$(t,eo,g),$(t,Q,g),x(He,Q,null),e(Q,xi),e(Q,Vt),e(Vt,Di),to=!0},p(t,[g]){const Ue={};g&2&&(Ue.$$scope={dirty:g,ctx:t}),ee.$set(Ue);const Wt={};g&2&&(Wt.$$scope={dirty:g,ctx:t}),se.$set(Wt);const Mt={};g&2&&(Mt.$$scope={dirty:g,ctx:t}),de.$set(Mt);const Ft={};g&2&&(Ft.$$scope={dirty:g,ctx:t}),pe.$set(Ft);const Z={};g&2&&(Z.$$scope={dirty:g,ctx:t}),fe.$set(Z);const Xt={};g&2&&(Xt.$$scope={dirty:g,ctx:t}),ce.$set(Xt);const Ht={};g&2&&(Ht.$$scope={dirty:g,ctx:t}),me.$set(Ht)},i(t){to||(D(l.$$.fragment,t),D(ee.$$.fragment,t),D(ve.$$.fragment,t),D(ye.$$.fragment,t),D(Pe.$$.fragment,t),D(xe.$$.fragment,t),D(De.$$.fragment,t),D(ke.$$.fragment,t),D(se.$$.fragment,t),D(Ie.$$.fragment,t),D(je.$$.fragment,t),D(Te.$$.fragment,t),D(de.$$.fragment,t),D(Le.$$.fragment,t),D(Oe.$$.fragment,t),D(pe.$$.fragment,t),D(Se.$$.fragment,t),D(fe.$$.fragment,t),D(ce.$$.fragment,t),D(me.$$.fragment,t),D(ze.$$.fragment,t),D(Ve.$$.fragment,t),D(Me.$$.fragment,t),D(Fe.$$.fragment,t),D(Xe.$$.fragment,t),D(He.$$.fragment,t),to=!0)},o(t){k(l.$$.fragment,t),k(ee.$$.fragment,t),k(ve.$$.fragment,t),k(ye.$$.fragment,t),k(Pe.$$.fragment,t),k(xe.$$.fragment,t),k(De.$$.fragment,t),k(ke.$$.fragment,t),k(se.$$.fragment,t),k(Ie.$$.fragment,t),k(je.$$.fragment,t),k(Te.$$.fragment,t),k(de.$$.fragment,t),k(Le.$$.fragment,t),k(Oe.$$.fragment,t),k(pe.$$.fragment,t),k(Se.$$.fragment,t),k(fe.$$.fragment,t),k(ce.$$.fragment,t),k(me.$$.fragment,t),k(ze.$$.fragment,t),k(Ve.$$.fragment,t),k(Me.$$.fragment,t),k(Fe.$$.fragment,t),k(Xe.$$.fragment,t),k(He.$$.fragment,t),to=!1},d(t){o(d),t&&o(v),t&&o(m),E(l),t&&o(V),t&&o(L),t&&o(be),E(ee,t),t&&o(Yt),t&&o(j),t&&o(Bt),t&&o(te),t&&o(Rt),t&&o(B),E(ve),t&&o(Jt),t&&o(h),E(ye),E(Pe),E(xe),E(De),E(ke),E(se),E(Ie),E(je),E(Te),E(de),E(Le),E(Oe),E(pe),E(Se),E(fe),E(ce),E(me),E(ze),E(Ve),t&&o(Kt),t&&o(R),E(Me),t&&o(Qt),t&&o(J),E(Fe),t&&o(Zt),t&&o(K),E(Xe),t&&o(eo),t&&o(Q),E(He)}}}const Sr={local:"pipelines",sections:[{local:"diffusers.DiffusionPipeline",title:"DiffusionPipeline"},{local:"diffusers.ImagePipelineOutput",title:"ImagePipelineOutput"},{local:"diffusers.AudioPipelineOutput",title:"AudioPipelineOutput"}],title:"Pipelines"};function qr(O){return Dr(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Fr extends $r{constructor(d){super();wr(this,d,qr,Or,Pr,{})}}export{Fr as default,Sr as metadata};
