import{S as sl,i as rl,s as ll,e as o,k as c,w as $,t as a,M as dl,c as n,d as t,m as f,a as i,x as D,h as s,b as u,G as e,g as T,y as P,q as k,o as S,B as E,v as cl,L as Vt}from"../../../../chunks/vendor-hf-doc-builder.js";import{T as Sn}from"../../../../chunks/Tip-hf-doc-builder.js";import{D as C}from"../../../../chunks/Docstring-hf-doc-builder.js";import{C as zt}from"../../../../chunks/CodeBlock-hf-doc-builder.js";import{I as al}from"../../../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Ut}from"../../../../chunks/ExampleCodeBlock-hf-doc-builder.js";function fl(I){let d,b,p,m,x;return m=new zt({props:{code:`import torch
from diffusers import StableDiffusionPipeline

pipe = StableDiffusionPipeline.from_pretrained("runwayml/stable-diffusion-v1-5", torch_dtype=torch.float16)
pipe = pipe.to("cuda")

prompt = "a photo of an astronaut riding a horse on mars"
image = pipe(prompt).images[0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = StableDiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe(prompt).images[<span class="hljs-number">0</span>]`}}),{c(){d=o("p"),b=a("Examples:"),p=c(),$(m.$$.fragment)},l(l){d=n(l,"P",{});var h=i(d);b=s(h,"Examples:"),h.forEach(t),p=f(l),D(m.$$.fragment,l)},m(l,h){T(l,d,h),e(d,b),T(l,p,h),P(m,l,h),x=!0},p:Vt,i(l){x||(k(m.$$.fragment,l),x=!0)},o(l){S(m.$$.fragment,l),x=!1},d(l){l&&t(d),l&&t(p),E(m,l)}}}function pl(I){let d,b,p,m,x;return m=new zt({props:{code:`import torch
from diffusers import DiffusionPipeline
from xformers.ops import MemoryEfficientAttentionFlashAttentionOp

pipe = DiffusionPipeline.from_pretrained("stabilityai/stable-diffusion-2-1", torch_dtype=torch.float16)
pipe = pipe.to("cuda")
pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
# Workaround for not accepting attention shape using VAE for Flash Attention
pipe.vae.enable_xformers_memory_efficient_attention(attention_op=None)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> xformers.ops <span class="hljs-keyword">import</span> MemoryEfficientAttentionFlashAttentionOp

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;stabilityai/stable-diffusion-2-1&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Workaround for not accepting attention shape using VAE for Flash Attention</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.vae.enable_xformers_memory_efficient_attention(attention_op=<span class="hljs-literal">None</span>)`}}),{c(){d=o("p"),b=a("Examples:"),p=c(),$(m.$$.fragment)},l(l){d=n(l,"P",{});var h=i(d);b=s(h,"Examples:"),h.forEach(t),p=f(l),D(m.$$.fragment,l)},m(l,h){T(l,d,h),e(d,b),T(l,p,h),P(m,l,h),x=!0},p:Vt,i(l){x||(k(m.$$.fragment,l),x=!0)},o(l){S(m.$$.fragment,l),x=!1},d(l){l&&t(d),l&&t(p),E(m,l)}}}function ul(I){let d,b;return{c(){d=o("p"),b=a("This function is experimental and might change in the future.")},l(p){d=n(p,"P",{});var m=i(d);b=s(m,"This function is experimental and might change in the future."),m.forEach(t)},m(p,m){T(p,d,m),e(d,b)},d(p){p&&t(d)}}}function ml(I){let d,b,p,m,x,l,h,j;return{c(){d=o("p"),b=a("It is required to be logged in ("),p=o("code"),m=a("huggingface-cli login"),x=a(") when you want to use private or "),l=o("a"),h=a(`gated
models`),j=a("."),this.h()},l(_){d=n(_,"P",{});var w=i(d);b=s(w,"It is required to be logged in ("),p=n(w,"CODE",{});var A=i(p);m=s(A,"huggingface-cli login"),A.forEach(t),x=s(w,") when you want to use private or "),l=n(w,"A",{href:!0,rel:!0});var O=i(l);h=s(O,`gated
models`),O.forEach(t),j=s(w,"."),w.forEach(t),this.h()},h(){u(l,"href","https://huggingface.co/docs/hub/models-gated#gated-models"),u(l,"rel","nofollow")},m(_,w){T(_,d,w),e(d,b),e(d,p),e(p,m),e(d,x),e(d,l),e(l,h),e(d,j)},d(_){_&&t(d)}}}function hl(I){let d,b,p,m,x,l,h,j;return h=new zt({props:{code:`from diffusers import StableDiffusionPipeline
import torch

model_id = "runwayml/stable-diffusion-v1-5"
pipe = StableDiffusionPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to("cuda")

pipe.load_textual_inversion("sd-concepts-library/cat-toy")

prompt = "A <cat-toy> backpack"

image = pipe(prompt, num_inference_steps=50).images[0]
image.save("cat-backpack.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> torch

model_id = <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>
pipe = StableDiffusionPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to(<span class="hljs-string">&quot;cuda&quot;</span>)

pipe.load_textual_inversion(<span class="hljs-string">&quot;sd-concepts-library/cat-toy&quot;</span>)

prompt = <span class="hljs-string">&quot;A &lt;cat-toy&gt; backpack&quot;</span>

image = pipe(prompt, num_inference_steps=<span class="hljs-number">50</span>).images[<span class="hljs-number">0</span>]
image.save(<span class="hljs-string">&quot;cat-backpack.png&quot;</span>)`}}),{c(){d=o("p"),b=a("To load a textual inversion embedding vector in "),p=o("code"),m=a("diffusers"),x=a(" format:"),l=c(),$(h.$$.fragment)},l(_){d=n(_,"P",{});var w=i(d);b=s(w,"To load a textual inversion embedding vector in "),p=n(w,"CODE",{});var A=i(p);m=s(A,"diffusers"),A.forEach(t),x=s(w," format:"),w.forEach(t),l=f(_),D(h.$$.fragment,_)},m(_,w){T(_,d,w),e(d,b),e(d,p),e(p,m),e(d,x),T(_,l,w),P(h,_,w),j=!0},p:Vt,i(_){j||(k(h.$$.fragment,_),j=!0)},o(_){S(h.$$.fragment,_),j=!1},d(_){_&&t(d),_&&t(l),E(h,_)}}}function gl(I){let d,b,p,m,x,l,h,j;return h=new zt({props:{code:`from diffusers import StableDiffusionPipeline
import torch

model_id = "runwayml/stable-diffusion-v1-5"
pipe = StableDiffusionPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to("cuda")

pipe.load_textual_inversion("./charturnerv2.pt", token="charturnerv2")

prompt = "charturnerv2, multiple views of the same character in the same outfit, a character turnaround of a woman wearing a black jacket and red shirt, best quality, intricate details."

image = pipe(prompt, num_inference_steps=50).images[0]
image.save("character.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline
<span class="hljs-keyword">import</span> torch

model_id = <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>
pipe = StableDiffusionPipeline.from_pretrained(model_id, torch_dtype=torch.float16).to(<span class="hljs-string">&quot;cuda&quot;</span>)

pipe.load_textual_inversion(<span class="hljs-string">&quot;./charturnerv2.pt&quot;</span>, token=<span class="hljs-string">&quot;charturnerv2&quot;</span>)

prompt = <span class="hljs-string">&quot;charturnerv2, multiple views of the same character in the same outfit, a character turnaround of a woman wearing a black jacket and red shirt, best quality, intricate details.&quot;</span>

image = pipe(prompt, num_inference_steps=<span class="hljs-number">50</span>).images[<span class="hljs-number">0</span>]
image.save(<span class="hljs-string">&quot;character.png&quot;</span>)`}}),{c(){d=o("p"),b=a("e.g. from "),p=o("a"),m=a("civitAI"),x=a(" and then load the vector locally:"),l=c(),$(h.$$.fragment),this.h()},l(_){d=n(_,"P",{});var w=i(d);b=s(w,"e.g. from "),p=n(w,"A",{href:!0,rel:!0});var A=i(p);m=s(A,"civitAI"),A.forEach(t),x=s(w," and then load the vector locally:"),w.forEach(t),l=f(_),D(h.$$.fragment,_),this.h()},h(){u(p,"href","https://civitai.com/models/3036?modelVersionId=9857"),u(p,"rel","nofollow")},m(_,w){T(_,d,w),e(d,b),e(d,p),e(p,m),e(d,x),T(_,l,w),P(h,_,w),j=!0},p:Vt,i(_){j||(k(h.$$.fragment,_),j=!0)},o(_){S(h.$$.fragment,_),j=!1},d(_){_&&t(d),_&&t(l),E(h,_)}}}function _l(I){let d,b,p,m,x;return m=new zt({props:{code:`from diffusers import StableDiffusionPipeline

# Download pipeline from huggingface.co and cache.
pipeline = StableDiffusionPipeline.from_ckpt(
    "https://huggingface.co/WarriorMama777/OrangeMixs/blob/main/Models/AbyssOrangeMix/AbyssOrangeMix.safetensors"
)

# Download pipeline from local file
# file is downloaded under ./v1-5-pruned-emaonly.ckpt
pipeline = StableDiffusionPipeline.from_ckpt("./v1-5-pruned-emaonly")

# Enable float16 and move to GPU
pipeline = StableDiffusionPipeline.from_ckpt(
    "https://huggingface.co/runwayml/stable-diffusion-v1-5/blob/main/v1-5-pruned-emaonly.ckpt",
    torch_dtype=torch.float16,
)
pipeline.to("cuda")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Download pipeline from huggingface.co and cache.</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline = StableDiffusionPipeline.from_ckpt(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;https://huggingface.co/WarriorMama777/OrangeMixs/blob/main/Models/AbyssOrangeMix/AbyssOrangeMix.safetensors&quot;</span>
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Download pipeline from local file</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># file is downloaded under ./v1-5-pruned-emaonly.ckpt</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline = StableDiffusionPipeline.from_ckpt(<span class="hljs-string">&quot;./v1-5-pruned-emaonly&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Enable float16 and move to GPU</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline = StableDiffusionPipeline.from_ckpt(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;https://huggingface.co/runwayml/stable-diffusion-v1-5/blob/main/v1-5-pruned-emaonly.ckpt&quot;</span>,
<span class="hljs-meta">... </span>    torch_dtype=torch.float16,
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline.to(<span class="hljs-string">&quot;cuda&quot;</span>)`}}),{c(){d=o("p"),b=a("Examples:"),p=c(),$(m.$$.fragment)},l(l){d=n(l,"P",{});var h=i(d);b=s(h,"Examples:"),h.forEach(t),p=f(l),D(m.$$.fragment,l)},m(l,h){T(l,d,h),e(d,b),T(l,p,h),P(m,l,h),x=!0},p:Vt,i(l){x||(k(m.$$.fragment,l),x=!0)},o(l){S(m.$$.fragment,l),x=!1},d(l){l&&t(d),l&&t(p),E(m,l)}}}function bl(I){let d,b;return{c(){d=o("p"),b=a("This function is experimental and might change in the future.")},l(p){d=n(p,"P",{});var m=i(d);b=s(m,"This function is experimental and might change in the future."),m.forEach(t)},m(p,m){T(p,d,m),e(d,b)},d(p){p&&t(d)}}}function vl(I){let d,b,p,m,x,l,h,j;return{c(){d=o("p"),b=a("It is required to be logged in ("),p=o("code"),m=a("huggingface-cli login"),x=a(") when you want to use private or "),l=o("a"),h=a(`gated
models`),j=a("."),this.h()},l(_){d=n(_,"P",{});var w=i(d);b=s(w,"It is required to be logged in ("),p=n(w,"CODE",{});var A=i(p);m=s(A,"huggingface-cli login"),A.forEach(t),x=s(w,") when you want to use private or "),l=n(w,"A",{href:!0,rel:!0});var O=i(l);h=s(O,`gated
models`),O.forEach(t),j=s(w,"."),w.forEach(t),this.h()},h(){u(l,"href","https://huggingface.co/docs/hub/models-gated#gated-models"),u(l,"rel","nofollow")},m(_,w){T(_,d,w),e(d,b),e(d,p),e(p,m),e(d,x),e(d,l),e(l,h),e(d,j)},d(_){_&&t(d)}}}function yl(I){let d,b,p,m,x;return m=new zt({props:{code:`import jax
import numpy as np
from flax.jax_utils import replicate
from flax.training.common_utils import shard

from diffusers import FlaxStableDiffusionPipeline

pipeline, params = FlaxStableDiffusionPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5", revision="bf16", dtype=jax.numpy.bfloat16
)

prompt = "a photo of an astronaut riding a horse on mars"

prng_seed = jax.random.PRNGKey(0)
num_inference_steps = 50

num_samples = jax.device_count()
prompt = num_samples * [prompt]
prompt_ids = pipeline.prepare_inputs(prompt)

params = replicate(params)
prng_seed = jax.random.split(prng_seed, jax.device_count())
prompt_ids = shard(prompt_ids)

images = pipeline(prompt_ids, params, prng_seed, num_inference_steps, jit=True).images
images = pipeline.numpy_to_pil(np.asarray(images.reshape((num_samples,) + images.shape[-3:])))`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> jax
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> flax.jax_utils <span class="hljs-keyword">import</span> replicate
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> flax.training.common_utils <span class="hljs-keyword">import</span> shard

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> FlaxStableDiffusionPipeline

<span class="hljs-meta">&gt;&gt;&gt; </span>pipeline, params = FlaxStableDiffusionPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>, revision=<span class="hljs-string">&quot;bf16&quot;</span>, dtype=jax.numpy.bfloat16
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = <span class="hljs-string">&quot;a photo of an astronaut riding a horse on mars&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>prng_seed = jax.random.PRNGKey(<span class="hljs-number">0</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>num_inference_steps = <span class="hljs-number">50</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>num_samples = jax.device_count()
<span class="hljs-meta">&gt;&gt;&gt; </span>prompt = num_samples * [prompt]
<span class="hljs-meta">&gt;&gt;&gt; </span>prompt_ids = pipeline.prepare_inputs(prompt)
<span class="hljs-comment"># shard inputs and rng</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>params = replicate(params)
<span class="hljs-meta">&gt;&gt;&gt; </span>prng_seed = jax.random.split(prng_seed, jax.device_count())
<span class="hljs-meta">&gt;&gt;&gt; </span>prompt_ids = shard(prompt_ids)

<span class="hljs-meta">&gt;&gt;&gt; </span>images = pipeline(prompt_ids, params, prng_seed, num_inference_steps, jit=<span class="hljs-literal">True</span>).images
<span class="hljs-meta">&gt;&gt;&gt; </span>images = pipeline.numpy_to_pil(np.asarray(images.reshape((num_samples,) + images.shape[-<span class="hljs-number">3</span>:])))`}}),{c(){d=o("p"),b=a("Examples:"),p=c(),$(m.$$.fragment)},l(l){d=n(l,"P",{});var h=i(d);b=s(h,"Examples:"),h.forEach(t),p=f(l),D(m.$$.fragment,l)},m(l,h){T(l,d,h),e(d,b),T(l,p,h),P(m,l,h),x=!0},p:Vt,i(l){x||(k(m.$$.fragment,l),x=!0)},o(l){S(m.$$.fragment,l),x=!1},d(l){l&&t(d),l&&t(p),E(m,l)}}}function xl(I){let d,b,p,m,x,l,h,j,_,w,A,O,Wt,De,En,Gt,Tn,Ko,q,jn,Pe,In,An,ke,Ln,Cn,Se,qn,Mn,Ee,Fn,Nn,wt,On,Un,Bo,$t,Vn,Ho,ne,Te,Rt,zn,Wn,je,Gn,Rn,Ie,Kt,Kn,Bn,Ae,Hn,Xo,Dt,Xn,Jo,M,Le,Bt,Jn,Qn,Ce,Yn,Zn,qe,Ht,ei,ti,Me,oi,ni,Fe,Xt,ii,ai,Ne,si,ri,Oe,Jt,li,di,Ue,ci,fi,Ve,Qt,pi,ui,ze,mi,hi,We,Yt,gi,_i,Ge,bi,Qo,g,Re,vi,Zt,yi,xi,Ke,wi,Pt,$i,Di,Pi,eo,ki,Si,Z,Be,to,Ei,Ti,kt,ji,Ii,He,oo,Ai,Li,St,Ci,qi,Xe,no,Mi,Fi,Et,Ni,Oi,io,Ui,Vi,ao,Je,so,zi,Wi,Tt,Gi,Ri,K,Qe,Ki,ro,Bi,Hi,ie,Xi,B,Ye,Ji,lo,Qi,Yi,co,Zi,ea,ae,Ze,ta,et,oa,fo,na,ia,aa,H,tt,sa,po,ra,la,uo,da,ca,se,ot,fa,nt,pa,mo,ua,ma,ha,U,it,ga,ho,_a,ba,go,va,ya,_o,xa,wa,re,$a,le,at,Da,bo,Pa,ka,X,st,Sa,vo,Ea,Ta,yo,ja,Ia,de,rt,Aa,lt,La,xo,Ca,qa,Ma,L,dt,Fa,ee,Na,wo,Oa,Ua,$o,Va,za,Wa,ce,Ga,fe,Ra,Do,Ka,Ba,pe,Ha,Po,Xa,Ja,ue,Qa,W,ct,Ya,ko,Za,es,ft,ts,So,os,ns,is,me,as,G,pt,ss,te,rs,jt,ls,ds,ut,Eo,cs,fs,ps,he,us,ge,ms,_e,mt,hs,To,gs,_s,be,ht,bs,V,vs,jo,ys,xs,Io,ws,$s,Ao,Ds,Ps,Lo,ks,Ss,Es,ve,gt,Ts,oe,js,Co,Is,As,qo,Ls,Cs,Yo,z,_t,qs,Mo,Ms,Fs,bt,Ns,Fo,Os,Us,Vs,J,vt,zs,No,Ws,Gs,ye,Zo;return l=new al({}),De=new al({}),Re=new C({props:{name:"class diffusers.StableDiffusionPipeline",anchor:"diffusers.StableDiffusionPipeline",parameters:[{name:"vae",val:": AutoencoderKL"},{name:"text_encoder",val:": CLIPTextModel"},{name:"tokenizer",val:": CLIPTokenizer"},{name:"unet",val:": UNet2DConditionModel"},{name:"scheduler",val:": KarrasDiffusionSchedulers"},{name:"safety_checker",val:": StableDiffusionSafetyChecker"},{name:"feature_extractor",val:": CLIPImageProcessor"},{name:"requires_safety_checker",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.StableDiffusionPipeline.vae",description:`<strong>vae</strong> (<a href="/docs/diffusers/pr_185/en/api/models#diffusers.AutoencoderKL">AutoencoderKL</a>) &#x2014;
Variational Auto-Encoder (VAE) Model to encode and decode images to and from latent representations.`,name:"vae"},{anchor:"diffusers.StableDiffusionPipeline.text_encoder",description:`<strong>text_encoder</strong> (<code>CLIPTextModel</code>) &#x2014;
Frozen text-encoder. Stable Diffusion uses the text portion of
<a href="https://huggingface.co/docs/transformers/model_doc/clip#transformers.CLIPTextModel" rel="nofollow">CLIP</a>, specifically
the <a href="https://huggingface.co/openai/clip-vit-large-patch14" rel="nofollow">clip-vit-large-patch14</a> variant.`,name:"text_encoder"},{anchor:"diffusers.StableDiffusionPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>CLIPTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/v4.21.0/en/model_doc/clip#transformers.CLIPTokenizer" rel="nofollow">CLIPTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.StableDiffusionPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/pr_185/en/api/models#diffusers.UNet2DConditionModel">UNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.StableDiffusionPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/pr_185/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<a href="/docs/diffusers/pr_185/en/api/schedulers/ddim#diffusers.DDIMScheduler">DDIMScheduler</a>, <a href="/docs/diffusers/pr_185/en/api/schedulers/lms_discrete#diffusers.LMSDiscreteScheduler">LMSDiscreteScheduler</a>, or <a href="/docs/diffusers/pr_185/en/api/schedulers/pndm#diffusers.PNDMScheduler">PNDMScheduler</a>.`,name:"scheduler"},{anchor:"diffusers.StableDiffusionPipeline.safety_checker",description:`<strong>safety_checker</strong> (<code>StableDiffusionSafetyChecker</code>) &#x2014;
Classification module that estimates whether generated images could be considered offensive or harmful.
Please, refer to the <a href="https://huggingface.co/runwayml/stable-diffusion-v1-5" rel="nofollow">model card</a> for details.`,name:"safety_checker"},{anchor:"diffusers.StableDiffusionPipeline.feature_extractor",description:`<strong>feature_extractor</strong> (<code>CLIPImageProcessor</code>) &#x2014;
Model that extracts features from generated images to be used as inputs for the <code>safety_checker</code>.`,name:"feature_extractor"}],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion.py#L58"}}),Qe=new C({props:{name:"__call__",anchor:"diffusers.StableDiffusionPipeline.__call__",parameters:[{name:"prompt",val:": typing.Union[str, typing.List[str]] = None"},{name:"height",val:": typing.Optional[int] = None"},{name:"width",val:": typing.Optional[int] = None"},{name:"num_inference_steps",val:": int = 50"},{name:"guidance_scale",val:": float = 7.5"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": float = 0.0"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"latents",val:": typing.Optional[torch.FloatTensor] = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": int = 1"},{name:"cross_attention_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"}],parametersDescription:[{anchor:"diffusers.StableDiffusionPipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts to guide the image generation. If not defined, one has to pass <code>prompt_embeds</code>.
instead.`,name:"prompt"},{anchor:"diffusers.StableDiffusionPipeline.__call__.height",description:`<strong>height</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The height in pixels of the generated image.`,name:"height"},{anchor:"diffusers.StableDiffusionPipeline.__call__.width",description:`<strong>width</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The width in pixels of the generated image.`,name:"width"},{anchor:"diffusers.StableDiffusionPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.StableDiffusionPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.StableDiffusionPipeline.__call__.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. If not defined, one has to pass
<code>negative_prompt_embeds</code> instead. Ignored when not using guidance (i.e., ignored if <code>guidance_scale</code> is
less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.StableDiffusionPipeline.__call__.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.StableDiffusionPipeline.__call__.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/pr_185/en/api/schedulers/ddim#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.StableDiffusionPipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code> or <code>List[torch.Generator]</code>, <em>optional</em>) &#x2014;
One or a list of <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator(s)</a>
to make generation deterministic.`,name:"generator"},{anchor:"diffusers.StableDiffusionPipeline.__call__.latents",description:`<strong>latents</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated noisy latents, sampled from a Gaussian distribution, to be used as inputs for image
generation. Can be used to tweak the same generation with different prompts. If not provided, a latents
tensor will ge generated by sampling using the supplied random <code>generator</code>.`,name:"latents"},{anchor:"diffusers.StableDiffusionPipeline.__call__.prompt_embeds",description:`<strong>prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt weighting. If not
provided, text embeddings will be generated from <code>prompt</code> input argument.`,name:"prompt_embeds"},{anchor:"diffusers.StableDiffusionPipeline.__call__.negative_prompt_embeds",description:`<strong>negative_prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt
weighting. If not provided, negative_prompt_embeds will be generated from <code>negative_prompt</code> input
argument.`,name:"negative_prompt_embeds"},{anchor:"diffusers.StableDiffusionPipeline.__call__.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.StableDiffusionPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/pr_185/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput">StableDiffusionPipelineOutput</a> instead of a
plain tuple.`,name:"return_dict"},{anchor:"diffusers.StableDiffusionPipeline.__call__.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.StableDiffusionPipeline.__call__.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"},{anchor:"diffusers.StableDiffusionPipeline.__call__.cross_attention_kwargs",description:`<strong>cross_attention_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A kwargs dictionary that if specified is passed along to the <code>AttentionProcessor</code> as defined under
<code>self.processor</code> in
<a href="https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/cross_attention.py" rel="nofollow">diffusers.cross_attention</a>.`,name:"cross_attention_kwargs"}],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion.py#L542",returnDescription:`
<p><a
  href="/docs/diffusers/pr_185/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/pr_185/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> or <code>tuple</code></p>
`}}),ie=new Ut({props:{anchor:"diffusers.StableDiffusionPipeline.__call__.example",$$slots:{default:[fl]},$$scope:{ctx:I}}}),Ye=new C({props:{name:"enable_attention_slicing",anchor:"diffusers.StableDiffusionPipeline.enable_attention_slicing",parameters:[{name:"slice_size",val:": typing.Union[str, int, NoneType] = 'auto'"}],parametersDescription:[{anchor:"diffusers.StableDiffusionPipeline.enable_attention_slicing.slice_size",description:`<strong>slice_size</strong> (<code>str</code> or <code>int</code>, <em>optional</em>, defaults to <code>&quot;auto&quot;</code>) &#x2014;
When <code>&quot;auto&quot;</code>, halves the input to the attention heads, so attention will be computed in two steps. If
<code>&quot;max&quot;</code>, maximum amount of memory will be saved by running only one slice at a time. If a number is
provided, uses as many slices as <code>attention_head_dim // slice_size</code>. In this case, <code>attention_head_dim</code>
must be a multiple of <code>slice_size</code>.`,name:"slice_size"}],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/pipeline_utils.py#L1476"}}),Ze=new C({props:{name:"disable_attention_slicing",anchor:"diffusers.StableDiffusionPipeline.disable_attention_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/pipeline_utils.py#L1492"}}),tt=new C({props:{name:"enable_vae_slicing",anchor:"diffusers.StableDiffusionPipeline.enable_vae_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion.py#L185"}}),ot=new C({props:{name:"disable_vae_slicing",anchor:"diffusers.StableDiffusionPipeline.disable_vae_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion.py#L194"}}),it=new C({props:{name:"enable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionPipeline.enable_xformers_memory_efficient_attention",parameters:[{name:"attention_op",val:": typing.Optional[typing.Callable] = None"}],parametersDescription:[{anchor:"diffusers.StableDiffusionPipeline.enable_xformers_memory_efficient_attention.attention_op",description:`<strong>attention_op</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
Override the default <code>None</code> operator for use as <code>op</code> argument to the
<a href="https://facebookresearch.github.io/xformers/components/ops.html#xformers.ops.memory_efficient_attention" rel="nofollow"><code>memory_efficient_attention()</code></a>
function of xFormers.`,name:"attention_op"}],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/pipeline_utils.py#L1418"}}),re=new Ut({props:{anchor:"diffusers.StableDiffusionPipeline.enable_xformers_memory_efficient_attention.example",$$slots:{default:[pl]},$$scope:{ctx:I}}}),at=new C({props:{name:"disable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionPipeline.disable_xformers_memory_efficient_attention",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/pipeline_utils.py#L1450"}}),st=new C({props:{name:"enable_vae_tiling",anchor:"diffusers.StableDiffusionPipeline.enable_vae_tiling",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion.py#L201"}}),rt=new C({props:{name:"disable_vae_tiling",anchor:"diffusers.StableDiffusionPipeline.disable_vae_tiling",parameters:[],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion.py#L210"}}),dt=new C({props:{name:"load_textual_inversion",anchor:"diffusers.StableDiffusionPipeline.load_textual_inversion",parameters:[{name:"pretrained_model_name_or_path",val:": typing.Union[str, typing.List[str]]"},{name:"token",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.StableDiffusionPipeline.load_textual_inversion.pretrained_model_name_or_path",description:`<strong>pretrained_model_name_or_path</strong> (<code>str</code> or <code>os.PathLike</code> or <code>List[str or os.PathLike]</code>) &#x2014;
Can be either:</p>
<ul>
<li>A string, the <em>model id</em> of a pretrained model hosted inside a model repo on huggingface.co.
Valid model ids should have an organization name, like
<code>&quot;sd-concepts-library/low-poly-hd-logos-icons&quot;</code>.</li>
<li>A path to a <em>directory</em> containing textual inversion weights, e.g.
<code>./my_text_inversion_directory/</code>.</li>
<li>A path to a <em>file</em> containing textual inversion weights, e.g. <code>./my_text_inversions.pt</code>.</li>
</ul>
<p>Or a list of those elements.`,name:"pretrained_model_name_or_path"},{anchor:"diffusers.StableDiffusionPipeline.load_textual_inversion.token",description:`<strong>token</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
Override the token to use for the textual inversion weights. If <code>pretrained_model_name_or_path</code> is a
list, then <code>token</code> must also be a list of equal length.`,name:"token"},{anchor:"diffusers.StableDiffusionPipeline.load_textual_inversion.weight_name",description:`<strong>weight_name</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Name of a custom weight file. This should be used in two cases:</p>
<ul>
<li>The saved textual inversion file is in <code>diffusers</code> format, but was saved under a specific weight
name, such as <code>text_inv.bin</code>.</li>
<li>The saved textual inversion file is in the &#x201C;Automatic1111&#x201D; form.</li>
</ul>`,name:"weight_name"},{anchor:"diffusers.StableDiffusionPipeline.load_textual_inversion.cache_dir",description:`<strong>cache_dir</strong> (<code>Union[str, os.PathLike]</code>, <em>optional</em>) &#x2014;
Path to a directory in which a downloaded pretrained model configuration should be cached if the
standard cache should not be used.`,name:"cache_dir"},{anchor:"diffusers.StableDiffusionPipeline.load_textual_inversion.force_download",description:`<strong>force_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to force the (re-)download of the model weights and configuration files, overriding the
cached versions if they exist.`,name:"force_download"},{anchor:"diffusers.StableDiffusionPipeline.load_textual_inversion.resume_download",description:`<strong>resume_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to delete incompletely received files. Will attempt to resume the download if such a
file exists.`,name:"resume_download"},{anchor:"diffusers.StableDiffusionPipeline.load_textual_inversion.proxies",description:`<strong>proxies</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A dictionary of proxy servers to use by protocol or endpoint, e.g., <code>{&apos;http&apos;: &apos;foo.bar:3128&apos;, &apos;http://hostname&apos;: &apos;foo.bar:4012&apos;}</code>. The proxies are used on each request.`,name:"proxies"},{anchor:"diffusers.StableDiffusionPipeline.load_textual_inversion.local_files_only(bool,",description:`<strong>local_files_only(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to only look at local files (i.e., do not try to download the model).`,name:"local_files_only(bool,"},{anchor:"diffusers.StableDiffusionPipeline.load_textual_inversion.use_auth_token",description:`<strong>use_auth_token</strong> (<code>str</code> or <em>bool</em>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If <code>True</code>, will use the token generated
when running <code>diffusers-cli login</code> (stored in <code>~/.huggingface</code>).`,name:"use_auth_token"},{anchor:"diffusers.StableDiffusionPipeline.load_textual_inversion.revision",description:`<strong>revision</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;main&quot;</code>) &#x2014;
The specific model version to use. It can be a branch name, a tag name, or a commit id, since we use a
git-based system for storing models and other artifacts on huggingface.co, so <code>revision</code> can be any
identifier allowed by git.`,name:"revision"},{anchor:"diffusers.StableDiffusionPipeline.load_textual_inversion.subfolder",description:`<strong>subfolder</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&quot;</code>) &#x2014;
In case the relevant files are located inside a subfolder of the model repo (either remote in
huggingface.co or downloaded locally), you can specify the folder name here.`,name:"subfolder"},{anchor:"diffusers.StableDiffusionPipeline.load_textual_inversion.mirror",description:`<strong>mirror</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Mirror source to accelerate downloads in China. If you are from China and have an accessibility
problem, you can set this option to resolve it. Note that we do not guarantee the timeliness or safety.
Please refer to the mirror site for more information.`,name:"mirror"}],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/loaders.py#L466"}}),ce=new Sn({props:{warning:!0,$$slots:{default:[ul]},$$scope:{ctx:I}}}),fe=new Sn({props:{$$slots:{default:[ml]},$$scope:{ctx:I}}}),pe=new Ut({props:{anchor:"diffusers.StableDiffusionPipeline.load_textual_inversion.example",$$slots:{default:[hl]},$$scope:{ctx:I}}}),ue=new Ut({props:{anchor:"diffusers.StableDiffusionPipeline.load_textual_inversion.example-2",$$slots:{default:[gl]},$$scope:{ctx:I}}}),ct=new C({props:{name:"from_ckpt",anchor:"diffusers.StableDiffusionPipeline.from_ckpt",parameters:[{name:"pretrained_model_link_or_path",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.StableDiffusionPipeline.from_ckpt.pretrained_model_link_or_path",description:`<strong>pretrained_model_link_or_path</strong> (<code>str</code> or <code>os.PathLike</code>, <em>optional</em>) &#x2014;
Can be either:<ul>
<li>A link to the .ckpt file on the Hub. Should be in the format
<code>&quot;https://huggingface.co/&lt;repo_id&gt;/blob/main/&lt;path_to_file&gt;&quot;</code></li>
<li>A path to a <em>file</em> containing all pipeline weights.</li>
</ul>`,name:"pretrained_model_link_or_path"},{anchor:"diffusers.StableDiffusionPipeline.from_ckpt.torch_dtype",description:`<strong>torch_dtype</strong> (<code>str</code> or <code>torch.dtype</code>, <em>optional</em>) &#x2014;
Override the default <code>torch.dtype</code> and load the model under this dtype. If <code>&quot;auto&quot;</code> is passed the dtype
will be automatically derived from the model&#x2019;s weights.`,name:"torch_dtype"},{anchor:"diffusers.StableDiffusionPipeline.from_ckpt.force_download",description:`<strong>force_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to force the (re-)download of the model weights and configuration files, overriding the
cached versions if they exist.`,name:"force_download"},{anchor:"diffusers.StableDiffusionPipeline.from_ckpt.cache_dir",description:`<strong>cache_dir</strong> (<code>Union[str, os.PathLike]</code>, <em>optional</em>) &#x2014;
Path to a directory in which a downloaded pretrained model configuration should be cached if the
standard cache should not be used.`,name:"cache_dir"},{anchor:"diffusers.StableDiffusionPipeline.from_ckpt.resume_download",description:`<strong>resume_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to delete incompletely received files. Will attempt to resume the download if such a
file exists.`,name:"resume_download"},{anchor:"diffusers.StableDiffusionPipeline.from_ckpt.proxies",description:`<strong>proxies</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A dictionary of proxy servers to use by protocol or endpoint, e.g., <code>{&apos;http&apos;: &apos;foo.bar:3128&apos;, &apos;http://hostname&apos;: &apos;foo.bar:4012&apos;}</code>. The proxies are used on each request.`,name:"proxies"},{anchor:"diffusers.StableDiffusionPipeline.from_ckpt.local_files_only",description:`<strong>local_files_only</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to only look at local files (i.e., do not try to download the model).`,name:"local_files_only"},{anchor:"diffusers.StableDiffusionPipeline.from_ckpt.use_auth_token",description:`<strong>use_auth_token</strong> (<code>str</code> or <em>bool</em>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If <code>True</code>, will use the token generated
when running <code>huggingface-cli login</code> (stored in <code>~/.huggingface</code>).`,name:"use_auth_token"},{anchor:"diffusers.StableDiffusionPipeline.from_ckpt.revision",description:`<strong>revision</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;main&quot;</code>) &#x2014;
The specific model version to use. It can be a branch name, a tag name, or a commit id, since we use a
git-based system for storing models and other artifacts on huggingface.co, so <code>revision</code> can be any
identifier allowed by git.`,name:"revision"},{anchor:"diffusers.StableDiffusionPipeline.from_ckpt.use_safetensors",description:`<strong>use_safetensors</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
If set to <code>None</code>, the pipeline will load the <code>safetensors</code> weights if they&#x2019;re available <strong>and</strong> if the
<code>safetensors</code> library is installed. If set to <code>True</code>, the pipeline will forcibly load the models from
<code>safetensors</code> weights. If set to <code>False</code> the pipeline will <em>not</em> use <code>safetensors</code>.`,name:"use_safetensors"},{anchor:"diffusers.StableDiffusionPipeline.from_ckpt.extract_ema",description:`<strong>extract_ema</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014; Only relevant for
checkpoints that have both EMA and non-EMA weights. Whether to extract the EMA weights or not. Defaults
to <code>False</code>. Pass <code>True</code> to extract the EMA weights. EMA weights usually yield higher quality images for
inference. Non-EMA weights are usually better to continue fine-tuning.`,name:"extract_ema"},{anchor:"diffusers.StableDiffusionPipeline.from_ckpt.upcast_attention",description:`<strong>upcast_attention</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Whether the attention computation should always be upcasted. This is necessary when running stable`,name:"upcast_attention"},{anchor:"diffusers.StableDiffusionPipeline.from_ckpt.image_size",description:`<strong>image_size</strong> (<code>int</code>, <em>optional</em>, defaults to 512) &#x2014;
The image size that the model was trained on. Use 512 for Stable Diffusion v1.X and Stable Diffusion v2
Base. Use 768 for Stable Diffusion v2.`,name:"image_size"},{anchor:"diffusers.StableDiffusionPipeline.from_ckpt.prediction_type",description:`<strong>prediction_type</strong> (<code>str</code>, <em>optional</em>) &#x2014;
The prediction type that the model was trained on. Use <code>&apos;epsilon&apos;</code> for Stable Diffusion v1.X and Stable
Diffusion v2 Base. Use <code>&apos;v_prediction&apos;</code> for Stable Diffusion v2.`,name:"prediction_type"},{anchor:"diffusers.StableDiffusionPipeline.from_ckpt.num_in_channels",description:`<strong>num_in_channels</strong> (<code>int</code>, <em>optional</em>, defaults to None) &#x2014;
The number of input channels. If <code>None</code>, it will be automatically inferred.`,name:"num_in_channels"},{anchor:"diffusers.StableDiffusionPipeline.from_ckpt.scheduler_type",description:`<strong>scheduler_type</strong> (<code>str</code>, <em>optional</em>, defaults to &#x2018;pndm&#x2019;) &#x2014;
Type of scheduler to use. Should be one of <code>[&quot;pndm&quot;, &quot;lms&quot;, &quot;heun&quot;, &quot;euler&quot;, &quot;euler-ancestral&quot;, &quot;dpm&quot;, &quot;ddim&quot;]</code>.`,name:"scheduler_type"},{anchor:"diffusers.StableDiffusionPipeline.from_ckpt.load_safety_checker",description:`<strong>load_safety_checker</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to load the safety checker or not. Defaults to <code>True</code>.`,name:"load_safety_checker"},{anchor:"diffusers.StableDiffusionPipeline.from_ckpt.kwargs",description:`<strong>kwargs</strong> (remaining dictionary of keyword arguments, <em>optional</em>) &#x2014;
Can be used to overwrite load - and saveable variables - <em>i.e.</em> the pipeline components - of the
specific pipeline class. The overwritten components are then directly passed to the pipelines
<code>__init__</code> method. See example below for more information.`,name:"kwargs"}],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/loaders.py#L1216"}}),me=new Ut({props:{anchor:"diffusers.StableDiffusionPipeline.from_ckpt.example",$$slots:{default:[_l]},$$scope:{ctx:I}}}),pt=new C({props:{name:"load_lora_weights",anchor:"diffusers.StableDiffusionPipeline.load_lora_weights",parameters:[{name:"pretrained_model_name_or_path_or_dict",val:": typing.Union[str, typing.Dict[str, torch.Tensor]]"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"diffusers.StableDiffusionPipeline.load_lora_weights.pretrained_model_name_or_path_or_dict",description:`<strong>pretrained_model_name_or_path_or_dict</strong> (<code>str</code> or <code>os.PathLike</code> or <code>dict</code>) &#x2014;
Can be either:</p>
<ul>
<li>A string, the <em>model id</em> of a pretrained model hosted inside a model repo on huggingface.co.
Valid model ids should have an organization name, like <code>google/ddpm-celebahq-256</code>.</li>
<li>A path to a <em>directory</em> containing model weights saved using <code>~ModelMixin.save_config</code>, e.g.,
<code>./my_model_directory/</code>.</li>
<li>A <a href="https://pytorch.org/tutorials/beginner/saving_loading_models.html#what-is-a-state-dict" rel="nofollow">torch state
dict</a>.</li>
</ul>`,name:"pretrained_model_name_or_path_or_dict"},{anchor:"diffusers.StableDiffusionPipeline.load_lora_weights.cache_dir",description:`<strong>cache_dir</strong> (<code>Union[str, os.PathLike]</code>, <em>optional</em>) &#x2014;
Path to a directory in which a downloaded pretrained model configuration should be cached if the
standard cache should not be used.`,name:"cache_dir"},{anchor:"diffusers.StableDiffusionPipeline.load_lora_weights.force_download",description:`<strong>force_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to force the (re-)download of the model weights and configuration files, overriding the
cached versions if they exist.`,name:"force_download"},{anchor:"diffusers.StableDiffusionPipeline.load_lora_weights.resume_download",description:`<strong>resume_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to delete incompletely received files. Will attempt to resume the download if such a
file exists.`,name:"resume_download"},{anchor:"diffusers.StableDiffusionPipeline.load_lora_weights.proxies",description:`<strong>proxies</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A dictionary of proxy servers to use by protocol or endpoint, e.g., <code>{&apos;http&apos;: &apos;foo.bar:3128&apos;, &apos;http://hostname&apos;: &apos;foo.bar:4012&apos;}</code>. The proxies are used on each request.`,name:"proxies"},{anchor:"diffusers.StableDiffusionPipeline.load_lora_weights.local_files_only(bool,",description:`<strong>local_files_only(<code>bool</code>,</strong> <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to only look at local files (i.e., do not try to download the model).`,name:"local_files_only(bool,"},{anchor:"diffusers.StableDiffusionPipeline.load_lora_weights.use_auth_token",description:`<strong>use_auth_token</strong> (<code>str</code> or <em>bool</em>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If <code>True</code>, will use the token generated
when running <code>diffusers-cli login</code> (stored in <code>~/.huggingface</code>).`,name:"use_auth_token"},{anchor:"diffusers.StableDiffusionPipeline.load_lora_weights.revision",description:`<strong>revision</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;main&quot;</code>) &#x2014;
The specific model version to use. It can be a branch name, a tag name, or a commit id, since we use a
git-based system for storing models and other artifacts on huggingface.co, so <code>revision</code> can be any
identifier allowed by git.`,name:"revision"},{anchor:"diffusers.StableDiffusionPipeline.load_lora_weights.subfolder",description:`<strong>subfolder</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&quot;</code>) &#x2014;
In case the relevant files are located inside a subfolder of the model repo (either remote in
huggingface.co or downloaded locally), you can specify the folder name here.`,name:"subfolder"},{anchor:"diffusers.StableDiffusionPipeline.load_lora_weights.mirror",description:`<strong>mirror</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Mirror source to accelerate downloads in China. If you are from China and have an accessibility
problem, you can set this option to resolve it. Note that we do not guarantee the timeliness or safety.
Please refer to the mirror site for more information.`,name:"mirror"}],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/loaders.py#L759"}}),he=new Sn({props:{warning:!0,$$slots:{default:[bl]},$$scope:{ctx:I}}}),ge=new Sn({props:{$$slots:{default:[vl]},$$scope:{ctx:I}}}),mt=new C({props:{name:"save_lora_weights",anchor:"diffusers.StableDiffusionPipeline.save_lora_weights",parameters:[{name:"save_directory",val:": typing.Union[str, os.PathLike]"},{name:"unet_lora_layers",val:": typing.Dict[str, typing.Union[torch.nn.modules.module.Module, torch.Tensor]] = None"},{name:"text_encoder_lora_layers",val:": typing.Dict[str, torch.nn.modules.module.Module] = None"},{name:"is_main_process",val:": bool = True"},{name:"weight_name",val:": str = None"},{name:"save_function",val:": typing.Callable = None"},{name:"safe_serialization",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.StableDiffusionPipeline.save_lora_weights.save_directory",description:`<strong>save_directory</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Directory to which to save. Will be created if it doesn&#x2019;t exist.`,name:"save_directory"},{anchor:"diffusers.StableDiffusionPipeline.save_lora_weights.unet_lora_layers",description:`<strong>unet_lora_layers</strong> (<code>Dict[str, torch.nn.Module]</code> or <code>Dict[str, torch.Tensor]</code>) &#x2014;
State dict of the LoRA layers corresponding to the UNet. Specifying this helps to make the
serialization process easier and cleaner. Values can be both LoRA torch.nn.Modules layers or torch
weights.`,name:"unet_lora_layers"},{anchor:"diffusers.StableDiffusionPipeline.save_lora_weights.text_encoder_lora_layers",description:"<strong>text_encoder_lora_layers</strong> (<code>Dict[str, torch.nn.Module] or </code>Dict[str, torch.Tensor]<code>) -- State dict of the LoRA layers corresponding to the </code>text_encoder<code>. Since the </code>text_encoder<code>comes from</code>transformers`, we cannot rejig it. That is why we have to explicitly pass the text encoder LoRA state\ndict. Values can be both LoRA torch.nn.Modules layers or torch weights.",name:"text_encoder_lora_layers"},{anchor:"diffusers.StableDiffusionPipeline.save_lora_weights.is_main_process",description:`<strong>is_main_process</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether the process calling this is the main process or not. Useful when in distributed training like
TPUs and need to call this function on all processes. In this case, set <code>is_main_process=True</code> only on
the main process to avoid race conditions.`,name:"is_main_process"},{anchor:"diffusers.StableDiffusionPipeline.save_lora_weights.save_function",description:`<strong>save_function</strong> (<code>Callable</code>) &#x2014;
The function to use to save the state dictionary. Useful on distributed training like TPUs when one
need to replace <code>torch.save</code> by another method. Can be configured with the environment variable
<code>DIFFUSERS_SAVE_MODE</code>.`,name:"save_function"}],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/loaders.py#L1130"}}),ht=new C({props:{name:"enable_model_cpu_offload",anchor:"diffusers.StableDiffusionPipeline.enable_model_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion.py#L242"}}),gt=new C({props:{name:"enable_sequential_cpu_offload",anchor:"diffusers.StableDiffusionPipeline.enable_sequential_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion.py#L217"}}),_t=new C({props:{name:"class diffusers.FlaxStableDiffusionPipeline",anchor:"diffusers.FlaxStableDiffusionPipeline",parameters:[{name:"vae",val:": FlaxAutoencoderKL"},{name:"text_encoder",val:": FlaxCLIPTextModel"},{name:"tokenizer",val:": CLIPTokenizer"},{name:"unet",val:": FlaxUNet2DConditionModel"},{name:"scheduler",val:": typing.Union[diffusers.schedulers.scheduling_ddim_flax.FlaxDDIMScheduler, diffusers.schedulers.scheduling_pndm_flax.FlaxPNDMScheduler, diffusers.schedulers.scheduling_lms_discrete_flax.FlaxLMSDiscreteScheduler, diffusers.schedulers.scheduling_dpmsolver_multistep_flax.FlaxDPMSolverMultistepScheduler]"},{name:"safety_checker",val:": FlaxStableDiffusionSafetyChecker"},{name:"feature_extractor",val:": CLIPImageProcessor"},{name:"dtype",val:": dtype = <class 'jax.numpy.float32'>"}],parametersDescription:[{anchor:"diffusers.FlaxStableDiffusionPipeline.vae",description:`<strong>vae</strong> (<a href="/docs/diffusers/pr_185/en/api/models#diffusers.FlaxAutoencoderKL">FlaxAutoencoderKL</a>) &#x2014;
Variational Auto-Encoder (VAE) Model to encode and decode images to and from latent representations.`,name:"vae"},{anchor:"diffusers.FlaxStableDiffusionPipeline.text_encoder",description:`<strong>text_encoder</strong> (<code>FlaxCLIPTextModel</code>) &#x2014;
Frozen text-encoder. Stable Diffusion uses the text portion of
<a href="https://huggingface.co/docs/transformers/model_doc/clip#transformers.FlaxCLIPTextModel" rel="nofollow">CLIP</a>,
specifically the <a href="https://huggingface.co/openai/clip-vit-large-patch14" rel="nofollow">clip-vit-large-patch14</a> variant.`,name:"text_encoder"},{anchor:"diffusers.FlaxStableDiffusionPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>CLIPTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/v4.21.0/en/model_doc/clip#transformers.CLIPTokenizer" rel="nofollow">CLIPTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.FlaxStableDiffusionPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/pr_185/en/api/models#diffusers.FlaxUNet2DConditionModel">FlaxUNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.FlaxStableDiffusionPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/pr_185/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<code>FlaxDDIMScheduler</code>, <code>FlaxLMSDiscreteScheduler</code>, <code>FlaxPNDMScheduler</code>, or
<code>FlaxDPMSolverMultistepScheduler</code>.`,name:"scheduler"},{anchor:"diffusers.FlaxStableDiffusionPipeline.safety_checker",description:`<strong>safety_checker</strong> (<code>FlaxStableDiffusionSafetyChecker</code>) &#x2014;
Classification module that estimates whether generated images could be considered offensive or harmful.
Please, refer to the <a href="https://huggingface.co/runwayml/stable-diffusion-v1-5" rel="nofollow">model card</a> for details.`,name:"safety_checker"},{anchor:"diffusers.FlaxStableDiffusionPipeline.feature_extractor",description:`<strong>feature_extractor</strong> (<code>CLIPImageProcessor</code>) &#x2014;
Model that extracts features from generated images to be used as inputs for the <code>safety_checker</code>.`,name:"feature_extractor"}],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/stable_diffusion/pipeline_flax_stable_diffusion.py#L81"}}),vt=new C({props:{name:"__call__",anchor:"diffusers.FlaxStableDiffusionPipeline.__call__",parameters:[{name:"prompt_ids",val:": array"},{name:"params",val:": typing.Union[typing.Dict, flax.core.frozen_dict.FrozenDict]"},{name:"prng_seed",val:": PRNGKeyArray"},{name:"num_inference_steps",val:": int = 50"},{name:"height",val:": typing.Optional[int] = None"},{name:"width",val:": typing.Optional[int] = None"},{name:"guidance_scale",val:": typing.Union[float, array] = 7.5"},{name:"latents",val:": array = None"},{name:"neg_prompt_ids",val:": array = None"},{name:"return_dict",val:": bool = True"},{name:"jit",val:": bool = False"}],parametersDescription:[{anchor:"diffusers.FlaxStableDiffusionPipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>) &#x2014;
The prompt or prompts to guide the image generation.`,name:"prompt"},{anchor:"diffusers.FlaxStableDiffusionPipeline.__call__.height",description:`<strong>height</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The height in pixels of the generated image.`,name:"height"},{anchor:"diffusers.FlaxStableDiffusionPipeline.__call__.width",description:`<strong>width</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The width in pixels of the generated image.`,name:"width"},{anchor:"diffusers.FlaxStableDiffusionPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.FlaxStableDiffusionPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.FlaxStableDiffusionPipeline.__call__.latents",description:`<strong>latents</strong> (<code>jnp.array</code>, <em>optional</em>) &#x2014;
Pre-generated noisy latents, sampled from a Gaussian distribution, to be used as inputs for image
generation. Can be used to tweak the same generation with different prompts. tensor will ge generated
by sampling using the supplied random <code>generator</code>.`,name:"latents"},{anchor:"diffusers.FlaxStableDiffusionPipeline.__call__.jit",description:`<strong>jit</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to run <code>pmap</code> versions of the generation and safety scoring functions. NOTE: This argument
exists because <code>__call__</code> is not yet end-to-end pmap-able. It will be removed in a future release.`,name:"jit"},{anchor:"diffusers.FlaxStableDiffusionPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <code>FlaxStableDiffusionPipelineOutput</code> instead of
a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/vr_185/src/diffusers/pipelines/stable_diffusion/pipeline_flax_stable_diffusion.py#L311",returnDescription:`
<p><code>FlaxStableDiffusionPipelineOutput</code> if <code>return_dict</code> is True, otherwise a
<code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><code>FlaxStableDiffusionPipelineOutput</code> or <code>tuple</code></p>
`}}),ye=new Ut({props:{anchor:"diffusers.FlaxStableDiffusionPipeline.__call__.example",$$slots:{default:[yl]},$$scope:{ctx:I}}}),{c(){d=o("meta"),b=c(),p=o("h1"),m=o("a"),x=o("span"),$(l.$$.fragment),h=c(),j=o("span"),_=a("Text-to-Image Generation"),w=c(),A=o("h2"),O=o("a"),Wt=o("span"),$(De.$$.fragment),En=c(),Gt=o("span"),Tn=a("StableDiffusionPipeline"),Ko=c(),q=o("p"),jn=a("The Stable Diffusion model was created by the researchers and engineers from "),Pe=o("a"),In=a("CompVis"),An=a(", "),ke=o("a"),Ln=a("Stability AI"),Cn=a(", "),Se=o("a"),qn=a("runway"),Mn=a(", and "),Ee=o("a"),Fn=a("LAION"),Nn=a(". The "),wt=o("a"),On=a("StableDiffusionPipeline"),Un=a(" is capable of generating photo-realistic images given any text input using Stable Diffusion."),Bo=c(),$t=o("p"),Vn=a("The original codebase can be found here:"),Ho=c(),ne=o("ul"),Te=o("li"),Rt=o("em"),zn=a("Stable Diffusion V1"),Wn=a(": "),je=o("a"),Gn=a("CompVis/stable-diffusion"),Rn=c(),Ie=o("li"),Kt=o("em"),Kn=a("Stable Diffusion v2"),Bn=a(": "),Ae=o("a"),Hn=a("Stability-AI/stablediffusion"),Xo=c(),Dt=o("p"),Xn=a("Available Checkpoints are:"),Jo=c(),M=o("ul"),Le=o("li"),Bt=o("em"),Jn=a("stable-diffusion-v1-4 (512x512 resolution)"),Qn=c(),Ce=o("a"),Yn=a("CompVis/stable-diffusion-v1-4"),Zn=c(),qe=o("li"),Ht=o("em"),ei=a("stable-diffusion-v1-5 (512x512 resolution)"),ti=c(),Me=o("a"),oi=a("runwayml/stable-diffusion-v1-5"),ni=c(),Fe=o("li"),Xt=o("em"),ii=a("stable-diffusion-2-base (512x512 resolution)"),ai=a(": "),Ne=o("a"),si=a("stabilityai/stable-diffusion-2-base"),ri=c(),Oe=o("li"),Jt=o("em"),li=a("stable-diffusion-2 (768x768 resolution)"),di=a(": "),Ue=o("a"),ci=a("stabilityai/stable-diffusion-2"),fi=c(),Ve=o("li"),Qt=o("em"),pi=a("stable-diffusion-2-1-base (512x512 resolution)"),ui=c(),ze=o("a"),mi=a("stabilityai/stable-diffusion-2-1-base"),hi=c(),We=o("li"),Yt=o("em"),gi=a("stable-diffusion-2-1 (768x768 resolution)"),_i=a(": "),Ge=o("a"),bi=a("stabilityai/stable-diffusion-2-1"),Qo=c(),g=o("div"),$(Re.$$.fragment),vi=c(),Zt=o("p"),yi=a("Pipeline for text-to-image generation using Stable Diffusion."),xi=c(),Ke=o("p"),wi=a("This model inherits from "),Pt=o("a"),$i=a("DiffusionPipeline"),Di=a(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),Pi=c(),eo=o("p"),ki=a("In addition the pipeline inherits the following loading methods:"),Si=c(),Z=o("ul"),Be=o("li"),to=o("em"),Ei=a("Textual-Inversion"),Ti=a(": "),kt=o("a"),ji=a("loaders.TextualInversionLoaderMixin.load_textual_inversion()"),Ii=c(),He=o("li"),oo=o("em"),Ai=a("LoRA"),Li=a(": "),St=o("a"),Ci=a("loaders.LoraLoaderMixin.load_lora_weights()"),qi=c(),Xe=o("li"),no=o("em"),Mi=a("Ckpt"),Fi=a(": "),Et=o("a"),Ni=a("loaders.FromCkptMixin.from_ckpt()"),Oi=c(),io=o("p"),Ui=a("as well as the following saving methods:"),Vi=c(),ao=o("ul"),Je=o("li"),so=o("em"),zi=a("LoRA"),Wi=a(": "),Tt=o("a"),Gi=a("loaders.LoraLoaderMixin.save_lora_weights()"),Ri=c(),K=o("div"),$(Qe.$$.fragment),Ki=c(),ro=o("p"),Bi=a("Function invoked when calling the pipeline for generation."),Hi=c(),$(ie.$$.fragment),Xi=c(),B=o("div"),$(Ye.$$.fragment),Ji=c(),lo=o("p"),Qi=a("Enable sliced attention computation."),Yi=c(),co=o("p"),Zi=a(`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),ea=c(),ae=o("div"),$(Ze.$$.fragment),ta=c(),et=o("p"),oa=a("Disable sliced attention computation. If "),fo=o("code"),na=a("enable_attention_slicing"),ia=a(` was previously invoked, this method will go
back to computing attention in one step.`),aa=c(),H=o("div"),$(tt.$$.fragment),sa=c(),po=o("p"),ra=a("Enable sliced VAE decoding."),la=c(),uo=o("p"),da=a(`When this option is enabled, the VAE will split the input tensor in slices to compute decoding in several
steps. This is useful to save some memory and allow larger batch sizes.`),ca=c(),se=o("div"),$(ot.$$.fragment),fa=c(),nt=o("p"),pa=a("Disable sliced VAE decoding. If "),mo=o("code"),ua=a("enable_vae_slicing"),ma=a(` was previously invoked, this method will go back to
computing decoding in one step.`),ha=c(),U=o("div"),$(it.$$.fragment),ga=c(),ho=o("p"),_a=a("Enable memory efficient attention as implemented in xformers."),ba=c(),go=o("p"),va=a(`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),ya=c(),_o=o("p"),xa=a(`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),wa=c(),$(re.$$.fragment),$a=c(),le=o("div"),$(at.$$.fragment),Da=c(),bo=o("p"),Pa=a("Disable memory efficient attention as implemented in xformers."),ka=c(),X=o("div"),$(st.$$.fragment),Sa=c(),vo=o("p"),Ea=a("Enable tiled VAE decoding."),Ta=c(),yo=o("p"),ja=a(`When this option is enabled, the VAE will split the input tensor into tiles to compute decoding and encoding in
several steps. This is useful to save a large amount of memory and to allow the processing of larger images.`),Ia=c(),de=o("div"),$(rt.$$.fragment),Aa=c(),lt=o("p"),La=a("Disable tiled VAE decoding. If "),xo=o("code"),Ca=a("enable_vae_tiling"),qa=a(` was previously invoked, this method will go back to
computing decoding in one step.`),Ma=c(),L=o("div"),$(dt.$$.fragment),Fa=c(),ee=o("p"),Na=a("Load textual inversion embeddings into the text encoder of stable diffusion pipelines. Both "),wo=o("code"),Oa=a("diffusers"),Ua=a(` and
`),$o=o("code"),Va=a("Automatic1111"),za=a(" formats are supported (see example below)."),Wa=c(),$(ce.$$.fragment),Ga=c(),$(fe.$$.fragment),Ra=c(),Do=o("p"),Ka=a("Example:"),Ba=c(),$(pe.$$.fragment),Ha=c(),Po=o("p"),Xa=a("To load a textual inversion embedding vector in Automatic1111 format, make sure to first download the vector,"),Ja=c(),$(ue.$$.fragment),Qa=c(),W=o("div"),$(ct.$$.fragment),Ya=c(),ko=o("p"),Za=a("Instantiate a PyTorch diffusion pipeline from pre-trained pipeline weights saved in the original .ckpt format."),es=c(),ft=o("p"),ts=a("The pipeline is set in evaluation mode by default using "),So=o("code"),os=a("model.eval()"),ns=a(" (Dropout modules are deactivated)."),is=c(),$(me.$$.fragment),as=c(),G=o("div"),$(pt.$$.fragment),ss=c(),te=o("p"),rs=a("Load pretrained attention processor layers (such as LoRA) into "),jt=o("a"),ls=a("UNet2DConditionModel"),ds=a(` and
`),ut=o("a"),Eo=o("code"),cs=a("CLIPTextModel"),fs=a(")."),ps=c(),$(he.$$.fragment),us=c(),$(ge.$$.fragment),ms=c(),_e=o("div"),$(mt.$$.fragment),hs=c(),To=o("p"),gs=a("Save the LoRA parameters corresponding to the UNet and the text encoder."),_s=c(),be=o("div"),$(ht.$$.fragment),bs=c(),V=o("p"),vs=a(`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),jo=o("code"),ys=a("enable_sequential_cpu_offload"),xs=a(", this method moves one whole model at a time to the GPU when its "),Io=o("code"),ws=a("forward"),$s=a(`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),Ao=o("code"),Ds=a("enable_sequential_cpu_offload"),Ps=a(", but performance is much better due to the iterative execution of the "),Lo=o("code"),ks=a("unet"),Ss=a("."),Es=c(),ve=o("div"),$(gt.$$.fragment),Ts=c(),oe=o("p"),js=a(`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae and safety checker have their state dicts saved to CPU and then are moved to a
`),Co=o("code"),Is=a("torch.device('meta') and loaded to GPU only when their specific submodule has its "),As=a("forward"),qo=o("code"),Ls=a("method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),Cs=a("enable_model_cpu_offload`, but performance is lower."),Yo=c(),z=o("div"),$(_t.$$.fragment),qs=c(),Mo=o("p"),Ms=a("Pipeline for text-to-image generation using Stable Diffusion."),Fs=c(),bt=o("p"),Ns=a("This model inherits from "),Fo=o("code"),Os=a("FlaxDiffusionPipeline"),Us=a(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),Vs=c(),J=o("div"),$(vt.$$.fragment),zs=c(),No=o("p"),Ws=a("Function invoked when calling the pipeline for generation."),Gs=c(),$(ye.$$.fragment),this.h()},l(r){const y=dl('[data-svelte="svelte-1phssyn"]',document.head);d=n(y,"META",{name:!0,content:!0}),y.forEach(t),b=f(r),p=n(r,"H1",{class:!0});var yt=i(p);m=n(yt,"A",{id:!0,class:!0,href:!0});var Oo=i(m);x=n(Oo,"SPAN",{});var Uo=i(x);D(l.$$.fragment,Uo),Uo.forEach(t),Oo.forEach(t),h=f(yt),j=n(yt,"SPAN",{});var Vo=i(j);_=s(Vo,"Text-to-Image Generation"),Vo.forEach(t),yt.forEach(t),w=f(r),A=n(r,"H2",{class:!0});var xt=i(A);O=n(xt,"A",{id:!0,class:!0,href:!0});var zo=i(O);Wt=n(zo,"SPAN",{});var Wo=i(Wt);D(De.$$.fragment,Wo),Wo.forEach(t),zo.forEach(t),En=f(xt),Gt=n(xt,"SPAN",{});var Go=i(Gt);Tn=s(Go,"StableDiffusionPipeline"),Go.forEach(t),xt.forEach(t),Ko=f(r),q=n(r,"P",{});var N=i(q);jn=s(N,"The Stable Diffusion model was created by the researchers and engineers from "),Pe=n(N,"A",{href:!0,rel:!0});var Ro=i(Pe);In=s(Ro,"CompVis"),Ro.forEach(t),An=s(N,", "),ke=n(N,"A",{href:!0,rel:!0});var Rs=i(ke);Ln=s(Rs,"Stability AI"),Rs.forEach(t),Cn=s(N,", "),Se=n(N,"A",{href:!0,rel:!0});var Ks=i(Se);qn=s(Ks,"runway"),Ks.forEach(t),Mn=s(N,", and "),Ee=n(N,"A",{href:!0,rel:!0});var Bs=i(Ee);Fn=s(Bs,"LAION"),Bs.forEach(t),Nn=s(N,". The "),wt=n(N,"A",{href:!0});var Hs=i(wt);On=s(Hs,"StableDiffusionPipeline"),Hs.forEach(t),Un=s(N," is capable of generating photo-realistic images given any text input using Stable Diffusion."),N.forEach(t),Bo=f(r),$t=n(r,"P",{});var Xs=i($t);Vn=s(Xs,"The original codebase can be found here:"),Xs.forEach(t),Ho=f(r),ne=n(r,"UL",{});var en=i(ne);Te=n(en,"LI",{});var tn=i(Te);Rt=n(tn,"EM",{});var Js=i(Rt);zn=s(Js,"Stable Diffusion V1"),Js.forEach(t),Wn=s(tn,": "),je=n(tn,"A",{href:!0,rel:!0});var Qs=i(je);Gn=s(Qs,"CompVis/stable-diffusion"),Qs.forEach(t),tn.forEach(t),Rn=f(en),Ie=n(en,"LI",{});var on=i(Ie);Kt=n(on,"EM",{});var Ys=i(Kt);Kn=s(Ys,"Stable Diffusion v2"),Ys.forEach(t),Bn=s(on,": "),Ae=n(on,"A",{href:!0,rel:!0});var Zs=i(Ae);Hn=s(Zs,"Stability-AI/stablediffusion"),Zs.forEach(t),on.forEach(t),en.forEach(t),Xo=f(r),Dt=n(r,"P",{});var er=i(Dt);Xn=s(er,"Available Checkpoints are:"),er.forEach(t),Jo=f(r),M=n(r,"UL",{});var R=i(M);Le=n(R,"LI",{});var nn=i(Le);Bt=n(nn,"EM",{});var tr=i(Bt);Jn=s(tr,"stable-diffusion-v1-4 (512x512 resolution)"),tr.forEach(t),Qn=f(nn),Ce=n(nn,"A",{href:!0,rel:!0});var or=i(Ce);Yn=s(or,"CompVis/stable-diffusion-v1-4"),or.forEach(t),nn.forEach(t),Zn=f(R),qe=n(R,"LI",{});var an=i(qe);Ht=n(an,"EM",{});var nr=i(Ht);ei=s(nr,"stable-diffusion-v1-5 (512x512 resolution)"),nr.forEach(t),ti=f(an),Me=n(an,"A",{href:!0,rel:!0});var ir=i(Me);oi=s(ir,"runwayml/stable-diffusion-v1-5"),ir.forEach(t),an.forEach(t),ni=f(R),Fe=n(R,"LI",{});var sn=i(Fe);Xt=n(sn,"EM",{});var ar=i(Xt);ii=s(ar,"stable-diffusion-2-base (512x512 resolution)"),ar.forEach(t),ai=s(sn,": "),Ne=n(sn,"A",{href:!0,rel:!0});var sr=i(Ne);si=s(sr,"stabilityai/stable-diffusion-2-base"),sr.forEach(t),sn.forEach(t),ri=f(R),Oe=n(R,"LI",{});var rn=i(Oe);Jt=n(rn,"EM",{});var rr=i(Jt);li=s(rr,"stable-diffusion-2 (768x768 resolution)"),rr.forEach(t),di=s(rn,": "),Ue=n(rn,"A",{href:!0,rel:!0});var lr=i(Ue);ci=s(lr,"stabilityai/stable-diffusion-2"),lr.forEach(t),rn.forEach(t),fi=f(R),Ve=n(R,"LI",{});var ln=i(Ve);Qt=n(ln,"EM",{});var dr=i(Qt);pi=s(dr,"stable-diffusion-2-1-base (512x512 resolution)"),dr.forEach(t),ui=f(ln),ze=n(ln,"A",{href:!0,rel:!0});var cr=i(ze);mi=s(cr,"stabilityai/stable-diffusion-2-1-base"),cr.forEach(t),ln.forEach(t),hi=f(R),We=n(R,"LI",{});var dn=i(We);Yt=n(dn,"EM",{});var fr=i(Yt);gi=s(fr,"stable-diffusion-2-1 (768x768 resolution)"),fr.forEach(t),_i=s(dn,": "),Ge=n(dn,"A",{href:!0,rel:!0});var pr=i(Ge);bi=s(pr,"stabilityai/stable-diffusion-2-1"),pr.forEach(t),dn.forEach(t),R.forEach(t),Qo=f(r),g=n(r,"DIV",{class:!0});var v=i(g);D(Re.$$.fragment,v),vi=f(v),Zt=n(v,"P",{});var ur=i(Zt);yi=s(ur,"Pipeline for text-to-image generation using Stable Diffusion."),ur.forEach(t),xi=f(v),Ke=n(v,"P",{});var cn=i(Ke);wi=s(cn,"This model inherits from "),Pt=n(cn,"A",{href:!0});var mr=i(Pt);$i=s(mr,"DiffusionPipeline"),mr.forEach(t),Di=s(cn,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),cn.forEach(t),Pi=f(v),eo=n(v,"P",{});var hr=i(eo);ki=s(hr,"In addition the pipeline inherits the following loading methods:"),hr.forEach(t),Si=f(v),Z=n(v,"UL",{});var It=i(Z);Be=n(It,"LI",{});var fn=i(Be);to=n(fn,"EM",{});var gr=i(to);Ei=s(gr,"Textual-Inversion"),gr.forEach(t),Ti=s(fn,": "),kt=n(fn,"A",{href:!0});var _r=i(kt);ji=s(_r,"loaders.TextualInversionLoaderMixin.load_textual_inversion()"),_r.forEach(t),fn.forEach(t),Ii=f(It),He=n(It,"LI",{});var pn=i(He);oo=n(pn,"EM",{});var br=i(oo);Ai=s(br,"LoRA"),br.forEach(t),Li=s(pn,": "),St=n(pn,"A",{href:!0});var vr=i(St);Ci=s(vr,"loaders.LoraLoaderMixin.load_lora_weights()"),vr.forEach(t),pn.forEach(t),qi=f(It),Xe=n(It,"LI",{});var un=i(Xe);no=n(un,"EM",{});var yr=i(no);Mi=s(yr,"Ckpt"),yr.forEach(t),Fi=s(un,": "),Et=n(un,"A",{href:!0});var xr=i(Et);Ni=s(xr,"loaders.FromCkptMixin.from_ckpt()"),xr.forEach(t),un.forEach(t),It.forEach(t),Oi=f(v),io=n(v,"P",{});var wr=i(io);Ui=s(wr,"as well as the following saving methods:"),wr.forEach(t),Vi=f(v),ao=n(v,"UL",{});var $r=i(ao);Je=n($r,"LI",{});var mn=i(Je);so=n(mn,"EM",{});var Dr=i(so);zi=s(Dr,"LoRA"),Dr.forEach(t),Wi=s(mn,": "),Tt=n(mn,"A",{href:!0});var Pr=i(Tt);Gi=s(Pr,"loaders.LoraLoaderMixin.save_lora_weights()"),Pr.forEach(t),mn.forEach(t),$r.forEach(t),Ri=f(v),K=n(v,"DIV",{class:!0});var At=i(K);D(Qe.$$.fragment,At),Ki=f(At),ro=n(At,"P",{});var kr=i(ro);Bi=s(kr,"Function invoked when calling the pipeline for generation."),kr.forEach(t),Hi=f(At),D(ie.$$.fragment,At),At.forEach(t),Xi=f(v),B=n(v,"DIV",{class:!0});var Lt=i(B);D(Ye.$$.fragment,Lt),Ji=f(Lt),lo=n(Lt,"P",{});var Sr=i(lo);Qi=s(Sr,"Enable sliced attention computation."),Sr.forEach(t),Yi=f(Lt),co=n(Lt,"P",{});var Er=i(co);Zi=s(Er,`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),Er.forEach(t),Lt.forEach(t),ea=f(v),ae=n(v,"DIV",{class:!0});var hn=i(ae);D(Ze.$$.fragment,hn),ta=f(hn),et=n(hn,"P",{});var gn=i(et);oa=s(gn,"Disable sliced attention computation. If "),fo=n(gn,"CODE",{});var Tr=i(fo);na=s(Tr,"enable_attention_slicing"),Tr.forEach(t),ia=s(gn,` was previously invoked, this method will go
back to computing attention in one step.`),gn.forEach(t),hn.forEach(t),aa=f(v),H=n(v,"DIV",{class:!0});var Ct=i(H);D(tt.$$.fragment,Ct),sa=f(Ct),po=n(Ct,"P",{});var jr=i(po);ra=s(jr,"Enable sliced VAE decoding."),jr.forEach(t),la=f(Ct),uo=n(Ct,"P",{});var Ir=i(uo);da=s(Ir,`When this option is enabled, the VAE will split the input tensor in slices to compute decoding in several
steps. This is useful to save some memory and allow larger batch sizes.`),Ir.forEach(t),Ct.forEach(t),ca=f(v),se=n(v,"DIV",{class:!0});var _n=i(se);D(ot.$$.fragment,_n),fa=f(_n),nt=n(_n,"P",{});var bn=i(nt);pa=s(bn,"Disable sliced VAE decoding. If "),mo=n(bn,"CODE",{});var Ar=i(mo);ua=s(Ar,"enable_vae_slicing"),Ar.forEach(t),ma=s(bn,` was previously invoked, this method will go back to
computing decoding in one step.`),bn.forEach(t),_n.forEach(t),ha=f(v),U=n(v,"DIV",{class:!0});var Q=i(U);D(it.$$.fragment,Q),ga=f(Q),ho=n(Q,"P",{});var Lr=i(ho);_a=s(Lr,"Enable memory efficient attention as implemented in xformers."),Lr.forEach(t),ba=f(Q),go=n(Q,"P",{});var Cr=i(go);va=s(Cr,`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),Cr.forEach(t),ya=f(Q),_o=n(Q,"P",{});var qr=i(_o);xa=s(qr,`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),qr.forEach(t),wa=f(Q),D(re.$$.fragment,Q),Q.forEach(t),$a=f(v),le=n(v,"DIV",{class:!0});var vn=i(le);D(at.$$.fragment,vn),Da=f(vn),bo=n(vn,"P",{});var Mr=i(bo);Pa=s(Mr,"Disable memory efficient attention as implemented in xformers."),Mr.forEach(t),vn.forEach(t),ka=f(v),X=n(v,"DIV",{class:!0});var qt=i(X);D(st.$$.fragment,qt),Sa=f(qt),vo=n(qt,"P",{});var Fr=i(vo);Ea=s(Fr,"Enable tiled VAE decoding."),Fr.forEach(t),Ta=f(qt),yo=n(qt,"P",{});var Nr=i(yo);ja=s(Nr,`When this option is enabled, the VAE will split the input tensor into tiles to compute decoding and encoding in
several steps. This is useful to save a large amount of memory and to allow the processing of larger images.`),Nr.forEach(t),qt.forEach(t),Ia=f(v),de=n(v,"DIV",{class:!0});var yn=i(de);D(rt.$$.fragment,yn),Aa=f(yn),lt=n(yn,"P",{});var xn=i(lt);La=s(xn,"Disable tiled VAE decoding. If "),xo=n(xn,"CODE",{});var Or=i(xo);Ca=s(Or,"enable_vae_tiling"),Or.forEach(t),qa=s(xn,` was previously invoked, this method will go back to
computing decoding in one step.`),xn.forEach(t),yn.forEach(t),Ma=f(v),L=n(v,"DIV",{class:!0});var F=i(L);D(dt.$$.fragment,F),Fa=f(F),ee=n(F,"P",{});var Mt=i(ee);Na=s(Mt,"Load textual inversion embeddings into the text encoder of stable diffusion pipelines. Both "),wo=n(Mt,"CODE",{});var Ur=i(wo);Oa=s(Ur,"diffusers"),Ur.forEach(t),Ua=s(Mt,` and
`),$o=n(Mt,"CODE",{});var Vr=i($o);Va=s(Vr,"Automatic1111"),Vr.forEach(t),za=s(Mt," formats are supported (see example below)."),Mt.forEach(t),Wa=f(F),D(ce.$$.fragment,F),Ga=f(F),D(fe.$$.fragment,F),Ra=f(F),Do=n(F,"P",{});var zr=i(Do);Ka=s(zr,"Example:"),zr.forEach(t),Ba=f(F),D(pe.$$.fragment,F),Ha=f(F),Po=n(F,"P",{});var Wr=i(Po);Xa=s(Wr,"To load a textual inversion embedding vector in Automatic1111 format, make sure to first download the vector,"),Wr.forEach(t),Ja=f(F),D(ue.$$.fragment,F),F.forEach(t),Qa=f(v),W=n(v,"DIV",{class:!0});var xe=i(W);D(ct.$$.fragment,xe),Ya=f(xe),ko=n(xe,"P",{});var Gr=i(ko);Za=s(Gr,"Instantiate a PyTorch diffusion pipeline from pre-trained pipeline weights saved in the original .ckpt format."),Gr.forEach(t),es=f(xe),ft=n(xe,"P",{});var wn=i(ft);ts=s(wn,"The pipeline is set in evaluation mode by default using "),So=n(wn,"CODE",{});var Rr=i(So);os=s(Rr,"model.eval()"),Rr.forEach(t),ns=s(wn," (Dropout modules are deactivated)."),wn.forEach(t),is=f(xe),D(me.$$.fragment,xe),xe.forEach(t),as=f(v),G=n(v,"DIV",{class:!0});var we=i(G);D(pt.$$.fragment,we),ss=f(we),te=n(we,"P",{});var Ft=i(te);rs=s(Ft,"Load pretrained attention processor layers (such as LoRA) into "),jt=n(Ft,"A",{href:!0});var Kr=i(jt);ls=s(Kr,"UNet2DConditionModel"),Kr.forEach(t),ds=s(Ft,` and
`),ut=n(Ft,"A",{href:!0,rel:!0});var Br=i(ut);Eo=n(Br,"CODE",{});var Hr=i(Eo);cs=s(Hr,"CLIPTextModel"),Hr.forEach(t),Br.forEach(t),fs=s(Ft,")."),Ft.forEach(t),ps=f(we),D(he.$$.fragment,we),us=f(we),D(ge.$$.fragment,we),we.forEach(t),ms=f(v),_e=n(v,"DIV",{class:!0});var $n=i(_e);D(mt.$$.fragment,$n),hs=f($n),To=n($n,"P",{});var Xr=i(To);gs=s(Xr,"Save the LoRA parameters corresponding to the UNet and the text encoder."),Xr.forEach(t),$n.forEach(t),_s=f(v),be=n(v,"DIV",{class:!0});var Dn=i(be);D(ht.$$.fragment,Dn),bs=f(Dn),V=n(Dn,"P",{});var Y=i(V);vs=s(Y,`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),jo=n(Y,"CODE",{});var Jr=i(jo);ys=s(Jr,"enable_sequential_cpu_offload"),Jr.forEach(t),xs=s(Y,", this method moves one whole model at a time to the GPU when its "),Io=n(Y,"CODE",{});var Qr=i(Io);ws=s(Qr,"forward"),Qr.forEach(t),$s=s(Y,`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),Ao=n(Y,"CODE",{});var Yr=i(Ao);Ds=s(Yr,"enable_sequential_cpu_offload"),Yr.forEach(t),Ps=s(Y,", but performance is much better due to the iterative execution of the "),Lo=n(Y,"CODE",{});var Zr=i(Lo);ks=s(Zr,"unet"),Zr.forEach(t),Ss=s(Y,"."),Y.forEach(t),Dn.forEach(t),Es=f(v),ve=n(v,"DIV",{class:!0});var Pn=i(ve);D(gt.$$.fragment,Pn),Ts=f(Pn),oe=n(Pn,"P",{});var Nt=i(oe);js=s(Nt,`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae and safety checker have their state dicts saved to CPU and then are moved to a
`),Co=n(Nt,"CODE",{});var el=i(Co);Is=s(el,"torch.device('meta') and loaded to GPU only when their specific submodule has its "),el.forEach(t),As=s(Nt,"forward"),qo=n(Nt,"CODE",{});var tl=i(qo);Ls=s(tl,"method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),tl.forEach(t),Cs=s(Nt,"enable_model_cpu_offload`, but performance is lower."),Nt.forEach(t),Pn.forEach(t),v.forEach(t),Yo=f(r),z=n(r,"DIV",{class:!0});var $e=i(z);D(_t.$$.fragment,$e),qs=f($e),Mo=n($e,"P",{});var ol=i(Mo);Ms=s(ol,"Pipeline for text-to-image generation using Stable Diffusion."),ol.forEach(t),Fs=f($e),bt=n($e,"P",{});var kn=i(bt);Ns=s(kn,"This model inherits from "),Fo=n(kn,"CODE",{});var nl=i(Fo);Os=s(nl,"FlaxDiffusionPipeline"),nl.forEach(t),Us=s(kn,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),kn.forEach(t),Vs=f($e),J=n($e,"DIV",{class:!0});var Ot=i(J);D(vt.$$.fragment,Ot),zs=f(Ot),No=n(Ot,"P",{});var il=i(No);Ws=s(il,"Function invoked when calling the pipeline for generation."),il.forEach(t),Gs=f(Ot),D(ye.$$.fragment,Ot),Ot.forEach(t),$e.forEach(t),this.h()},h(){u(d,"name","hf:doc:metadata"),u(d,"content",JSON.stringify(wl)),u(m,"id","texttoimage-generation"),u(m,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(m,"href","#texttoimage-generation"),u(p,"class","relative group"),u(O,"id","diffusers.StableDiffusionPipeline"),u(O,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(O,"href","#diffusers.StableDiffusionPipeline"),u(A,"class","relative group"),u(Pe,"href","https://github.com/CompVis"),u(Pe,"rel","nofollow"),u(ke,"href","https://stability.ai/"),u(ke,"rel","nofollow"),u(Se,"href","https://github.com/runwayml"),u(Se,"rel","nofollow"),u(Ee,"href","https://laion.ai/"),u(Ee,"rel","nofollow"),u(wt,"href","/docs/diffusers/pr_185/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline"),u(je,"href","https://github.com/CompVis/stable-diffusion"),u(je,"rel","nofollow"),u(Ae,"href","https://github.com/Stability-AI/stablediffusion"),u(Ae,"rel","nofollow"),u(Ce,"href","https://huggingface.co/CompVis/stable-diffusion-v1-4"),u(Ce,"rel","nofollow"),u(Me,"href","https://huggingface.co/runwayml/stable-diffusion-v1-5"),u(Me,"rel","nofollow"),u(Ne,"href","https://huggingface.co/stabilityai/stable-diffusion-2-base"),u(Ne,"rel","nofollow"),u(Ue,"href","https://huggingface.co/stabilityai/stable-diffusion-2"),u(Ue,"rel","nofollow"),u(ze,"href","https://huggingface.co/stabilityai/stable-diffusion-2-1-base"),u(ze,"rel","nofollow"),u(Ge,"href","https://huggingface.co/stabilityai/stable-diffusion-2-1"),u(Ge,"rel","nofollow"),u(Pt,"href","/docs/diffusers/pr_185/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),u(kt,"href","/docs/diffusers/pr_185/en/api/pipelines/stable_diffusion/controlnet#diffusers.StableDiffusionControlNetPipeline.load_textual_inversion"),u(St,"href","/docs/diffusers/pr_185/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline.load_lora_weights"),u(Et,"href","/docs/diffusers/pr_185/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline.from_ckpt"),u(Tt,"href","/docs/diffusers/pr_185/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline.save_lora_weights"),u(K,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),u(B,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),u(ae,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),u(H,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),u(se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),u(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),u(le,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),u(X,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),u(de,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),u(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),u(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),u(jt,"href","/docs/diffusers/pr_185/en/api/models#diffusers.UNet2DConditionModel"),u(ut,"href","https://huggingface.co/docs/transformers/model_doc/clip#transformers.CLIPTextModel"),u(ut,"rel","nofollow"),u(G,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),u(_e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),u(be,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),u(ve,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),u(g,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),u(J,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),u(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(r,y){e(document.head,d),T(r,b,y),T(r,p,y),e(p,m),e(m,x),P(l,x,null),e(p,h),e(p,j),e(j,_),T(r,w,y),T(r,A,y),e(A,O),e(O,Wt),P(De,Wt,null),e(A,En),e(A,Gt),e(Gt,Tn),T(r,Ko,y),T(r,q,y),e(q,jn),e(q,Pe),e(Pe,In),e(q,An),e(q,ke),e(ke,Ln),e(q,Cn),e(q,Se),e(Se,qn),e(q,Mn),e(q,Ee),e(Ee,Fn),e(q,Nn),e(q,wt),e(wt,On),e(q,Un),T(r,Bo,y),T(r,$t,y),e($t,Vn),T(r,Ho,y),T(r,ne,y),e(ne,Te),e(Te,Rt),e(Rt,zn),e(Te,Wn),e(Te,je),e(je,Gn),e(ne,Rn),e(ne,Ie),e(Ie,Kt),e(Kt,Kn),e(Ie,Bn),e(Ie,Ae),e(Ae,Hn),T(r,Xo,y),T(r,Dt,y),e(Dt,Xn),T(r,Jo,y),T(r,M,y),e(M,Le),e(Le,Bt),e(Bt,Jn),e(Le,Qn),e(Le,Ce),e(Ce,Yn),e(M,Zn),e(M,qe),e(qe,Ht),e(Ht,ei),e(qe,ti),e(qe,Me),e(Me,oi),e(M,ni),e(M,Fe),e(Fe,Xt),e(Xt,ii),e(Fe,ai),e(Fe,Ne),e(Ne,si),e(M,ri),e(M,Oe),e(Oe,Jt),e(Jt,li),e(Oe,di),e(Oe,Ue),e(Ue,ci),e(M,fi),e(M,Ve),e(Ve,Qt),e(Qt,pi),e(Ve,ui),e(Ve,ze),e(ze,mi),e(M,hi),e(M,We),e(We,Yt),e(Yt,gi),e(We,_i),e(We,Ge),e(Ge,bi),T(r,Qo,y),T(r,g,y),P(Re,g,null),e(g,vi),e(g,Zt),e(Zt,yi),e(g,xi),e(g,Ke),e(Ke,wi),e(Ke,Pt),e(Pt,$i),e(Ke,Di),e(g,Pi),e(g,eo),e(eo,ki),e(g,Si),e(g,Z),e(Z,Be),e(Be,to),e(to,Ei),e(Be,Ti),e(Be,kt),e(kt,ji),e(Z,Ii),e(Z,He),e(He,oo),e(oo,Ai),e(He,Li),e(He,St),e(St,Ci),e(Z,qi),e(Z,Xe),e(Xe,no),e(no,Mi),e(Xe,Fi),e(Xe,Et),e(Et,Ni),e(g,Oi),e(g,io),e(io,Ui),e(g,Vi),e(g,ao),e(ao,Je),e(Je,so),e(so,zi),e(Je,Wi),e(Je,Tt),e(Tt,Gi),e(g,Ri),e(g,K),P(Qe,K,null),e(K,Ki),e(K,ro),e(ro,Bi),e(K,Hi),P(ie,K,null),e(g,Xi),e(g,B),P(Ye,B,null),e(B,Ji),e(B,lo),e(lo,Qi),e(B,Yi),e(B,co),e(co,Zi),e(g,ea),e(g,ae),P(Ze,ae,null),e(ae,ta),e(ae,et),e(et,oa),e(et,fo),e(fo,na),e(et,ia),e(g,aa),e(g,H),P(tt,H,null),e(H,sa),e(H,po),e(po,ra),e(H,la),e(H,uo),e(uo,da),e(g,ca),e(g,se),P(ot,se,null),e(se,fa),e(se,nt),e(nt,pa),e(nt,mo),e(mo,ua),e(nt,ma),e(g,ha),e(g,U),P(it,U,null),e(U,ga),e(U,ho),e(ho,_a),e(U,ba),e(U,go),e(go,va),e(U,ya),e(U,_o),e(_o,xa),e(U,wa),P(re,U,null),e(g,$a),e(g,le),P(at,le,null),e(le,Da),e(le,bo),e(bo,Pa),e(g,ka),e(g,X),P(st,X,null),e(X,Sa),e(X,vo),e(vo,Ea),e(X,Ta),e(X,yo),e(yo,ja),e(g,Ia),e(g,de),P(rt,de,null),e(de,Aa),e(de,lt),e(lt,La),e(lt,xo),e(xo,Ca),e(lt,qa),e(g,Ma),e(g,L),P(dt,L,null),e(L,Fa),e(L,ee),e(ee,Na),e(ee,wo),e(wo,Oa),e(ee,Ua),e(ee,$o),e($o,Va),e(ee,za),e(L,Wa),P(ce,L,null),e(L,Ga),P(fe,L,null),e(L,Ra),e(L,Do),e(Do,Ka),e(L,Ba),P(pe,L,null),e(L,Ha),e(L,Po),e(Po,Xa),e(L,Ja),P(ue,L,null),e(g,Qa),e(g,W),P(ct,W,null),e(W,Ya),e(W,ko),e(ko,Za),e(W,es),e(W,ft),e(ft,ts),e(ft,So),e(So,os),e(ft,ns),e(W,is),P(me,W,null),e(g,as),e(g,G),P(pt,G,null),e(G,ss),e(G,te),e(te,rs),e(te,jt),e(jt,ls),e(te,ds),e(te,ut),e(ut,Eo),e(Eo,cs),e(te,fs),e(G,ps),P(he,G,null),e(G,us),P(ge,G,null),e(g,ms),e(g,_e),P(mt,_e,null),e(_e,hs),e(_e,To),e(To,gs),e(g,_s),e(g,be),P(ht,be,null),e(be,bs),e(be,V),e(V,vs),e(V,jo),e(jo,ys),e(V,xs),e(V,Io),e(Io,ws),e(V,$s),e(V,Ao),e(Ao,Ds),e(V,Ps),e(V,Lo),e(Lo,ks),e(V,Ss),e(g,Es),e(g,ve),P(gt,ve,null),e(ve,Ts),e(ve,oe),e(oe,js),e(oe,Co),e(Co,Is),e(oe,As),e(oe,qo),e(qo,Ls),e(oe,Cs),T(r,Yo,y),T(r,z,y),P(_t,z,null),e(z,qs),e(z,Mo),e(Mo,Ms),e(z,Fs),e(z,bt),e(bt,Ns),e(bt,Fo),e(Fo,Os),e(bt,Us),e(z,Vs),e(z,J),P(vt,J,null),e(J,zs),e(J,No),e(No,Ws),e(J,Gs),P(ye,J,null),Zo=!0},p(r,[y]){const yt={};y&2&&(yt.$$scope={dirty:y,ctx:r}),ie.$set(yt);const Oo={};y&2&&(Oo.$$scope={dirty:y,ctx:r}),re.$set(Oo);const Uo={};y&2&&(Uo.$$scope={dirty:y,ctx:r}),ce.$set(Uo);const Vo={};y&2&&(Vo.$$scope={dirty:y,ctx:r}),fe.$set(Vo);const xt={};y&2&&(xt.$$scope={dirty:y,ctx:r}),pe.$set(xt);const zo={};y&2&&(zo.$$scope={dirty:y,ctx:r}),ue.$set(zo);const Wo={};y&2&&(Wo.$$scope={dirty:y,ctx:r}),me.$set(Wo);const Go={};y&2&&(Go.$$scope={dirty:y,ctx:r}),he.$set(Go);const N={};y&2&&(N.$$scope={dirty:y,ctx:r}),ge.$set(N);const Ro={};y&2&&(Ro.$$scope={dirty:y,ctx:r}),ye.$set(Ro)},i(r){Zo||(k(l.$$.fragment,r),k(De.$$.fragment,r),k(Re.$$.fragment,r),k(Qe.$$.fragment,r),k(ie.$$.fragment,r),k(Ye.$$.fragment,r),k(Ze.$$.fragment,r),k(tt.$$.fragment,r),k(ot.$$.fragment,r),k(it.$$.fragment,r),k(re.$$.fragment,r),k(at.$$.fragment,r),k(st.$$.fragment,r),k(rt.$$.fragment,r),k(dt.$$.fragment,r),k(ce.$$.fragment,r),k(fe.$$.fragment,r),k(pe.$$.fragment,r),k(ue.$$.fragment,r),k(ct.$$.fragment,r),k(me.$$.fragment,r),k(pt.$$.fragment,r),k(he.$$.fragment,r),k(ge.$$.fragment,r),k(mt.$$.fragment,r),k(ht.$$.fragment,r),k(gt.$$.fragment,r),k(_t.$$.fragment,r),k(vt.$$.fragment,r),k(ye.$$.fragment,r),Zo=!0)},o(r){S(l.$$.fragment,r),S(De.$$.fragment,r),S(Re.$$.fragment,r),S(Qe.$$.fragment,r),S(ie.$$.fragment,r),S(Ye.$$.fragment,r),S(Ze.$$.fragment,r),S(tt.$$.fragment,r),S(ot.$$.fragment,r),S(it.$$.fragment,r),S(re.$$.fragment,r),S(at.$$.fragment,r),S(st.$$.fragment,r),S(rt.$$.fragment,r),S(dt.$$.fragment,r),S(ce.$$.fragment,r),S(fe.$$.fragment,r),S(pe.$$.fragment,r),S(ue.$$.fragment,r),S(ct.$$.fragment,r),S(me.$$.fragment,r),S(pt.$$.fragment,r),S(he.$$.fragment,r),S(ge.$$.fragment,r),S(mt.$$.fragment,r),S(ht.$$.fragment,r),S(gt.$$.fragment,r),S(_t.$$.fragment,r),S(vt.$$.fragment,r),S(ye.$$.fragment,r),Zo=!1},d(r){t(d),r&&t(b),r&&t(p),E(l),r&&t(w),r&&t(A),E(De),r&&t(Ko),r&&t(q),r&&t(Bo),r&&t($t),r&&t(Ho),r&&t(ne),r&&t(Xo),r&&t(Dt),r&&t(Jo),r&&t(M),r&&t(Qo),r&&t(g),E(Re),E(Qe),E(ie),E(Ye),E(Ze),E(tt),E(ot),E(it),E(re),E(at),E(st),E(rt),E(dt),E(ce),E(fe),E(pe),E(ue),E(ct),E(me),E(pt),E(he),E(ge),E(mt),E(ht),E(gt),r&&t(Yo),r&&t(z),E(_t),E(vt),E(ye)}}}const wl={local:"texttoimage-generation",sections:[{local:"diffusers.StableDiffusionPipeline",title:"StableDiffusionPipeline"}],title:"Text-to-Image Generation"};function $l(I){return cl(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class jl extends sl{constructor(d){super();rl(this,d,$l,xl,ll,{})}}export{jl as default,wl as metadata};
