import{S as zo,i as Wo,s as Yo,e as r,k as m,w,t as s,M as Vo,c as n,d as t,m as d,a as i,x as v,h as o,b as u,G as a,g as h,y,q as b,o as k,B as x,v as Jo,L as Fa}from"../../chunks/vendor-hf-doc-builder.js";import{T as Go}from"../../chunks/Tip-hf-doc-builder.js";import{I as Fe}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as ve}from"../../chunks/CodeBlock-hf-doc-builder.js";import{F as Bo,M as Ca}from"../../chunks/Markdown-hf-doc-builder.js";function Ko(O){let p,g;return{c(){p=r("p"),g=s("The text-to-image fine-tuning script is experimental. It\u2019s easy to overfit and run into issues like catastrophic forgetting. We recommend you explore different hyperparameters to get the best results on your dataset.")},l(l){p=n(l,"P",{});var $=i(p);g=o($,"The text-to-image fine-tuning script is experimental. It\u2019s easy to overfit and run into issues like catastrophic forgetting. We recommend you explore different hyperparameters to get the best results on your dataset."),$.forEach(t)},m(l,$){h(l,p,$),a(p,g)},d(l){l&&t(p)}}}function Xo(O){let p,g,l,$,P,I,ne,ce,me,T,G,M,C,de,L,Z,ee,_e,V,te,ge,N,ae,S,B,z,W,U,ie,A,ye,D,le,se,J,H,ke,K,F,X,pe,R,oe,Q;return te=new ve({props:{code:`\`\`\`bash
export MODEL_NAME="CompVis/stable-diffusion-v1-4"
export dataset_name="lambdalabs/pokemon-blip-captions"

accelerate launch --mixed_precision="fp16"  train_text_to_image.py \\
  --pretrained_model_name_or_path=$MODEL_NAME \\
  --dataset_name=$dataset_name \\
  --use_ema \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=4 \\
  --gradient_checkpointing \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --lr_scheduler="constant" --lr_warmup_steps=0 \\
  --output_dir="sd-pokemon-model" `,highlighted:`\`\`\`bash
<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
<span class="hljs-built_in">export</span> dataset_name=<span class="hljs-string">&quot;lambdalabs/pokemon-blip-captions&quot;</span>

accelerate launch --mixed_precision=<span class="hljs-string">&quot;fp16&quot;</span>  train_text_to_image.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span> \\
  --dataset_name=<span class="hljs-variable">$dataset_name</span> \\
  --use_ema \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=4 \\
  --gradient_checkpointing \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --lr_scheduler=<span class="hljs-string">&quot;constant&quot;</span> --lr_warmup_steps=0 \\
  --output_dir=<span class="hljs-string">&quot;sd-pokemon-model&quot;</span> `}}),N=new ve({props:{code:`
To finetune on your own dataset, prepare the dataset according to the format required by \u{1F917} [Datasets](https://huggingface.co/docs/datasets/index). You can [upload your dataset to the Hub](https://huggingface.co/docs/datasets/image_dataset#upload-dataset-to-the-hub), or you can [prepare a local folder with your files](https://huggingface.co/docs/datasets/image_dataset#imagefolder).

Modify the script if you want to use custom loading logic. We left pointers in the code in the appropriate places to help you. \u{1F917} The example script below shows how to finetune on a local dataset in \`TRAIN_DIR\` and where to save the model to in \`OUTPUT_DIR\`:

\`\`\`bash
export MODEL_NAME="CompVis/stable-diffusion-v1-4"
export TRAIN_DIR="path_to_your_dataset"
export OUTPUT_DIR="path_to_save_model"

accelerate launch train_text_to_image.py \\
  --pretrained_model_name_or_path=$MODEL_NAME \\
  --train_data_dir=$TRAIN_DIR \\
  --use_ema \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=4 \\
  --gradient_checkpointing \\
  --mixed_precision="fp16" \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --lr_scheduler="constant" --lr_warmup_steps=0 \\
  --output_dir=\${OUTPUT_DIR}`,highlighted:`
<span class="hljs-keyword">To</span> finetune <span class="hljs-keyword">on</span> your own dataset, <span class="hljs-keyword">prepare</span> the dataset according <span class="hljs-keyword">to</span> the <span class="hljs-keyword">format</span> required <span class="hljs-keyword">by</span> \u{1F917} [Datasets](https://huggingface.co/docs/datasets/<span class="hljs-keyword">index</span>). You can [upload your dataset <span class="hljs-keyword">to</span> the Hub](https://huggingface.co/docs/datasets/image_dataset#upload-dataset-<span class="hljs-keyword">to</span>-the-hub), <span class="hljs-keyword">or</span> you can [<span class="hljs-keyword">prepare</span> a <span class="hljs-keyword">local</span> folder <span class="hljs-keyword">with</span> your files](https://huggingface.co/docs/datasets/image_dataset#imagefolder).

Modify the script <span class="hljs-keyword">if</span> you want <span class="hljs-keyword">to</span> use custom loading logic. We left pointers <span class="hljs-keyword">in</span> the code <span class="hljs-keyword">in</span> the appropriate places <span class="hljs-keyword">to</span> help you. \u{1F917} The example script below shows how <span class="hljs-keyword">to</span> finetune <span class="hljs-keyword">on</span> a <span class="hljs-keyword">local</span> dataset <span class="hljs-keyword">in</span> \`TRAIN_DIR\` <span class="hljs-keyword">and</span> <span class="hljs-keyword">where</span> <span class="hljs-keyword">to</span> save the model <span class="hljs-keyword">to</span> <span class="hljs-keyword">in</span> \`OUTPUT_DIR\`:

\`\`\`bash
export MODEL_NAME=&quot;CompVis/stable-diffusion-v1-4&quot;
export TRAIN_DIR=&quot;path_to_your_dataset&quot;
export OUTPUT_DIR=&quot;path_to_save_model&quot;

accelerate launch train_text_to_image.py \\
  <span class="hljs-comment">--pretrained_model_name_or_path=$MODEL_NAME \\</span>
  <span class="hljs-comment">--train_data_dir=$TRAIN_DIR \\</span>
  <span class="hljs-comment">--use_ema \\</span>
  <span class="hljs-comment">--resolution=512 --center_crop --random_flip \\</span>
  <span class="hljs-comment">--train_batch_size=1 \\</span>
  <span class="hljs-comment">--gradient_accumulation_steps=4 \\</span>
  <span class="hljs-comment">--gradient_checkpointing \\</span>
  <span class="hljs-comment">--mixed_precision=&quot;fp16&quot; \\</span>
  <span class="hljs-comment">--max_train_steps=15000 \\</span>
  <span class="hljs-comment">--learning_rate=1e-05 \\</span>
  <span class="hljs-comment">--max_grad_norm=1 \\</span>
  <span class="hljs-comment">--lr_scheduler=&quot;constant&quot; --lr_warmup_steps=0 \\</span>
  <span class="hljs-comment">--output_dir=\${OUTPUT_DIR}</span>`}}),W=new Fe({}),oe=new ve({props:{code:`export MODEL_NAME="CompVis/stable-diffusion-v1-4"
export dataset_name="lambdalabs/pokemon-blip-captions"

accelerate launch --mixed_precision="fp16" --multi_gpu  train_text_to_image.py \\
  --pretrained_model_name_or_path=$MODEL_NAME \\
  --dataset_name=$dataset_name \\
  --use_ema \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=4 \\
  --gradient_checkpointing \\
  --max_train_steps=15000 \\ 
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --lr_scheduler="constant" --lr_warmup_steps=0 \\
  --output_dir="sd-pokemon-model" `,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;CompVis/stable-diffusion-v1-4&quot;</span>
<span class="hljs-built_in">export</span> dataset_name=<span class="hljs-string">&quot;lambdalabs/pokemon-blip-captions&quot;</span>

accelerate launch --mixed_precision=<span class="hljs-string">&quot;fp16&quot;</span> --multi_gpu  train_text_to_image.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span> \\
  --dataset_name=<span class="hljs-variable">$dataset_name</span> \\
  --use_ema \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --gradient_accumulation_steps=4 \\
  --gradient_checkpointing \\
  --max_train_steps=15000 \\ 
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --lr_scheduler=<span class="hljs-string">&quot;constant&quot;</span> --lr_warmup_steps=0 \\
  --output_dir=<span class="hljs-string">&quot;sd-pokemon-model&quot;</span> `}}),{c(){p=r("p"),g=s("Launch the "),l=r("a"),$=s("PyTorch training script"),P=s(" for a fine-tuning run on the "),I=r("a"),ne=s("Pok\xE9mon BLIP captions"),ce=s(" dataset like this."),me=m(),T=r("p"),G=s("Specify the "),M=r("code"),C=s("MODEL_NAME"),de=s(" environment variable (either a Hub model repository id or a path to the directory containing the model weights) and pass it to the "),L=r("a"),Z=r("code"),ee=s("pretrained_model_name_or_path"),_e=s(" argument."),V=m(),w(te.$$.fragment),ge=m(),w(N.$$.fragment),ae=m(),S=r("h4"),B=r("a"),z=r("span"),w(W.$$.fragment),U=m(),ie=r("span"),A=s("Training with multiple GPUs"),ye=m(),D=r("p"),le=r("code"),se=s("accelerate"),J=s(" allows for seamless multi-GPU training. Follow the instructions "),H=r("a"),ke=s("here"),K=s(`
for running distributed training with `),F=r("code"),X=s("accelerate"),pe=s(". Here is an example command:"),R=m(),w(oe.$$.fragment),this.h()},l(_){p=n(_,"P",{});var E=i(p);g=o(E,"Launch the "),l=n(E,"A",{href:!0,rel:!0});var q=i(l);$=o(q,"PyTorch training script"),q.forEach(t),P=o(E," for a fine-tuning run on the "),I=n(E,"A",{href:!0,rel:!0});var he=i(I);ne=o(he,"Pok\xE9mon BLIP captions"),he.forEach(t),ce=o(E," dataset like this."),E.forEach(t),me=d(_),T=n(_,"P",{});var Y=i(T);G=o(Y,"Specify the "),M=n(Y,"CODE",{});var c=i(M);C=o(c,"MODEL_NAME"),c.forEach(t),de=o(Y," environment variable (either a Hub model repository id or a path to the directory containing the model weights) and pass it to the "),L=n(Y,"A",{href:!0,rel:!0});var j=i(L);Z=n(j,"CODE",{});var xe=i(Z);ee=o(xe,"pretrained_model_name_or_path"),xe.forEach(t),j.forEach(t),_e=o(Y," argument."),Y.forEach(t),V=d(_),v(te.$$.fragment,_),ge=d(_),v(N.$$.fragment,_),ae=d(_),S=n(_,"H4",{class:!0});var Ee=i(S);B=n(Ee,"A",{id:!0,class:!0,href:!0});var $e=i(B);z=n($e,"SPAN",{});var je=i(z);v(W.$$.fragment,je),je.forEach(t),$e.forEach(t),U=d(Ee),ie=n(Ee,"SPAN",{});var Me=i(ie);A=o(Me,"Training with multiple GPUs"),Me.forEach(t),Ee.forEach(t),ye=d(_),D=n(_,"P",{});var fe=i(D);le=n(fe,"CODE",{});var ue=i(le);se=o(ue,"accelerate"),ue.forEach(t),J=o(fe," allows for seamless multi-GPU training. Follow the instructions "),H=n(fe,"A",{href:!0,rel:!0});var Ne=i(H);ke=o(Ne,"here"),Ne.forEach(t),K=o(fe,`
for running distributed training with `),F=n(fe,"CODE",{});var re=i(F);X=o(re,"accelerate"),re.forEach(t),pe=o(fe,". Here is an example command:"),fe.forEach(t),R=d(_),v(oe.$$.fragment,_),this.h()},h(){u(l,"href","https://github.com/huggingface/diffusers/blob/main/examples/text_to_image/train_text_to_image.py"),u(l,"rel","nofollow"),u(I,"href","https://huggingface.co/datasets/lambdalabs/pokemon-blip-captions"),u(I,"rel","nofollow"),u(L,"href","https://huggingface.co/docs/diffusers/en/api/diffusion_pipeline#diffusers.DiffusionPipeline.from_pretrained.pretrained_model_name_or_path"),u(L,"rel","nofollow"),u(B,"id","training-with-multiple-gpus"),u(B,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(B,"href","#training-with-multiple-gpus"),u(S,"class","relative group"),u(H,"href","https://huggingface.co/docs/accelerate/basic_tutorials/launch"),u(H,"rel","nofollow")},m(_,E){h(_,p,E),a(p,g),a(p,l),a(l,$),a(p,P),a(p,I),a(I,ne),a(p,ce),h(_,me,E),h(_,T,E),a(T,G),a(T,M),a(M,C),a(T,de),a(T,L),a(L,Z),a(Z,ee),a(T,_e),h(_,V,E),y(te,_,E),h(_,ge,E),y(N,_,E),h(_,ae,E),h(_,S,E),a(S,B),a(B,z),y(W,z,null),a(S,U),a(S,ie),a(ie,A),h(_,ye,E),h(_,D,E),a(D,le),a(le,se),a(D,J),a(D,H),a(H,ke),a(D,K),a(D,F),a(F,X),a(D,pe),h(_,R,E),y(oe,_,E),Q=!0},p:Fa,i(_){Q||(b(te.$$.fragment,_),b(N.$$.fragment,_),b(W.$$.fragment,_),b(oe.$$.fragment,_),Q=!0)},o(_){k(te.$$.fragment,_),k(N.$$.fragment,_),k(W.$$.fragment,_),k(oe.$$.fragment,_),Q=!1},d(_){_&&t(p),_&&t(me),_&&t(T),_&&t(V),x(te,_),_&&t(ge),x(N,_),_&&t(ae),_&&t(S),x(W),_&&t(ye),_&&t(D),_&&t(R),x(oe,_)}}}function Qo(O){let p,g;return p=new Ca({props:{$$slots:{default:[Xo]},$$scope:{ctx:O}}}),{c(){w(p.$$.fragment)},l(l){v(p.$$.fragment,l)},m(l,$){y(p,l,$),g=!0},p(l,$){const P={};$&2&&(P.$$scope={dirty:$,ctx:l}),p.$set(P)},i(l){g||(b(p.$$.fragment,l),g=!0)},o(l){k(p.$$.fragment,l),g=!1},d(l){x(p,l)}}}function Zo(O){let p,g,l,$,P,I,ne,ce,me,T,G,M,C,de,L,Z,ee,_e,V,te,ge,N,ae,S,B,z,W,U,ie,A,ye,D,le,se,J,H,ke,K,F,X,pe,R,oe,Q,_,E,q,he,Y;return T=new ve({props:{code:"pip install -U -r requirements_flax.txt",highlighted:"pip install -U -r requirements_flax.txt"}}),U=new ve({props:{code:`export MODEL_NAME="runwayml/stable-diffusion-v1-5"
export dataset_name="lambdalabs/pokemon-blip-captions"

python train_text_to_image_flax.py \\
  --pretrained_model_name_or_path=$MODEL_NAME \\
  --dataset_name=$dataset_name \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --output_dir="sd-pokemon-model" `,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>
<span class="hljs-built_in">export</span> dataset_name=<span class="hljs-string">&quot;lambdalabs/pokemon-blip-captions&quot;</span>

python train_text_to_image_flax.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span> \\
  --dataset_name=<span class="hljs-variable">$dataset_name</span> \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --output_dir=<span class="hljs-string">&quot;sd-pokemon-model&quot;</span> `}}),he=new ve({props:{code:`export MODEL_NAME="duongna/stable-diffusion-v1-4-flax"
export TRAIN_DIR="path_to_your_dataset"

python train_text_to_image_flax.py \\
  --pretrained_model_name_or_path=$MODEL_NAME \\
  --train_data_dir=$TRAIN_DIR \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --mixed_precision="fp16" \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --output_dir="sd-pokemon-model"`,highlighted:`<span class="hljs-built_in">export</span> MODEL_NAME=<span class="hljs-string">&quot;duongna/stable-diffusion-v1-4-flax&quot;</span>
<span class="hljs-built_in">export</span> TRAIN_DIR=<span class="hljs-string">&quot;path_to_your_dataset&quot;</span>

python train_text_to_image_flax.py \\
  --pretrained_model_name_or_path=<span class="hljs-variable">$MODEL_NAME</span> \\
  --train_data_dir=<span class="hljs-variable">$TRAIN_DIR</span> \\
  --resolution=512 --center_crop --random_flip \\
  --train_batch_size=1 \\
  --mixed_precision=<span class="hljs-string">&quot;fp16&quot;</span> \\
  --max_train_steps=15000 \\
  --learning_rate=1e-05 \\
  --max_grad_norm=1 \\
  --output_dir=<span class="hljs-string">&quot;sd-pokemon-model&quot;</span>`}}),{c(){p=r("p"),g=s("With Flax, it\u2019s possible to train a Stable Diffusion model faster on TPUs and GPUs thanks to "),l=r("a"),$=s("@duongna211"),P=s(". This is very efficient on TPU hardware but works great on GPUs too. The Flax training script doesn\u2019t support features like gradient checkpointing or gradient accumulation yet, so you\u2019ll need a GPU with at least 30GB of memory or a TPU v3."),I=m(),ne=r("p"),ce=s("Before running the script, make sure you have the requirements installed:"),me=m(),w(T.$$.fragment),G=m(),M=r("p"),C=s("Specify the "),de=r("code"),L=s("MODEL_NAME"),Z=s(" environment variable (either a Hub model repository id or a path to the directory containing the model weights) and pass it to the "),ee=r("a"),_e=r("code"),V=s("pretrained_model_name_or_path"),te=s(" argument."),ge=m(),N=r("p"),ae=s("Now you can launch the "),S=r("a"),B=s("Flax training script"),z=s(" like this:"),W=m(),w(U.$$.fragment),ie=m(),A=r("p"),ye=s("To finetune on your own dataset, prepare the dataset according to the format required by \u{1F917} "),D=r("a"),le=s("Datasets"),se=s(". You can "),J=r("a"),H=s("upload your dataset to the Hub"),ke=s(", or you can "),K=r("a"),F=s("prepare a local folder with your files"),X=s("."),pe=m(),R=r("p"),oe=s("Modify the script if you want to use custom loading logic. We left pointers in the code in the appropriate places to help you. \u{1F917} The example script below shows how to finetune on a local dataset in "),Q=r("code"),_=s("TRAIN_DIR"),E=s(":"),q=m(),w(he.$$.fragment),this.h()},l(c){p=n(c,"P",{});var j=i(p);g=o(j,"With Flax, it\u2019s possible to train a Stable Diffusion model faster on TPUs and GPUs thanks to "),l=n(j,"A",{href:!0,rel:!0});var xe=i(l);$=o(xe,"@duongna211"),xe.forEach(t),P=o(j,". This is very efficient on TPU hardware but works great on GPUs too. The Flax training script doesn\u2019t support features like gradient checkpointing or gradient accumulation yet, so you\u2019ll need a GPU with at least 30GB of memory or a TPU v3."),j.forEach(t),I=d(c),ne=n(c,"P",{});var Ee=i(ne);ce=o(Ee,"Before running the script, make sure you have the requirements installed:"),Ee.forEach(t),me=d(c),v(T.$$.fragment,c),G=d(c),M=n(c,"P",{});var $e=i(M);C=o($e,"Specify the "),de=n($e,"CODE",{});var je=i(de);L=o(je,"MODEL_NAME"),je.forEach(t),Z=o($e," environment variable (either a Hub model repository id or a path to the directory containing the model weights) and pass it to the "),ee=n($e,"A",{href:!0,rel:!0});var Me=i(ee);_e=n(Me,"CODE",{});var fe=i(_e);V=o(fe,"pretrained_model_name_or_path"),fe.forEach(t),Me.forEach(t),te=o($e," argument."),$e.forEach(t),ge=d(c),N=n(c,"P",{});var ue=i(N);ae=o(ue,"Now you can launch the "),S=n(ue,"A",{href:!0,rel:!0});var Ne=i(S);B=o(Ne,"Flax training script"),Ne.forEach(t),z=o(ue," like this:"),ue.forEach(t),W=d(c),v(U.$$.fragment,c),ie=d(c),A=n(c,"P",{});var re=i(A);ye=o(re,"To finetune on your own dataset, prepare the dataset according to the format required by \u{1F917} "),D=n(re,"A",{href:!0,rel:!0});var tt=i(D);le=o(tt,"Datasets"),tt.forEach(t),se=o(re,". You can "),J=n(re,"A",{href:!0,rel:!0});var we=i(J);H=o(we,"upload your dataset to the Hub"),we.forEach(t),ke=o(re,", or you can "),K=n(re,"A",{href:!0,rel:!0});var _t=i(K);F=o(_t,"prepare a local folder with your files"),_t.forEach(t),X=o(re,"."),re.forEach(t),pe=d(c),R=n(c,"P",{});var Pe=i(R);oe=o(Pe,"Modify the script if you want to use custom loading logic. We left pointers in the code in the appropriate places to help you. \u{1F917} The example script below shows how to finetune on a local dataset in "),Q=n(Pe,"CODE",{});var gt=i(Q);_=o(gt,"TRAIN_DIR"),gt.forEach(t),E=o(Pe,":"),Pe.forEach(t),q=d(c),v(he.$$.fragment,c),this.h()},h(){u(l,"href","https://github.com/duongna21"),u(l,"rel","nofollow"),u(ee,"href","https://huggingface.co/docs/diffusers/en/api/diffusion_pipeline#diffusers.DiffusionPipeline.from_pretrained.pretrained_model_name_or_path"),u(ee,"rel","nofollow"),u(S,"href","https://github.com/huggingface/diffusers/blob/main/examples/text_to_image/train_text_to_image_flax.py"),u(S,"rel","nofollow"),u(D,"href","https://huggingface.co/docs/datasets/index"),u(D,"rel","nofollow"),u(J,"href","https://huggingface.co/docs/datasets/image_dataset#upload-dataset-to-the-hub"),u(J,"rel","nofollow"),u(K,"href","https://huggingface.co/docs/datasets/image_dataset#imagefolder"),u(K,"rel","nofollow")},m(c,j){h(c,p,j),a(p,g),a(p,l),a(l,$),a(p,P),h(c,I,j),h(c,ne,j),a(ne,ce),h(c,me,j),y(T,c,j),h(c,G,j),h(c,M,j),a(M,C),a(M,de),a(de,L),a(M,Z),a(M,ee),a(ee,_e),a(_e,V),a(M,te),h(c,ge,j),h(c,N,j),a(N,ae),a(N,S),a(S,B),a(N,z),h(c,W,j),y(U,c,j),h(c,ie,j),h(c,A,j),a(A,ye),a(A,D),a(D,le),a(A,se),a(A,J),a(J,H),a(A,ke),a(A,K),a(K,F),a(A,X),h(c,pe,j),h(c,R,j),a(R,oe),a(R,Q),a(Q,_),a(R,E),h(c,q,j),y(he,c,j),Y=!0},p:Fa,i(c){Y||(b(T.$$.fragment,c),b(U.$$.fragment,c),b(he.$$.fragment,c),Y=!0)},o(c){k(T.$$.fragment,c),k(U.$$.fragment,c),k(he.$$.fragment,c),Y=!1},d(c){c&&t(p),c&&t(I),c&&t(ne),c&&t(me),x(T,c),c&&t(G),c&&t(M),c&&t(ge),c&&t(N),c&&t(W),x(U,c),c&&t(ie),c&&t(A),c&&t(pe),c&&t(R),c&&t(q),x(he,c)}}}function er(O){let p,g;return p=new Ca({props:{$$slots:{default:[Zo]},$$scope:{ctx:O}}}),{c(){w(p.$$.fragment)},l(l){v(p.$$.fragment,l)},m(l,$){y(p,l,$),g=!0},p(l,$){const P={};$&2&&(P.$$scope={dirty:$,ctx:l}),p.$set(P)},i(l){g||(b(p.$$.fragment,l),g=!0)},o(l){k(p.$$.fragment,l),g=!1},d(l){x(p,l)}}}function tr(O){let p,g;return{c(){p=r("p"),g=s("Training with Min-SNR weighting strategy is only supported in PyTorch.")},l(l){p=n(l,"P",{});var $=i(p);g=o($,"Training with Min-SNR weighting strategy is only supported in PyTorch."),$.forEach(t)},m(l,$){h(l,p,$),a(p,g)},d(l){l&&t(p)}}}function ar(O){let p,g;return p=new ve({props:{code:`from diffusers import StableDiffusionPipeline

model_path = "path_to_saved_model"
pipe = StableDiffusionPipeline.from_pretrained(model_path, torch_dtype=torch.float16)
pipe.to("cuda")

image = pipe(prompt="yoda").images[0]
image.save("yoda-pokemon.png")`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionPipeline

model_path = <span class="hljs-string">&quot;path_to_saved_model&quot;</span>
pipe = StableDiffusionPipeline.from_pretrained(model_path, torch_dtype=torch.float16)
pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)

image = pipe(prompt=<span class="hljs-string">&quot;yoda&quot;</span>).images[<span class="hljs-number">0</span>]
image.save(<span class="hljs-string">&quot;yoda-pokemon.png&quot;</span>)`}}),{c(){w(p.$$.fragment)},l(l){v(p.$$.fragment,l)},m(l,$){y(p,l,$),g=!0},p:Fa,i(l){g||(b(p.$$.fragment,l),g=!0)},o(l){k(p.$$.fragment,l),g=!1},d(l){x(p,l)}}}function sr(O){let p,g;return p=new Ca({props:{$$slots:{default:[ar]},$$scope:{ctx:O}}}),{c(){w(p.$$.fragment)},l(l){v(p.$$.fragment,l)},m(l,$){y(p,l,$),g=!0},p(l,$){const P={};$&2&&(P.$$scope={dirty:$,ctx:l}),p.$set(P)},i(l){g||(b(p.$$.fragment,l),g=!0)},o(l){k(p.$$.fragment,l),g=!1},d(l){x(p,l)}}}function or(O){let p,g;return p=new ve({props:{code:`import jax
import numpy as np
from flax.jax_utils import replicate
from flax.training.common_utils import shard
from diffusers import FlaxStableDiffusionPipeline

model_path = "path_to_saved_model"
pipe, params = FlaxStableDiffusionPipeline.from_pretrained(model_path, dtype=jax.numpy.bfloat16)

prompt = "yoda pokemon"
prng_seed = jax.random.PRNGKey(0)
num_inference_steps = 50

num_samples = jax.device_count()
prompt = num_samples * [prompt]
prompt_ids = pipeline.prepare_inputs(prompt)

# shard inputs and rng
params = replicate(params)
prng_seed = jax.random.split(prng_seed, jax.device_count())
prompt_ids = shard(prompt_ids)

images = pipeline(prompt_ids, params, prng_seed, num_inference_steps, jit=True).images
images = pipeline.numpy_to_pil(np.asarray(images.reshape((num_samples,) + images.shape[-3:])))
image.save("yoda-pokemon.png")`,highlighted:`<span class="hljs-keyword">import</span> jax
<span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-keyword">from</span> flax.jax_utils <span class="hljs-keyword">import</span> replicate
<span class="hljs-keyword">from</span> flax.training.common_utils <span class="hljs-keyword">import</span> shard
<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> FlaxStableDiffusionPipeline

model_path = <span class="hljs-string">&quot;path_to_saved_model&quot;</span>
pipe, params = FlaxStableDiffusionPipeline.from_pretrained(model_path, dtype=jax.numpy.bfloat16)

prompt = <span class="hljs-string">&quot;yoda pokemon&quot;</span>
prng_seed = jax.random.PRNGKey(<span class="hljs-number">0</span>)
num_inference_steps = <span class="hljs-number">50</span>

num_samples = jax.device_count()
prompt = num_samples * [prompt]
prompt_ids = pipeline.prepare_inputs(prompt)

<span class="hljs-comment"># shard inputs and rng</span>
params = replicate(params)
prng_seed = jax.random.split(prng_seed, jax.device_count())
prompt_ids = shard(prompt_ids)

images = pipeline(prompt_ids, params, prng_seed, num_inference_steps, jit=<span class="hljs-literal">True</span>).images
images = pipeline.numpy_to_pil(np.asarray(images.reshape((num_samples,) + images.shape[-<span class="hljs-number">3</span>:])))
image.save(<span class="hljs-string">&quot;yoda-pokemon.png&quot;</span>)`}}),{c(){w(p.$$.fragment)},l(l){v(p.$$.fragment,l)},m(l,$){y(p,l,$),g=!0},p:Fa,i(l){g||(b(p.$$.fragment,l),g=!0)},o(l){k(p.$$.fragment,l),g=!1},d(l){x(p,l)}}}function rr(O){let p,g;return p=new Ca({props:{$$slots:{default:[or]},$$scope:{ctx:O}}}),{c(){w(p.$$.fragment)},l(l){v(p.$$.fragment,l)},m(l,$){y(p,l,$),g=!0},p(l,$){const P={};$&2&&(P.$$scope={dirty:$,ctx:l}),p.$set(P)},i(l){g||(b(p.$$.fragment,l),g=!0)},o(l){k(p.$$.fragment,l),g=!1},d(l){x(p,l)}}}function nr(O){let p,g,l,$,P,I,ne,ce,me,T,G,M,C,de,L,Z,ee,_e,V,te,ge,N,ae,S,B,z,W,U,ie,A,ye,D,le,se,J,H,ke,K,F,X,pe,R,oe,Q,_,E,q,he,Y,c,j,xe,Ee,$e,je,Me,fe,ue,Ne,re,tt,we,_t,Pe,gt,Ha,Tt,Ga,Ba,ta,$t,za,aa,Se,Ce,Dt,at,Wa,qt,Ya,sa,wt,Va,oa,st,ra,Re,He,Mt,ot,Ja,Nt,Ka,na,vt,Xa,ia,rt,la,be,Qa,St,Za,es,Rt,ts,as,Ot,ss,os,pa,Ge,rs,It,ns,is,ha,nt,fa,Oe,Be,Ut,it,ls,Lt,ps,ua,ze,ca,Ie,We,Ft,lt,hs,Ct,fs,ma,Ae,us,pt,cs,ms,Ht,ds,_s,da,Ye,gs,ht,$s,ws,_a,Te,Gt,vs,ys,ft,bs,Bt,ks,xs,Es,ut,js,zt,Ps,As,ga,yt,Ts,$a,De,Ds,Wt,qs,Ms,Yt,Ns,Ss,wa,Ve,va,Ue,Je,Vt,ct,Rs,Jt,Os,ya,Ke,Is,bt,Us,Ls,ba,Le,Xe,Kt,mt,Fs,Xt,Cs,ka,Qe,Hs,kt,Gs,Bs,xa,Ze,Ea;return I=new Fe({}),G=new Go({props:{warning:!0,$$slots:{default:[Ko]},$$scope:{ctx:O}}}),z=new ve({props:{code:`pip install git+https://github.com/huggingface/diffusers.git
pip install -U -r requirements.txt`,highlighted:`pip install git+https://github.com/huggingface/diffusers.git
pip install -U -r requirements.txt`}}),se=new ve({props:{code:"accelerate config",highlighted:"accelerate config"}}),R=new Fe({}),at=new Fe({}),st=new ve({props:{code:"  --push_to_hub",highlighted:"  --push_to_hub"}}),ot=new Fe({}),rt=new ve({props:{code:"  --checkpointing_steps=500",highlighted:"  --checkpointing_steps=500"}}),nt=new ve({props:{code:'  --resume_from_checkpoint="checkpoint-1500"',highlighted:'  --resume_from_checkpoint=<span class="hljs-string">&quot;checkpoint-1500&quot;</span>'}}),it=new Fe({}),ze=new Bo({props:{pytorch:!0,tensorflow:!1,jax:!0,$$slots:{jax:[er],pytorch:[Qo]},$$scope:{ctx:O}}}),lt=new Fe({}),Ve=new Go({props:{warning:!0,$$slots:{default:[tr]},$$scope:{ctx:O}}}),ct=new Fe({}),mt=new Fe({}),Ze=new Bo({props:{pytorch:!0,tensorflow:!1,jax:!0,$$slots:{jax:[rr],pytorch:[sr]},$$scope:{ctx:O}}}),{c(){p=r("meta"),g=m(),l=r("h1"),$=r("a"),P=r("span"),w(I.$$.fragment),ne=m(),ce=r("span"),me=s("Text-to-image"),T=m(),w(G.$$.fragment),M=m(),C=r("p"),de=s("Text-to-image models like Stable Diffusion generate an image from a text prompt. This guide will show you how to finetune the "),L=r("a"),Z=r("code"),ee=s("CompVis/stable-diffusion-v1-4"),_e=s(" model on your own dataset with PyTorch and Flax. All the training scripts for text-to-image finetuning used in this guide can be found in this "),V=r("a"),te=s("repository"),ge=s(" if you\u2019re interested in taking a closer look."),N=m(),ae=r("p"),S=s("Before running the scripts, make sure to install the library\u2019s training dependencies:"),B=m(),w(z.$$.fragment),W=m(),U=r("p"),ie=s("And initialize an "),A=r("a"),ye=s("\u{1F917} Accelerate"),D=s(" environment with:"),le=m(),w(se.$$.fragment),J=m(),H=r("p"),ke=s("If you have already cloned the repo, then you won\u2019t need to go through these steps. Instead, you can pass the path to your local checkout to the training script and it will be loaded from there."),K=m(),F=r("h2"),X=r("a"),pe=r("span"),w(R.$$.fragment),oe=m(),Q=r("span"),_=s("Hardware requirements"),E=m(),q=r("p"),he=s("Using "),Y=r("code"),c=s("gradient_checkpointing"),j=s(" and "),xe=r("code"),Ee=s("mixed_precision"),$e=s(", it should be possible to finetune the model on a single 24GB GPU. For higher "),je=r("code"),Me=s("batch_size"),fe=s("\u2019s and faster training, it\u2019s better to use GPUs with more than 30GB of GPU memory. You can also use JAX/Flax for fine-tuning on TPUs or GPUs, which will be covered "),ue=r("a"),Ne=s("below"),re=s("."),tt=m(),we=r("p"),_t=s("You can reduce your memory footprint even more by enabling memory efficient attention with xFormers. Make sure you have "),Pe=r("a"),gt=s("xFormers installed"),Ha=s(" and pass the "),Tt=r("code"),Ga=s("--enable_xformers_memory_efficient_attention"),Ba=s(" flag to the training script."),ta=m(),$t=r("p"),za=s("xFormers is not available for Flax."),aa=m(),Se=r("h2"),Ce=r("a"),Dt=r("span"),w(at.$$.fragment),Wa=m(),qt=r("span"),Ya=s("Upload model to Hub"),sa=m(),wt=r("p"),Va=s("Store your model on the Hub by adding the following argument to the training script:"),oa=m(),w(st.$$.fragment),ra=m(),Re=r("h2"),He=r("a"),Mt=r("span"),w(ot.$$.fragment),Ja=m(),Nt=r("span"),Ka=s("Save and load checkpoints"),na=m(),vt=r("p"),Xa=s("It is a good idea to regularly save checkpoints in case anything happens during training. To save a checkpoint, pass the following argument to the training script:"),ia=m(),w(rt.$$.fragment),la=m(),be=r("p"),Qa=s("Every 500 steps, the full training state is saved in a subfolder in the "),St=r("code"),Za=s("output_dir"),es=s(". The checkpoint has the format "),Rt=r("code"),ts=s("checkpoint-"),as=s(" followed by the number of steps trained so far. For example, "),Ot=r("code"),ss=s("checkpoint-1500"),os=s(" is a checkpoint saved after 1500 training steps."),pa=m(),Ge=r("p"),rs=s("To load a checkpoint to resume training, pass the argument "),It=r("code"),ns=s("--resume_from_checkpoint"),is=s(" to the training script and specify the checkpoint you want to resume from. For example, the following argument resumes training from the checkpoint saved after 1500 training steps:"),ha=m(),w(nt.$$.fragment),fa=m(),Oe=r("h2"),Be=r("a"),Ut=r("span"),w(it.$$.fragment),ls=m(),Lt=r("span"),ps=s("Fine-tuning"),ua=m(),w(ze.$$.fragment),ca=m(),Ie=r("h2"),We=r("a"),Ft=r("span"),w(lt.$$.fragment),hs=m(),Ct=r("span"),fs=s("Training with Min-SNR weighting"),ma=m(),Ae=r("p"),us=s("We support training with the Min-SNR weighting strategy proposed in "),pt=r("a"),cs=s("Efficient Diffusion Training via Min-SNR Weighting Strategy"),ms=s(` which helps to achieve faster convergence
by rebalancing the loss. In order to use it, one needs to set the `),Ht=r("code"),ds=s("--snr_gamma"),_s=s(` argument. The recommended
value when using it is 5.0.`),da=m(),Ye=r("p"),gs=s("You can find "),ht=r("a"),$s=s("this project on Weights and Biases"),ws=s(" that compares the loss surfaces of the following setups:"),_a=m(),Te=r("ul"),Gt=r("li"),vs=s("Training without the Min-SNR weighting strategy"),ys=m(),ft=r("li"),bs=s("Training with the Min-SNR weighting strategy ("),Bt=r("code"),ks=s("snr_gamma"),xs=s(" set to 5.0)"),Es=m(),ut=r("li"),js=s("Training with the Min-SNR weighting strategy ("),zt=r("code"),Ps=s("snr_gamma"),As=s(" set to 1.0)"),ga=m(),yt=r("p"),Ts=s("For our small Pokemons dataset, the effects of Min-SNR weighting strategy might not appear to be pronounced, but for larger datasets, we believe the effects will be more pronounced."),$a=m(),De=r("p"),Ds=s("Also, note that in this example, we either predict "),Wt=r("code"),qs=s("epsilon"),Ms=s(" (i.e., the noise) or the "),Yt=r("code"),Ns=s("v_prediction"),Ss=s(". For both of these cases, the formulation of the Min-SNR weighting strategy that we have used holds."),wa=m(),w(Ve.$$.fragment),va=m(),Ue=r("h2"),Je=r("a"),Vt=r("span"),w(ct.$$.fragment),Rs=m(),Jt=r("span"),Os=s("LoRA"),ya=m(),Ke=r("p"),Is=s("You can also use Low-Rank Adaptation of Large Language Models (LoRA), a fine-tuning technique for accelerating training large models, for fine-tuning text-to-image models. For more details, take a look at the "),bt=r("a"),Us=s("LoRA training"),Ls=s(" guide."),ba=m(),Le=r("h2"),Xe=r("a"),Kt=r("span"),w(mt.$$.fragment),Fs=m(),Xt=r("span"),Cs=s("Inference"),ka=m(),Qe=r("p"),Hs=s("Now you can load the fine-tuned model for inference by passing the model path or model name on the Hub to the "),kt=r("a"),Gs=s("StableDiffusionPipeline"),Bs=s(":"),xa=m(),w(Ze.$$.fragment),this.h()},l(e){const f=Vo('[data-svelte="svelte-1phssyn"]',document.head);p=n(f,"META",{name:!0,content:!0}),f.forEach(t),g=d(e),l=n(e,"H1",{class:!0});var dt=i(l);$=n(dt,"A",{id:!0,class:!0,href:!0});var Qt=i($);P=n(Qt,"SPAN",{});var Zt=i(P);v(I.$$.fragment,Zt),Zt.forEach(t),Qt.forEach(t),ne=d(dt),ce=n(dt,"SPAN",{});var ea=i(ce);me=o(ea,"Text-to-image"),ea.forEach(t),dt.forEach(t),T=d(e),v(G.$$.fragment,e),M=d(e),C=n(e,"P",{});var xt=i(C);de=o(xt,"Text-to-image models like Stable Diffusion generate an image from a text prompt. This guide will show you how to finetune the "),L=n(xt,"A",{href:!0,rel:!0});var zs=i(L);Z=n(zs,"CODE",{});var Ws=i(Z);ee=o(Ws,"CompVis/stable-diffusion-v1-4"),Ws.forEach(t),zs.forEach(t),_e=o(xt," model on your own dataset with PyTorch and Flax. All the training scripts for text-to-image finetuning used in this guide can be found in this "),V=n(xt,"A",{href:!0,rel:!0});var Ys=i(V);te=o(Ys,"repository"),Ys.forEach(t),ge=o(xt," if you\u2019re interested in taking a closer look."),xt.forEach(t),N=d(e),ae=n(e,"P",{});var Vs=i(ae);S=o(Vs,"Before running the scripts, make sure to install the library\u2019s training dependencies:"),Vs.forEach(t),B=d(e),v(z.$$.fragment,e),W=d(e),U=n(e,"P",{});var ja=i(U);ie=o(ja,"And initialize an "),A=n(ja,"A",{href:!0,rel:!0});var Js=i(A);ye=o(Js,"\u{1F917} Accelerate"),Js.forEach(t),D=o(ja," environment with:"),ja.forEach(t),le=d(e),v(se.$$.fragment,e),J=d(e),H=n(e,"P",{});var Ks=i(H);ke=o(Ks,"If you have already cloned the repo, then you won\u2019t need to go through these steps. Instead, you can pass the path to your local checkout to the training script and it will be loaded from there."),Ks.forEach(t),K=d(e),F=n(e,"H2",{class:!0});var Pa=i(F);X=n(Pa,"A",{id:!0,class:!0,href:!0});var Xs=i(X);pe=n(Xs,"SPAN",{});var Qs=i(pe);v(R.$$.fragment,Qs),Qs.forEach(t),Xs.forEach(t),oe=d(Pa),Q=n(Pa,"SPAN",{});var Zs=i(Q);_=o(Zs,"Hardware requirements"),Zs.forEach(t),Pa.forEach(t),E=d(e),q=n(e,"P",{});var qe=i(q);he=o(qe,"Using "),Y=n(qe,"CODE",{});var eo=i(Y);c=o(eo,"gradient_checkpointing"),eo.forEach(t),j=o(qe," and "),xe=n(qe,"CODE",{});var to=i(xe);Ee=o(to,"mixed_precision"),to.forEach(t),$e=o(qe,", it should be possible to finetune the model on a single 24GB GPU. For higher "),je=n(qe,"CODE",{});var ao=i(je);Me=o(ao,"batch_size"),ao.forEach(t),fe=o(qe,"\u2019s and faster training, it\u2019s better to use GPUs with more than 30GB of GPU memory. You can also use JAX/Flax for fine-tuning on TPUs or GPUs, which will be covered "),ue=n(qe,"A",{href:!0});var so=i(ue);Ne=o(so,"below"),so.forEach(t),re=o(qe,"."),qe.forEach(t),tt=d(e),we=n(e,"P",{});var Et=i(we);_t=o(Et,"You can reduce your memory footprint even more by enabling memory efficient attention with xFormers. Make sure you have "),Pe=n(Et,"A",{href:!0});var oo=i(Pe);gt=o(oo,"xFormers installed"),oo.forEach(t),Ha=o(Et," and pass the "),Tt=n(Et,"CODE",{});var ro=i(Tt);Ga=o(ro,"--enable_xformers_memory_efficient_attention"),ro.forEach(t),Ba=o(Et," flag to the training script."),Et.forEach(t),ta=d(e),$t=n(e,"P",{});var no=i($t);za=o(no,"xFormers is not available for Flax."),no.forEach(t),aa=d(e),Se=n(e,"H2",{class:!0});var Aa=i(Se);Ce=n(Aa,"A",{id:!0,class:!0,href:!0});var io=i(Ce);Dt=n(io,"SPAN",{});var lo=i(Dt);v(at.$$.fragment,lo),lo.forEach(t),io.forEach(t),Wa=d(Aa),qt=n(Aa,"SPAN",{});var po=i(qt);Ya=o(po,"Upload model to Hub"),po.forEach(t),Aa.forEach(t),sa=d(e),wt=n(e,"P",{});var ho=i(wt);Va=o(ho,"Store your model on the Hub by adding the following argument to the training script:"),ho.forEach(t),oa=d(e),v(st.$$.fragment,e),ra=d(e),Re=n(e,"H2",{class:!0});var Ta=i(Re);He=n(Ta,"A",{id:!0,class:!0,href:!0});var fo=i(He);Mt=n(fo,"SPAN",{});var uo=i(Mt);v(ot.$$.fragment,uo),uo.forEach(t),fo.forEach(t),Ja=d(Ta),Nt=n(Ta,"SPAN",{});var co=i(Nt);Ka=o(co,"Save and load checkpoints"),co.forEach(t),Ta.forEach(t),na=d(e),vt=n(e,"P",{});var mo=i(vt);Xa=o(mo,"It is a good idea to regularly save checkpoints in case anything happens during training. To save a checkpoint, pass the following argument to the training script:"),mo.forEach(t),ia=d(e),v(rt.$$.fragment,e),la=d(e),be=n(e,"P",{});var et=i(be);Qa=o(et,"Every 500 steps, the full training state is saved in a subfolder in the "),St=n(et,"CODE",{});var _o=i(St);Za=o(_o,"output_dir"),_o.forEach(t),es=o(et,". The checkpoint has the format "),Rt=n(et,"CODE",{});var go=i(Rt);ts=o(go,"checkpoint-"),go.forEach(t),as=o(et," followed by the number of steps trained so far. For example, "),Ot=n(et,"CODE",{});var $o=i(Ot);ss=o($o,"checkpoint-1500"),$o.forEach(t),os=o(et," is a checkpoint saved after 1500 training steps."),et.forEach(t),pa=d(e),Ge=n(e,"P",{});var Da=i(Ge);rs=o(Da,"To load a checkpoint to resume training, pass the argument "),It=n(Da,"CODE",{});var wo=i(It);ns=o(wo,"--resume_from_checkpoint"),wo.forEach(t),is=o(Da," to the training script and specify the checkpoint you want to resume from. For example, the following argument resumes training from the checkpoint saved after 1500 training steps:"),Da.forEach(t),ha=d(e),v(nt.$$.fragment,e),fa=d(e),Oe=n(e,"H2",{class:!0});var qa=i(Oe);Be=n(qa,"A",{id:!0,class:!0,href:!0});var vo=i(Be);Ut=n(vo,"SPAN",{});var yo=i(Ut);v(it.$$.fragment,yo),yo.forEach(t),vo.forEach(t),ls=d(qa),Lt=n(qa,"SPAN",{});var bo=i(Lt);ps=o(bo,"Fine-tuning"),bo.forEach(t),qa.forEach(t),ua=d(e),v(ze.$$.fragment,e),ca=d(e),Ie=n(e,"H2",{class:!0});var Ma=i(Ie);We=n(Ma,"A",{id:!0,class:!0,href:!0});var ko=i(We);Ft=n(ko,"SPAN",{});var xo=i(Ft);v(lt.$$.fragment,xo),xo.forEach(t),ko.forEach(t),hs=d(Ma),Ct=n(Ma,"SPAN",{});var Eo=i(Ct);fs=o(Eo,"Training with Min-SNR weighting"),Eo.forEach(t),Ma.forEach(t),ma=d(e),Ae=n(e,"P",{});var jt=i(Ae);us=o(jt,"We support training with the Min-SNR weighting strategy proposed in "),pt=n(jt,"A",{href:!0,rel:!0});var jo=i(pt);cs=o(jo,"Efficient Diffusion Training via Min-SNR Weighting Strategy"),jo.forEach(t),ms=o(jt,` which helps to achieve faster convergence
by rebalancing the loss. In order to use it, one needs to set the `),Ht=n(jt,"CODE",{});var Po=i(Ht);ds=o(Po,"--snr_gamma"),Po.forEach(t),_s=o(jt,` argument. The recommended
value when using it is 5.0.`),jt.forEach(t),da=d(e),Ye=n(e,"P",{});var Na=i(Ye);gs=o(Na,"You can find "),ht=n(Na,"A",{href:!0,rel:!0});var Ao=i(ht);$s=o(Ao,"this project on Weights and Biases"),Ao.forEach(t),ws=o(Na," that compares the loss surfaces of the following setups:"),Na.forEach(t),_a=d(e),Te=n(e,"UL",{});var Pt=i(Te);Gt=n(Pt,"LI",{});var To=i(Gt);vs=o(To,"Training without the Min-SNR weighting strategy"),To.forEach(t),ys=d(Pt),ft=n(Pt,"LI",{});var Sa=i(ft);bs=o(Sa,"Training with the Min-SNR weighting strategy ("),Bt=n(Sa,"CODE",{});var Do=i(Bt);ks=o(Do,"snr_gamma"),Do.forEach(t),xs=o(Sa," set to 5.0)"),Sa.forEach(t),Es=d(Pt),ut=n(Pt,"LI",{});var Ra=i(ut);js=o(Ra,"Training with the Min-SNR weighting strategy ("),zt=n(Ra,"CODE",{});var qo=i(zt);Ps=o(qo,"snr_gamma"),qo.forEach(t),As=o(Ra," set to 1.0)"),Ra.forEach(t),Pt.forEach(t),ga=d(e),yt=n(e,"P",{});var Mo=i(yt);Ts=o(Mo,"For our small Pokemons dataset, the effects of Min-SNR weighting strategy might not appear to be pronounced, but for larger datasets, we believe the effects will be more pronounced."),Mo.forEach(t),$a=d(e),De=n(e,"P",{});var At=i(De);Ds=o(At,"Also, note that in this example, we either predict "),Wt=n(At,"CODE",{});var No=i(Wt);qs=o(No,"epsilon"),No.forEach(t),Ms=o(At," (i.e., the noise) or the "),Yt=n(At,"CODE",{});var So=i(Yt);Ns=o(So,"v_prediction"),So.forEach(t),Ss=o(At,". For both of these cases, the formulation of the Min-SNR weighting strategy that we have used holds."),At.forEach(t),wa=d(e),v(Ve.$$.fragment,e),va=d(e),Ue=n(e,"H2",{class:!0});var Oa=i(Ue);Je=n(Oa,"A",{id:!0,class:!0,href:!0});var Ro=i(Je);Vt=n(Ro,"SPAN",{});var Oo=i(Vt);v(ct.$$.fragment,Oo),Oo.forEach(t),Ro.forEach(t),Rs=d(Oa),Jt=n(Oa,"SPAN",{});var Io=i(Jt);Os=o(Io,"LoRA"),Io.forEach(t),Oa.forEach(t),ya=d(e),Ke=n(e,"P",{});var Ia=i(Ke);Is=o(Ia,"You can also use Low-Rank Adaptation of Large Language Models (LoRA), a fine-tuning technique for accelerating training large models, for fine-tuning text-to-image models. For more details, take a look at the "),bt=n(Ia,"A",{href:!0});var Uo=i(bt);Us=o(Uo,"LoRA training"),Uo.forEach(t),Ls=o(Ia," guide."),Ia.forEach(t),ba=d(e),Le=n(e,"H2",{class:!0});var Ua=i(Le);Xe=n(Ua,"A",{id:!0,class:!0,href:!0});var Lo=i(Xe);Kt=n(Lo,"SPAN",{});var Fo=i(Kt);v(mt.$$.fragment,Fo),Fo.forEach(t),Lo.forEach(t),Fs=d(Ua),Xt=n(Ua,"SPAN",{});var Co=i(Xt);Cs=o(Co,"Inference"),Co.forEach(t),Ua.forEach(t),ka=d(e),Qe=n(e,"P",{});var La=i(Qe);Hs=o(La,"Now you can load the fine-tuned model for inference by passing the model path or model name on the Hub to the "),kt=n(La,"A",{href:!0});var Ho=i(kt);Gs=o(Ho,"StableDiffusionPipeline"),Ho.forEach(t),Bs=o(La,":"),La.forEach(t),xa=d(e),v(Ze.$$.fragment,e),this.h()},h(){u(p,"name","hf:doc:metadata"),u(p,"content",JSON.stringify(ir)),u($,"id","texttoimage"),u($,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u($,"href","#texttoimage"),u(l,"class","relative group"),u(L,"href","https://huggingface.co/CompVis/stable-diffusion-v1-4"),u(L,"rel","nofollow"),u(V,"href","https://github.com/huggingface/diffusers/tree/main/examples/text_to_image"),u(V,"rel","nofollow"),u(A,"href","https://github.com/huggingface/accelerate/"),u(A,"rel","nofollow"),u(X,"id","hardware-requirements"),u(X,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(X,"href","#hardware-requirements"),u(F,"class","relative group"),u(ue,"href","#flax-jax-finetuning"),u(Pe,"href","./optimization/xformers"),u(Ce,"id","upload-model-to-hub"),u(Ce,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(Ce,"href","#upload-model-to-hub"),u(Se,"class","relative group"),u(He,"id","save-and-load-checkpoints"),u(He,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(He,"href","#save-and-load-checkpoints"),u(Re,"class","relative group"),u(Be,"id","finetuning"),u(Be,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(Be,"href","#finetuning"),u(Oe,"class","relative group"),u(We,"id","training-with-minsnr-weighting"),u(We,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(We,"href","#training-with-minsnr-weighting"),u(Ie,"class","relative group"),u(pt,"href","https://arxiv.org/abs/2303.09556"),u(pt,"rel","nofollow"),u(ht,"href","https://wandb.ai/sayakpaul/text2image-finetune-minsnr"),u(ht,"rel","nofollow"),u(Je,"id","lora"),u(Je,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(Je,"href","#lora"),u(Ue,"class","relative group"),u(bt,"href","lora#text-to-image"),u(Xe,"id","inference"),u(Xe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),u(Xe,"href","#inference"),u(Le,"class","relative group"),u(kt,"href","/docs/diffusers/pr_185/en/api/pipelines/stable_diffusion/text2img#diffusers.StableDiffusionPipeline")},m(e,f){a(document.head,p),h(e,g,f),h(e,l,f),a(l,$),a($,P),y(I,P,null),a(l,ne),a(l,ce),a(ce,me),h(e,T,f),y(G,e,f),h(e,M,f),h(e,C,f),a(C,de),a(C,L),a(L,Z),a(Z,ee),a(C,_e),a(C,V),a(V,te),a(C,ge),h(e,N,f),h(e,ae,f),a(ae,S),h(e,B,f),y(z,e,f),h(e,W,f),h(e,U,f),a(U,ie),a(U,A),a(A,ye),a(U,D),h(e,le,f),y(se,e,f),h(e,J,f),h(e,H,f),a(H,ke),h(e,K,f),h(e,F,f),a(F,X),a(X,pe),y(R,pe,null),a(F,oe),a(F,Q),a(Q,_),h(e,E,f),h(e,q,f),a(q,he),a(q,Y),a(Y,c),a(q,j),a(q,xe),a(xe,Ee),a(q,$e),a(q,je),a(je,Me),a(q,fe),a(q,ue),a(ue,Ne),a(q,re),h(e,tt,f),h(e,we,f),a(we,_t),a(we,Pe),a(Pe,gt),a(we,Ha),a(we,Tt),a(Tt,Ga),a(we,Ba),h(e,ta,f),h(e,$t,f),a($t,za),h(e,aa,f),h(e,Se,f),a(Se,Ce),a(Ce,Dt),y(at,Dt,null),a(Se,Wa),a(Se,qt),a(qt,Ya),h(e,sa,f),h(e,wt,f),a(wt,Va),h(e,oa,f),y(st,e,f),h(e,ra,f),h(e,Re,f),a(Re,He),a(He,Mt),y(ot,Mt,null),a(Re,Ja),a(Re,Nt),a(Nt,Ka),h(e,na,f),h(e,vt,f),a(vt,Xa),h(e,ia,f),y(rt,e,f),h(e,la,f),h(e,be,f),a(be,Qa),a(be,St),a(St,Za),a(be,es),a(be,Rt),a(Rt,ts),a(be,as),a(be,Ot),a(Ot,ss),a(be,os),h(e,pa,f),h(e,Ge,f),a(Ge,rs),a(Ge,It),a(It,ns),a(Ge,is),h(e,ha,f),y(nt,e,f),h(e,fa,f),h(e,Oe,f),a(Oe,Be),a(Be,Ut),y(it,Ut,null),a(Oe,ls),a(Oe,Lt),a(Lt,ps),h(e,ua,f),y(ze,e,f),h(e,ca,f),h(e,Ie,f),a(Ie,We),a(We,Ft),y(lt,Ft,null),a(Ie,hs),a(Ie,Ct),a(Ct,fs),h(e,ma,f),h(e,Ae,f),a(Ae,us),a(Ae,pt),a(pt,cs),a(Ae,ms),a(Ae,Ht),a(Ht,ds),a(Ae,_s),h(e,da,f),h(e,Ye,f),a(Ye,gs),a(Ye,ht),a(ht,$s),a(Ye,ws),h(e,_a,f),h(e,Te,f),a(Te,Gt),a(Gt,vs),a(Te,ys),a(Te,ft),a(ft,bs),a(ft,Bt),a(Bt,ks),a(ft,xs),a(Te,Es),a(Te,ut),a(ut,js),a(ut,zt),a(zt,Ps),a(ut,As),h(e,ga,f),h(e,yt,f),a(yt,Ts),h(e,$a,f),h(e,De,f),a(De,Ds),a(De,Wt),a(Wt,qs),a(De,Ms),a(De,Yt),a(Yt,Ns),a(De,Ss),h(e,wa,f),y(Ve,e,f),h(e,va,f),h(e,Ue,f),a(Ue,Je),a(Je,Vt),y(ct,Vt,null),a(Ue,Rs),a(Ue,Jt),a(Jt,Os),h(e,ya,f),h(e,Ke,f),a(Ke,Is),a(Ke,bt),a(bt,Us),a(Ke,Ls),h(e,ba,f),h(e,Le,f),a(Le,Xe),a(Xe,Kt),y(mt,Kt,null),a(Le,Fs),a(Le,Xt),a(Xt,Cs),h(e,ka,f),h(e,Qe,f),a(Qe,Hs),a(Qe,kt),a(kt,Gs),a(Qe,Bs),h(e,xa,f),y(Ze,e,f),Ea=!0},p(e,[f]){const dt={};f&2&&(dt.$$scope={dirty:f,ctx:e}),G.$set(dt);const Qt={};f&2&&(Qt.$$scope={dirty:f,ctx:e}),ze.$set(Qt);const Zt={};f&2&&(Zt.$$scope={dirty:f,ctx:e}),Ve.$set(Zt);const ea={};f&2&&(ea.$$scope={dirty:f,ctx:e}),Ze.$set(ea)},i(e){Ea||(b(I.$$.fragment,e),b(G.$$.fragment,e),b(z.$$.fragment,e),b(se.$$.fragment,e),b(R.$$.fragment,e),b(at.$$.fragment,e),b(st.$$.fragment,e),b(ot.$$.fragment,e),b(rt.$$.fragment,e),b(nt.$$.fragment,e),b(it.$$.fragment,e),b(ze.$$.fragment,e),b(lt.$$.fragment,e),b(Ve.$$.fragment,e),b(ct.$$.fragment,e),b(mt.$$.fragment,e),b(Ze.$$.fragment,e),Ea=!0)},o(e){k(I.$$.fragment,e),k(G.$$.fragment,e),k(z.$$.fragment,e),k(se.$$.fragment,e),k(R.$$.fragment,e),k(at.$$.fragment,e),k(st.$$.fragment,e),k(ot.$$.fragment,e),k(rt.$$.fragment,e),k(nt.$$.fragment,e),k(it.$$.fragment,e),k(ze.$$.fragment,e),k(lt.$$.fragment,e),k(Ve.$$.fragment,e),k(ct.$$.fragment,e),k(mt.$$.fragment,e),k(Ze.$$.fragment,e),Ea=!1},d(e){t(p),e&&t(g),e&&t(l),x(I),e&&t(T),x(G,e),e&&t(M),e&&t(C),e&&t(N),e&&t(ae),e&&t(B),x(z,e),e&&t(W),e&&t(U),e&&t(le),x(se,e),e&&t(J),e&&t(H),e&&t(K),e&&t(F),x(R),e&&t(E),e&&t(q),e&&t(tt),e&&t(we),e&&t(ta),e&&t($t),e&&t(aa),e&&t(Se),x(at),e&&t(sa),e&&t(wt),e&&t(oa),x(st,e),e&&t(ra),e&&t(Re),x(ot),e&&t(na),e&&t(vt),e&&t(ia),x(rt,e),e&&t(la),e&&t(be),e&&t(pa),e&&t(Ge),e&&t(ha),x(nt,e),e&&t(fa),e&&t(Oe),x(it),e&&t(ua),x(ze,e),e&&t(ca),e&&t(Ie),x(lt),e&&t(ma),e&&t(Ae),e&&t(da),e&&t(Ye),e&&t(_a),e&&t(Te),e&&t(ga),e&&t(yt),e&&t($a),e&&t(De),e&&t(wa),x(Ve,e),e&&t(va),e&&t(Ue),x(ct),e&&t(ya),e&&t(Ke),e&&t(ba),e&&t(Le),x(mt),e&&t(ka),e&&t(Qe),e&&t(xa),x(Ze,e)}}}const ir={local:"texttoimage",sections:[{local:"hardware-requirements",title:"Hardware requirements"},{local:"upload-model-to-hub",title:"Upload model to Hub"},{local:"save-and-load-checkpoints",title:"Save and load checkpoints"},{local:"finetuning",sections:[{local:"training-with-multiple-gpus",title:"Training with multiple GPUs"}],title:"Fine-tuning"},{local:"training-with-minsnr-weighting",title:"Training with Min-SNR weighting"},{local:"lora",title:"LoRA"},{local:"inference",title:"Inference"}],title:"Text-to-image"};function lr(O){return Jo(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class mr extends zo{constructor(p){super();Wo(this,p,lr,nr,Yo,{})}}export{mr as default,ir as metadata};
